//---------------------------------------------------------------------------
//
//	GfBO
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "ending.h"
#include "prime4.h"
#include "graph.h"
#include "event_grp.h"
#include "script.h"
#include "item.h"
#include "schedule.h"
#include "sound_data.h"
#include "def/ending_def.h"
#include "def/af_def.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define ENDING_MODE_STAFF_INIT			0
#define ENDING_MODE_STAFF_MAIN			1
#define ENDING_MODE_AFTER_INIT			2
#define ENDING_MODE_AFTER_WAIT			3
#define ENDING_MODE_AFTER_MAIN			4

#define ENDING_BATTLE_NONE				0
#define ENDING_BATTLE_LOOK				1
#define ENDING_BATTLE_FIGHT				2

#define epPRIm			1000+pPRIDE
#define epMORm			1000+pMORAL
#define epMIRm			1000+pMIRYOKU

#define NUM_ENDING		37
#define NUM_ED_PARAM	18

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_end_fade;
static u8
	g_step,
	g_staff_step,
	g_staff_scr_u,
	g_staff_scr_d,
	g_battle_info,
	g_battle_char;
static s16
	g_staff_wait,
	g_staff_scroll_u,
	g_staff_scroll_d,
	g_staff_bgm_count;
static void
	*g_my_cha_buf,
	*g_my_mag_buf,
	*g_en_cha_buf,
	*g_en_mag_buf;


static u16
	EndNum;

static s16
	endingParamTbl[NUM_ED_PARAM] = 
	{
		pTAIRYOKU,
		pCHIRYOKU,
		pMIRYOKU,
		pPRIDE,
		pMORAL,
		pKIHINN,
		pKANNJYU,
		pKIDATE,
		pCHIMEI,
		pBUJYUTU,
		pMAJYUTU,
		pMAZOKU,
		pINGOU,
		pFA,
		pPR,
		pDP,
		pDY,
		pCU
	},
	endingTbl[NUM_ENDING * NUM_ED_PARAM] = 
	{
	//-----------------------------------------------------------------------------------------------------------------------
	//          m             v           i           C      m                     V   p    h   L 
	//-----------------------------------------------------------------------------------------------------------------------
		 500,    600,      0,     420,    520,   350,    400,     0,    480,   400,  500,    0,   0,   0,   0,   0,   0,   0,	//  0 ^lԊE̗E
		   0,    450,    500,     450,    500,   700,      0,   430,    500,     0,    0,  -99,   0,   0,  75,   0,   0,   0,	//  1 vZX
		 600,    500,      0,     420,    520,   350,      0,     0,    480,   700,  600,  -99,   0,   0,   0,   0,   0,   0,	//  2 lԊE̗E
		   0,    480,    600,     500,    500,   720,      0,     0,    720,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	//  3 
		 420,    480,    500,     500,      0,     0,    400,     0,      0,   500,  600,  150,   0,   0,   0,   0,   0,   0,	//  4 
		 300,    620,      0,     500,    500,   500,      0,     0,    500,     0,  700,  -99,   0,   0,   0,   0,   0,   0,	//  5 {pt
		   0,    420,    500,       0,   -350,   440,    460,   470,      0,     0,    0,  -99,   0, 300,   0,   0,   0,   0,	//  6 ƌ
		 600,    300,      0,     400,    500,     0,      0,     0,    500,   700,    0,  -99, -99,   0,   0,   0,   0,   0,	//  7 [[
		 600,    500,      0,     400,    400,     0,      0,     0,    500,   700,    0,  -99, -99,   0,   0,   0,   0,   0,	//  8 R
		   0,    450,    380,     200,    120,   480,    390,   380,      0,     0,    0,  150,   0,   0,   0,  75,   0,   0,	//  9 ẼvZX
		   0,    480,    200,     300,    750,   300,      0,     0,    480,     0,    0,  -99,  -1,   0,   0,   0,   0,   0,	// 10 i
		   0,    420,    500,       0,    430,   680,      0,   400,    400,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 11 ݕvl
		   0,    600,    350,     400,    350,     0,    300,     0,    450,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 12 b
		 400,      0,    450,     300,      0,     0,    400,     0,      0,   420,    0,    0,   0,   0,   0,   0,  75,   0,	// 13 hS[Xƌ
		 400,    300,      0,     300,    -99,     0,      0,     0,      0,   450,    0,  -99, 200, -49,   0,   0,   0,   0,	// 14 ÍX̃{X
		   0,      0,    480,  epMORm,   -299,   350,      0,     0,    400,     0,    0,  -99,   0,-124,   0,   0,   0,   0,	// 15 ̒P
		   0,    520, epPRIm,     500,    490,     0, epPRIm,     0,    300,     0,    0,  -99,-150,   0,   0,   0,   0,   0,	// 16 i@
		   0,    500,      0,     300,    100,     0,      0,     0,    300,     0,  650,  -99,   0,   0,   0,   0,   0,   0,	// 17 J
		   0,    500,      0,     300,    100,     0,      0,     0,    300,     0,  650,  -99,   0,   0,   0,   0,   0,   0,	// 18 m
		   0,      0,      0,     300,      0,     0,    500,   500,      0,     0,    0,  -99,   0,   0,   0,   0,   0, 250,	// 19 L[uƌ
		   0,      0,    400,     400,      0,   600,      0,   200,    300,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 20 NX`[i
		   0,      0,    300,     400,      0,   600,      0,   200,    300,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 21 Mwl
		   0,    490,      0,     480,    300,     0, epPRIm,     0,    300,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 22 
		   0,    300,    600,       0,      0,     0,      0,   400,    300,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 23 xwl
		   0,    300,    450,       0,   -190,   300,      0,     0,    200,     0,    0,  -99,  40,-150,   0,   0,   0,   0,	// 24 `Cj[YI[Nƌ
		   0,    500,      0,     450,      0,     0,    750,     0,    500,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 25 }[
		   0,    500,      0,     450,      0,     0,    750,     0,    500,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 26 |pƁiƁj
		 200,      0,    600,  epMIRm,      0,     0,    300,     0,    300,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 27 ̕PiX^[j
		   0,    300,    200,       0,    400,     0,      0,     0,    100,     0,    0,  -99, -50,   0,   0,   0,   0,   0,	// 28 VX^[
		   0,    400,    250,       0,    -99,     0,      0,     0,      0,     0,    0,  -99, 260, -75,   0,   0,   0,   0,	// 29 \t
		 300,      0,      0,     100,      0,     0,      0,     0,      0,   350,    0,  -99,   0,   0,   0,   0,   0,   0,	// 30 m
		   0,    300,      0,       0,      0,     0,    300,     0,      0,     0,  350,  -99,   0,   0,   0,   0,   0,   0,	// 31 肢t
		   0,      0,    400,       0, epMIRm,     0,      0,   100,      0,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 32 Ch̓X
		   0,      0,    300,     200,   -200,   350,      0,     0,      0,     0,    0,  -99,  50, -99,   0,   0,   0,   0,	// 33 ̏
		   0,      0,    200,       0,      0,     0,      0,   400,      0,     0,    0,  -99,   0,   0,   0,   0,   0,   0,	// 34 ʏ̌
		   0,      0,      0,       0,      0,     0,      0,     0,      0,     0,    0,   90,   0,-299,   0,   0,   0,   0,	// 35 EɋA
		   0,      0,      0,       0,      0,     0,      0,     0,      0,     0,    0,    0,   0,   0,   0,   0,   0,   0 	// 36 t[^[
	};

static u8
	g_scr_base[] = 
	{
		VRAM_BG_SCRBASE_0x1000,
		VRAM_BG_SCRBASE_0x1800,
		VRAM_BG_SCRBASE_0x2000,
		VRAM_BG_SCRBASE_0x2800,
		VRAM_BG_SCRBASE_0x3000,

		VRAM_BG_SCRBASE_0x4000,
		VRAM_BG_SCRBASE_0x4800,
		VRAM_BG_SCRBASE_0x5000,
		VRAM_BG_SCRBASE_0x5800,
	};

static u16
	g_file_id[] = 
	{
		_BCHA_01A_CG,
		_BEFFECT_01_CG,
		_BCUTIN_01_CG,
		_BCHA_01A_PAL,
		_BEFFECT_01_PAL,
		_BCUTIN_01_PAL,
		_BCHA_02_CG,
		NULL,
		_BCUTIN_02_CG,
		_BCHA_02_PAL,
		NULL,
		_BCUTIN_02_PAL,
		_BCHA_03_CG,
		_BEFFECT_03_CG,
		_BCUTIN_03_CG,
		_BCHA_03_PAL,
		_BEFFECT_03_PAL,
		_BCUTIN_03_PAL,
		_BCHA_04_CG,
		_BEFFECT_04_CG,
		_BCUTIN_04_CG,
		_BCHA_04_PAL,
		_BEFFECT_04_PAL,
		_BCUTIN_04_PAL,
		_BCHA_05_CG,
		_BEFFECT_05_CG,
		_BCUTIN_05_CG,
		_BCHA_05_PAL,
		_BEFFECT_05_PAL,
		_BCUTIN_05_PAL,
		_BCHA_06_CG,
		_BEFFECT_06_CG,
		_BCUTIN_06_CG,
		_BCHA_06_PAL,
		_BEFFECT_06_PAL,
		_BCUTIN_06_PAL,
		_BCHA_07_CG,
		_BEFFECT_07_CG,
		_BCUTIN_07_CG,
		_BCHA_07_PAL,
		_BEFFECT_07_PAL,
		_BCUTIN_07_PAL,
		_BCHA_08_CG,
		NULL,
		_BCUTIN_08_CG,
		_BCHA_08_PAL,
		NULL,
		_BCUTIN_08_PAL,
	};



// -------------------------------------
// [J֐`
// -------------------------------------
static void GetEndingNo(void);
static BOOL af00_check(void);
static void af00(void);
static void initStaffScreen(void);
static void mainStaff(void);
static void scrollU(void);
static void scrollD(void);
static void initAfter(void);
static void waitAfter(void);
static void mainAfter(void);

static void initBattleChar(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
//---------------------------------------------------
//GfBO
//---------------------------------------------------
void startEnding(void)
{
	setScriptGraph();
	fadeBGM(120);
	setChangeLock(TRUE);
	putDateWindow(FALSE);
	clearMessage();
	clearFaceName();
	clearCha(3);
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();
	waitOnly(60);

	setBgNum(BG_ed00);
	waitChangeGraph();
	waitOnly(120);

	GetEndingNo();

	setEndTitleGraph((u8)EndNum);
	setEnding(EndNum);
	switch (EndNum)
	{
		case 0:				// 0 ^lԊE̗E
			setScript(_ENDING_PSC, ENDING_EN39);
			waitScript();
			break;
		case 1:				//  1 vZX
			setDress(14);
			setcon(conN);
			setScript(_ENDING_PSC, ENDING_EN05);
			waitScript();
			setPrincess(1);
			break;
		case 2:				//  2 lԊE̗E
			setScript(_ENDING_PSC, ENDING_EN10);
			waitScript();
			break;
		case 3:				//  3 
			setScript(_ENDING_PSC, ENDING_EN17);
			waitScript();
			break;
		case 4:				//  4 
			setScript(_ENDING_PSC, ENDING_EN02);
			waitScript();
			break;
		case 5:				//  5 {pt
			setScript(_ENDING_PSC, ENDING_EN14);
			waitScript();
			break;
		case 6:				//  6 ƌ
			setScript(_ENDING_PSC, ENDING_EN04);
			waitScript();
			if (getScriptEndCode() == 1)
				setFatherBride(1);
			break;
		case 7:				//  7 [[
			setScript(_ENDING_PSC, ENDING_EN42);
			waitScript();
			break;
		case 8:				//  8 R
			setScript(_ENDING_PSC, ENDING_EN34);
			waitScript();
			break;
		case 9:				//  9 ẼvZX
			setScript(_ENDING_PSC, ENDING_EN01);
			waitScript();
			break;
		case 10:			// 10 i
			setScript(_ENDING_PSC, ENDING_EN30);
			waitScript();
			break;
		case 11:			// 11 ݕvl
			setScript(_ENDING_PSC, ENDING_EN18);
			waitScript();
			break;
		case 12:			// 12 b
			setScript(_ENDING_PSC, ENDING_EN21);
			waitScript();
			break;
		case 13:			// 13 hS[Xƌ
			setScript(_ENDING_PSC, ENDING_EN08);
			waitScript();
			break;
		case 14:			// 14 ÍX̃{X
			setScript(_ENDING_PSC, ENDING_EN12);
			waitScript();
			break;
		case 15:			// 15 ̒P
			setScript(_ENDING_PSC, ENDING_EN25);
			waitScript();
			break;
		case 16:			// 16 i@
			setScript(_ENDING_PSC, ENDING_EN22);
			waitScript();
			break;
		case 17:			// 17 J
			setDress(1);
			setScript(_ENDING_PSC, ENDING_EN38);
			waitScript();
			break;
		case 18:			// 18 m
			setScript(_ENDING_PSC, ENDING_EN15);
			waitScript();
			break;
		case 19:			// 19 L[uƌ
			setScript(_ENDING_PSC, ENDING_EN07);
			waitScript();
			break;
		case 20:			// 20 NX`[i
			setScript(_ENDING_PSC, ENDING_EN36);
			waitScript();
			break;
		case 21:			// 21 Mwl
			setScript(_ENDING_PSC, ENDING_EN19);
			waitScript();
			break;
		case 22:			// 22 
			setScript(_ENDING_PSC, ENDING_EN23);
			waitScript();
			break;
		case 23:			// 23 xwl
			setScript(_ENDING_PSC, ENDING_EN26);
			waitScript();
			break;
		case 24:			// 24 `Cj[YI[Nƌ
			setScript(_ENDING_PSC, ENDING_EN35);
			waitScript();
			break;
		case 25:			// 25 }[
			setScript(_ENDING_PSC, ENDING_EN37);
			waitScript();
			break;
		case 26:			// 26 |pƁiƁj
			setScript(_ENDING_PSC, ENDING_EN31);
			waitScript();
			break;
		case 27:			// 27 ̕PiX^[j
			setScript(_ENDING_PSC, ENDING_EN27);
			waitScript();
			break;
		case 28:			// 28 VX^[
			setScript(_ENDING_PSC, ENDING_EN29);
			waitScript();
			break;
		case 29:			// 29 \t
			setScript(_ENDING_PSC, ENDING_EN24);
			waitScript();
			break;
		case 30:			// 30 m
			setScript(_ENDING_PSC, ENDING_EN13);
			waitScript();
			break;
		case 31:			// 31 肢t
			setScript(_ENDING_PSC, ENDING_EN16);
			waitScript();
			break;
		case 32:			// 32 Ch̓X
			setScript(_ENDING_PSC, ENDING_EN28);
			waitScript();
			break;
		case 33:			// 33 ̏
			setScript(_ENDING_PSC, ENDING_EN20);
			waitScript();
			break;
		case 34:			// 34 ʏ̌
			setScript(_ENDING_PSC, ENDING_EN32);
			waitScript();
			break;
		case 35:			// 35 EɋA
			setScript(_ENDING_PSC, ENDING_EN03);
			waitScript();
			break;
		case 36:			// 36 t[^[
			setScript(_ENDING_PSC, ENDING_EN33);
			waitScript();
			break;
	}
#if 0
	//---------------------------------------------------
	// X^bt[
	//---------------------------------------------------
	setScriptGraph();


	//---------------------------------------------------
	// ki΁j
	//---------------------------------------------------
	af00();		//k

	waitOnly(60);
	fadeBGM(60);
	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	clearCha(3);
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();

	setAlbumEnable(1);

	setBgNum(BG_ed_fin);
	waitOnly(600);
#endif
}


//---------------------------------------------------
// Ending
//---------------------------------------------------
static void GetEndingNo(void)
{
	int i, j;

	if (getLabel(LF_ev041) == ON)
	{
		EndNum = 19;
		return;
	}
	for (i=0; i<NUM_ENDING; i++)
	{
		//ɂĂ͂
		if (i == 0 && (getLabel(LF_ev325_0) == OFF || getLabel(LF_ev024b) == OFF || getLabel(LF_adv01_4) == OFF || getLabel(LF_ev034) == OFF))
			continue;
		if (i == 1 && getLabel(LF_ev034_2) == OFF)
			continue;
		if (i == 6 && getLabel(LF_ev040_1) == OFF)
			continue;
		if (i == 7 && (getParam(pR1) < 150 || getSchRank(jBujyutu) < 2))
			continue;
		if (i == 10 && getSchCount(jKyoukai) <= 4)
			continue;
		if (i == 13 && getLabel(LF_ev023) == OFF)
			continue;
		if (i == 14 && getSchCount(jAyasiiSakaba) <= 2)
			continue;
		if (i == 17 && getParam(pR4) < 100)
			continue;		// J
		if (i == 20 && getParam(pR2) < 140)
			continue;
		if (i == 23 && getLabel(LF_ev042) == OFF)
			continue;
		if (i == 24 && (getGold() > 999 || getLabel(LF_adv02_0) == OFF))
			continue;
		if (i == 25 && (getParam(pR3) < 140 || getSchRank(jGeijyutu) < 2))
			continue;
		if (i == 26 && getSchRank(jGeijyutu) <= 1)
			continue;
		if (i == 27 && getLabel(LF_ev027) == OFF)
			continue;
		if (i == 28 && getSchCount(jKyoukai) <= 2)
			continue;
		if (i == 32 && getSchCount(jMeidoSakaba) <= 2)
			continue;
		if (i == 33 && getSchCount(jAyasiiSakaba) <= 2)
			continue;

		for (j=0; j<NUM_ED_PARAM; j++)
		{
			s32 val0, val1;

			val0 = (s32)getParam((s32)endingParamTbl[j]);			// Ώۃp[^l
			val1 = endingTbl[(i * NUM_ED_PARAM) + j];	// Kl
			if (val1 >= 1000)
				val1 = -(s32)getParam(val1 - 1000);
			if (val1 < 0)
			{
				val1 = -val1;
				// HHȉ̏ꍇ
				if (val0 > val1)
					break;		// ip[^ > Klj ̏ꍇ͂߂
			} else
			if (val0 < val1)
				break;			// ip[^ < Klj ̏ꍇ͂߂
		}
		if (j == NUM_ED_PARAM)
		{
			EndNum = (u16)i;
			return;
		}
	}
	// ɗ̂͂蓾ȂǃoOh~̂
	EndNum = 36;
}


//---------------------------------------------------
// k
//---------------------------------------------------
static void af00(void)
{
	BOOL result;

	result = FALSE;
	//k
	switch (EndNum)
	{
		case 0:		// 0 ^ElԊE̗E
			setDress(1);
			setScript(_AF_PSC, AF_AF_5);
			waitScript();
			result = TRUE;
			break;
		case 1:		// 1 vZX
			if (getParam(pMORAL) >= 700)
			{
				setScript(_AF_PSC, AF_AF_3);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_0);
				waitScript();
			}
			result = TRUE;
			break;
		case 2:		// 2 E
			setScript(_AF_PSC, AF_AF_0);
			waitScript();
			result = TRUE;
			break;
		case 3:		//3 
			if (getParam(pMAZOKU) >= 50)
			{
				setScript(_AF_PSC, AF_AF_2);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_0);
				waitScript();
			}
			result = TRUE;
			break;
		case 4:		//4 
			if (getLabel(LF_ev039) == ON)
			{
				setScript(_AF_PSC, AF_AF_1);
				waitScript();
			} else
			if (getParam(pMORAL) >= 600)
			{
				setScript(_AF_PSC, AF_AF_2);
				waitScript();
			} else
			if (getParam(pMORAL) < 600 && getParam(pKANNJYU) >= 700)
			{
				setScript(_AF_PSC, AF_AF_3);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_4);
				waitScript();
			}
			result = TRUE;
			break;
		case 8:		// 8 R
			if (getParam(pCHIRYOKU) >= 700)
			{
				setScript(_AF_PSC, AF_AF_2);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_4);
				waitScript();
			}
			result = TRUE;
			break;
		case 9:		// 9 ẼvX
			if (getLabel(LF_ev039) == ON)
			{
				setScript(_AF_PSC, AF_AF_1);
				waitScript();
			} else
			if (getParam(pMORAL) > 150)
			{
				setScript(_AF_PSC, AF_AF_2);
				waitScript();
			} else
			if (getParam(pMORAL) < 151 && getParam(pKANNJYU) >= 700)
			{
				setScript(_AF_PSC, AF_AF_3);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_4);
				waitScript();
			}
			result = TRUE;
			break;
		case 12:	// 12 b
			if (getParam(pMAZOKU) >= 50 && getParam(pMORAL) >= 400)
			{
				setScript(_AF_PSC, AF_AF_2);
				waitScript();
			} else {
				setScript(_AF_PSC, AF_AF_0);
				waitScript();
			}
			result = TRUE;
			break;
		case 30:	// 30 m
			setScript(_AF_PSC, AF_AF_4);
			waitScript();
			result = TRUE;
			break;
		case 35:	// 35 EɋA
			setScript(_AF_PSC, AF_AF_4);
			waitScript();
			result = TRUE;
			break;
	}

	if (result)
	{
		waitOnly(60);
		fadeBGM(60);
		setChangeLock(TRUE);
		clearMessage();
		clearFaceName();
		clearCha(3);
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setBgNum(BG_black);
		setChangeLock(FALSE);
		waitChangeGraph();
	}
	setAlbumEnable(1);
	if (result)
	{
		setBgNum(BG_ed_fin);
	}
	waitOnly(600);
}
//---------------------------------------------------
static BOOL af00_check(void)
{
	switch (EndNum)
	{
		case 0:		// 0 ^ElԊE̗E
		case 1:		// 1 vZX
		case 2:		// 2 E
		case 3:		//3 
		case 4:		//4 
		case 8:		// 8 R
		case 9:		// 9 ẼvX
		case 12:	// 12 b
		case 30:	// 30 m
		case 35:	// 35 EɋA
			return TRUE;
	}
	return FALSE;
}


//---------------------------------------------------
// X^bt[ȍ~̏
//---------------------------------------------------
void initEnding(void)
{
	g_step = ENDING_MODE_STAFF_INIT;
}

//---------------------------------------------------
// X^bt[ȍ~̏
//---------------------------------------------------
void execEnding(void)
{
	switch (g_step)
	{
		case ENDING_MODE_STAFF_INIT:
			initStaffScreen();
			break;
		case ENDING_MODE_STAFF_MAIN:
			mainStaff();
			break;
		case ENDING_MODE_AFTER_INIT:
			initAfter();
			break;
		case ENDING_MODE_AFTER_WAIT:
			waitAfter();
			break;
		case ENDING_MODE_AFTER_MAIN:
			mainAfter();
			break;
		default:
			;
	}
}

//---------------------------------------------------
// X^bt[ʏ
//---------------------------------------------------
static void initStaffScreen(void)
{
	putLCDC(0, 0);
	setMainLCDC(LCDC_UP);		// Cɂ
	setVRAMBank(VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128);
	//setExtPalette(FALSE, FALSE, FALSE, TRUE);
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	setFadeFrom(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, FADE_NORMAL, 60);
	// 
	setBgMode(PLANE_MAIN_BG0, VRAM_BG_CHARBASE_0x18000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);
	setBgMode(PLANE_MAIN_BG1, VRAM_BG_CHARBASE_0x08000, VRAM_BG_SCRBASE_0x0800, BG_SCRSIZE_256x512, COLOR_MODE_16);
	setBgMode(PLANE_MAIN_BG2, VRAM_BG_CHARBASE_0x10000, VRAM_BG_SCRBASE_0x3800, BG_SCRSIZE_256x512, COLOR_MODE_16);

	readFileToVRAM(_STUFF_A_CG, VRAM_MAIN_BG0_CG, 0);
	readFileToVRAM(_STUFF_B_CG, VRAM_MAIN_BG1_CG, 0);
	readFileToVRAM(_STUFF_C_CG, VRAM_MAIN_BG2_CG, 0);
	readFileToVRAM(_STUFF_A_MAP, VRAM_MAIN_BG0_SCR, 0);
	readFileToVRAM(_STUFF_B_MAP, VRAM_MAIN_BG1_SCR, 0);
	readFileToVRAM(_STUFF_C_MAP, VRAM_MAIN_BG2_SCR, 0);
	readFileToVRAM(_STUFF_PAL, VRAM_MAIN_BG_PAL, 0);

	// 
	setBgMode(PLANE_SUB_BG1, VRAM_BG_CHARBASE_0x08000, VRAM_BG_SCRBASE_0x0800, BG_SCRSIZE_256x512, COLOR_MODE_16);
	setBgMode(PLANE_SUB_BG2, VRAM_BG_CHARBASE_0x10000, VRAM_BG_SCRBASE_0x3800, BG_SCRSIZE_256x512, COLOR_MODE_16);

	readFileToVRAM(_STUFF_B_CG, VRAM_SUB_BG1_CG, 0);
	readFileToVRAM(_STUFF_C_CG, VRAM_SUB_BG2_CG, 0);
	readFileToVRAM(_STUFF_B_MAP, VRAM_SUB_BG1_SCR, 0);
	readFileToVRAM(_STUFF_C_MAP, VRAM_SUB_BG2_SCR, 0);
	readFileToVRAM(_STUFF_PAL, VRAM_SUB_BG_PAL, 0);

	//setFileToExtPalette(VRAM_SUB_OBJ_PAL, 0, _S_EV1_PAL);
	//initBattleChar();

	setVisible(PLANE_MAIN_BG0|PLANE_MAIN_BG1|PLANE_SUB_BG1, 1);

	putLCDC(1, 1);

	setBGM(SEQ_PRM4_01);

	g_staff_step = 0;

	g_step = ENDING_MODE_STAFF_MAIN;
}

//---------------------------------------------------
// X^bt[
//---------------------------------------------------
static void mainStaff(void)
{
	switch (g_staff_step)
	{
		case 0:			// zCgC
			if (!isFade(FADE_MAIN_BG))
			{
				playBGM();
				g_staff_bgm_count = 0;
				g_staff_wait = 300;
				g_staff_step = 1;
				g_end_fade = FALSE;
			}
			break;

		case 1:			// ʂ̃XN[n܂
			g_staff_wait--;
			if (g_staff_wait == 0)
			{
				g_staff_scroll_d = 0;
				g_staff_scr_d = 0;
				g_staff_wait = 120;
				g_staff_step = 2;
			}
			g_staff_bgm_count++;
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				fadeBGM(120);
				g_end_fade = TRUE;
			}
			break;

		case 2:			// ʂ̕\
			g_staff_wait--;
			if (g_staff_wait == 0)
			{
				if (g_end_fade)
				{
					g_staff_step = 8;
				} else {
					setFade(FADE_MAIN_BG, FADE_BLACK, 180);
					g_staff_step = 3;
				}
			}
			scrollD();
			g_staff_bgm_count++;
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				fadeBGM(120);
				g_end_fade = TRUE;
			}
			break;

		case 3:			// ʂXN[̏
			if (!isFade(FADE_MAIN_BG))
			{
				setVisible(PLANE_MAIN_BG0, 0);
				setFade(FADE_MAIN_BG, FADE_NORMAL, 1);
				g_staff_step = 4;
			}
			scrollD();
			g_staff_bgm_count++;
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				fadeBGM(120);
				g_staff_step = 8;
				g_end_fade = TRUE;
			}
			break;

		case 4:			// ʃXN[Jn
			if (g_staff_scroll_d == 464)
			{
				g_staff_scroll_u = 0;
				g_staff_scr_u = 0;
				g_staff_step = 5;
			}
			scrollD();
			g_staff_bgm_count++;
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				fadeBGM(120);
				g_staff_step = 7;
				g_end_fade = TRUE;
			}
			break;

		case 5:			// Ȃ̏I҂
			scrollU();
			scrollD();
			g_staff_bgm_count++;
			if (g_staff_bgm_count >= 86*60)
			{
				stopBGM();
				g_staff_wait = 60;
				g_staff_step = 6;
			}
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				fadeBGM(120);
				g_end_fade = TRUE;
			}
			break;

		case 6:			// I҂
			scrollU();
			scrollD();
			g_staff_wait--;
			if (g_staff_wait == 0)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				g_end_fade = TRUE;
				g_staff_step = 7;
			}
			if (getPad() & PAD_BUTTON_START && !g_end_fade)
			{
				setFade(FADE_MAIN_BG|FADE_SUB_BG, FADE_WHITE, 120);
				g_staff_step = 7;
				g_end_fade = TRUE;
			}
			break;

		case 7:			// zCgAEg
			scrollU();
			scrollD();
			break;

		case 8:			// zCgAEg
			scrollD();
			break;

		default:
			;
	}
	if (g_end_fade)
	{
		if (!isFade(FADE_SUB_BG))
		{
			stopBGM();
			g_step = ENDING_MODE_AFTER_INIT;
		}
	}
}

//---------------------------------------------------
// X^bt[̃XN[
//---------------------------------------------------
static void scrollU(void)
{
	if (g_staff_scroll_u == 512*2)
		return;
	g_staff_scroll_u++;
	if (g_staff_scroll_u == 256*2)
	{
		if (g_staff_scr_u < 5)
		{
			setScrBlock(PLANE_MAIN_BG1, g_scr_base[g_staff_scr_u]);
			if (g_staff_scr_u == 3)
				setVisible(PLANE_MAIN_BG2, 1);
			else
			if (g_staff_scr_u == 4)
			{
				g_staff_scr_u++;
				setScrBlock(PLANE_MAIN_BG2, g_scr_base[g_staff_scr_u]);
			}
			g_staff_scr_u++;
			g_staff_scroll_u = 0;
		} else
		if (g_staff_scr_u < 9)
		{
			setScrBlock(PLANE_MAIN_BG2, g_scr_base[g_staff_scr_u]);
			if (g_staff_scr_u == 5)
				setVisible(PLANE_MAIN_BG1, 0);
			g_staff_scr_u++;
			g_staff_scroll_u = 0;
		}
	}
	setBgPos(PLANE_MAIN_BG1, 0, g_staff_scroll_u / 2);
	setBgPos(PLANE_MAIN_BG2, 0, g_staff_scroll_u / 2);
}
//---------------------------------------------------
static void scrollD(void)
{
	if (g_staff_scroll_d == 512*2)
		return;
	g_staff_scroll_d++;
	if (g_staff_scroll_d == 256*2)
	{
		if (g_staff_scr_d < 5)
		{
			setScrBlock(PLANE_SUB_BG1, g_scr_base[g_staff_scr_d]);
			if (g_staff_scr_d == 3)
				setVisible(PLANE_SUB_BG2, 1);
			else
			if (g_staff_scr_d == 4)
			{
				g_staff_scr_d++;
				setScrBlock(PLANE_SUB_BG2, g_scr_base[g_staff_scr_d]);
			}
			g_staff_scr_d++;
			g_staff_scroll_d = 0;
		} else
		if (g_staff_scr_d < 9)
		{
			setScrBlock(PLANE_SUB_BG2, g_scr_base[g_staff_scr_d]);
			if (g_staff_scr_d == 5)
				setVisible(PLANE_SUB_BG1, 0);
			g_staff_scr_d++;
			g_staff_scroll_d = 0;
		}
	}
	setBgPos(PLANE_SUB_BG1, 0, g_staff_scroll_d / 2);
	setBgPos(PLANE_SUB_BG2, 0, g_staff_scroll_d / 2);
}

//---------------------------------------------------
// k@
//---------------------------------------------------
static void initAfter(void)
{
	if (af00_check())
		initEventGraph(2);
	else
		initEventGraph(3);
	setScriptGraph();

	g_step = ENDING_MODE_AFTER_WAIT;
}

//---------------------------------------------------
// k
//---------------------------------------------------
static void waitAfter(void)
{
	if (!isFlipBmpBuf())
	{
		setScriptThread(af00);
		g_step = ENDING_MODE_AFTER_MAIN;
	}
	execBmpBuf();
}

//---------------------------------------------------
// k
//---------------------------------------------------
static void mainAfter(void)
{
	if (isEndScriptThread())
	{
		stopBGM();
		exitEventGraph();
		changeGameMode(GAME_MODE_LOGO);
	} else {
		execScript();
		execEventGraph();
	}
}


//---------------------------------------------------
// 
//---------------------------------------------------
static void initBattleChar(void)
{
	int c;

	c = getEndingCount();
	if (c == 0)
		g_battle_info = ENDING_BATTLE_NONE;
	else
	if (c == 1)
		g_battle_info = ENDING_BATTLE_LOOK;
	else
		g_battle_info = ENDING_BATTLE_FIGHT;

	if (g_battle_info != ENDING_BATTLE_NONE)
	{
		// ΐ푊̓_
		g_battle_char = (u8)(getRandom() % 7);

//	*g_en_cha_buf,
//	*g_en_mag_buf;
		
		
//	*g_my_cha_buf,
//	*g_my_mag_buf,
		
		
	}
}


