//---------------------------------------------------------------------------
//
//	GAMEŏʃt@C
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "game.h"
#include "pack_data.h"
#include "prime4.h"
#include "title.h"
#include "entry.h"
#include "room.h"
#include "script.h"
#include "event_grp.h"
#include "test.h"
#include "sound_data.h"
#include "item.h"
#include "album.h"
#include "omake.h"
#include "ending.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define WARNING_MODE_INIT			0
#define WARNING_MODE_MAIN			1

// -------------------------------------
// NXE\̒`
// -------------------------------------

// -------------------------------------
// [Jϐ`
// -------------------------------------
static u8
	g_game_mode;

// -------------------------------------
// [J֐`
// -------------------------------------
static void initWarningSave(void);
static void initWarningLoad(void);


//---------------------------------------------------------------------------
//
// [J֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initGame(void)
{
	g_game_mode = 0xff;
	usePadRepeat(PAD_BUTTON_X, FALSE);

	setSE(SEQ_SE, BANK_SE);
	setBGMVolume(90);
	setMovieVolume(100);
	initFirstBackup();
	setLoadScreen(FALSE);
	setOptionScreen(FALSE);
	if (g_game_mode != GAME_MODE_WARNING_LOAD && g_game_mode != GAME_MODE_WARNING_SAVE)
	{
		initFirstEventGraph();
		initFirstScript();
		initFirstItem();

		if (OS_GetResetParameter() == 0)
			changeGameMode(GAME_MODE_LOGO);
		else
		if (OS_GetResetParameter() == 1)
			changeGameMode(GAME_MODE_TITLE);
		else
			changeGameMode(GAME_MODE_OMAKE);
	}
}

// -------------------------------------
//  C
// -------------------------------------
void execGame(void)
{
	switch (g_game_mode)
	{
		case GAME_MODE_WARNING_LOAD:
		case GAME_MODE_WARNING_SAVE:
			break;
		case GAME_MODE_LOGO:
		case GAME_MODE_TITLE:
		case GAME_MODE_OMAKE:
			execTitle();
			break;
		case GAME_MODE_ENTRY:
			execEntry();
			break;
		case GAME_MODE_ROOM:
			execRoom();
			break;
		case GAME_MODE_ALBUM:
			execAlbum();
			break;
		case GAME_MODE_OMAKESCRIPT:
			execOmakeScript();
			break;
		case GAME_MODE_ENDING:
			execEnding();
			break;
		case GAME_MODE_TEST:
			execTest();
			break;
		default:
			;
	}
}

// -------------------------------------
//  Q[[h̕ύX
// -------------------------------------
void changeGameMode(u8 in_mode)
{
	if (g_game_mode == GAME_MODE_WARNING_LOAD || g_game_mode == GAME_MODE_WARNING_SAVE)
		return;		// [jO͒e

	g_game_mode = in_mode;
	switch (g_game_mode)
	{
		case GAME_MODE_WARNING_LOAD:
			initWarningLoad();
			break;
		case GAME_MODE_WARNING_SAVE:
			initWarningSave();
			break;
		case GAME_MODE_LOGO:
			initLogo();
			break;
		case GAME_MODE_TITLE:
			initTitle();
			break;
		case GAME_MODE_OMAKE:
			initOmake();
			break;
		case GAME_MODE_ENTRY:
			initEntry();
			break;
		case GAME_MODE_ROOM:
			initRoom();
			break;
		case GAME_MODE_ALBUM:
			initAlbum();
			break;
		case GAME_MODE_OMAKESCRIPT:
			initOmakeScript();
			break;
		case GAME_MODE_ENDING:
			initEnding();
			break;
		case GAME_MODE_TEST:
			initTest();
			break;
		default:
			;
	}
}

// -------------------------------------
//  Q[[h̕ύX
// -------------------------------------
void setGameMode(u8 in_mode)
{
	g_game_mode = in_mode;
}

// -------------------------------------
//  Q[[h̎擾
// -------------------------------------
u8 getGameMode(void)
{
	return g_game_mode;
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initWarningSave(void)
{
	putLCDC(0, 0);
	setVRAMBank(VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128);
	setMainLCDC(LCDC_DOWN);		// Cɂ
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	// ʂȂH

	// 
	setBgMode(PLANE_MAIN_BG0, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);

	readFileToVRAM(_WARNING_CG, VRAM_MAIN_BG0_CG, 0);
	readFileToVRAM(_WARNING_01_MAP, VRAM_MAIN_BG0_SCR, 0);

	setFadeFrom(FADE_MAIN_BG|FADE_MAIN_OBJ, FADE_WHITE, FADE_NORMAL, 30);
	readFileToVRAM(_WARNING_PAL, VRAM_MAIN_BG_PAL, 0);

	setVisible(PLANE_MAIN_BG0, 1);
	putLCDC(1, 0);
}
// -------------------------------------
static void initWarningLoad(void)
{
	putLCDC(0, 0);
	setVRAMBank(VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128, VRAM_SIZE_128);
	setMainLCDC(LCDC_DOWN);		// Cɂ
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	// ʂȂH

	// 
	setBgMode(PLANE_MAIN_BG0, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);

	readFileToVRAM(_WARNING_CG, VRAM_MAIN_BG0_CG, 0);
	readFileToVRAM(_WARNING_02_MAP, VRAM_MAIN_BG0_SCR, 0);

	setFadeFrom(FADE_MAIN_BG|FADE_MAIN_OBJ, FADE_WHITE, FADE_NORMAL, 30);
	readFileToVRAM(_WARNING_PAL, VRAM_MAIN_BG_PAL, 0);

	setVisible(PLANE_MAIN_BG0, 1);
	putLCDC(1, 0);
}

