//---------------------------------------------------------------------------
//
//	ACe item.gh item_dress.gh
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "graph.h"
#include "prime4.h"
#include "item.h"
#include "event_grp.h"
#include "script.h"
#include "room.h"
#include "schedule.h"
#include "sound_data.h"
#include "def/sp01_def.h"
#include "def/sp01b_def.h"
#include "def/sp02_def.h"
#include "def/sp03_def.h"
#include "def/sp05_def.h"
#include "def/sp06_def.h"
#include "def/sp07_def.h"
#include "def/sp07p_def.h"
#include "def/item_def.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define ITEM_MODE_NONE				0		// 
#define ITEM_MODE_WAIT				1		// \EFCg
#define ITEM_MODE_MAIN				2		// I
#define ITEM_MODE_DECIDE			3		// 
#define ITEM_MODE_EAT_WAIT			4		// XgEp[^\
#define ITEM_MODE_EAT_MAIN			5		// XgEp[^ω
#define ITEM_MODE_EAT_END			6		// Xg
#define ITEM_MODE_SCRIPT_WAIT		7		// XNvg҂

#define ITEM_SELECT_LOOK			0
#define ITEM_SELECT_BUY				1
#define ITEM_SELECT_SELL			2
#define ITEM_SELECT_CHURCH			3
#define ITEM_SELECT_DRESS			4
#define ITEM_SELECT_THIEF			5
#define ITEM_SELECT_DRESS2			6
#define ITEM_SELECT_PRESENT			7
#define ITEM_SELECT_HAR				8

// -------------------------------------
// NXE\̒`
// -------------------------------------
typedef struct
{
	u8
		m_from_len,
		m_to_len;
	char
		*m_from_mes,
		*m_to_mes;
} MessageBuf;

typedef struct
{
	char
		*m_name;
	u8
		m_kind,
		m_label;
	u16
		m_price;

} ITEM_INFO;

// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_key_use,
	g_key_decide;
static s8
	g_select,
	g_item_select;
static u8
	g_step,
	g_count,
	g_key_select,
	g_select_mode,
	g_sort_count,
	g_price_rate,
	g_sort_item[100],
	g_select_top,
	g_no_flag;
static s16
	g_wait,
	g_script_label,
	g_last_label,
	g_nomoney_label,
	g_buy_label,
	g_already_label,
	g_dress_num;
static u16
	g_script_id;
static OSMutex
	g_mutex;

static MessageBuf
	g_dress_mes[19] = 
	{
		{  5, 11, "i", "iɒւ܂B" },
		{  4, 10, "ĕ", "ĕɒւ܂B" },
		{  4, 10, "~", "~ɒւ܂B" },
		{  5, 11, "hX", "hXɒւ܂B" },
		{  9, 15, "VÑhX", "VÑhXɒւ܂B" },
		{  8, 14, "؂ȃhX", "؂ȃhXɒւ܂B" },
		{  5, 11, "p", "pɒւ܂B" },
		{  8, 14, "pt̐", "pt̐ɒւ܂B" },
		{  0,  0, "", "" },
		{  0,  0, "", "" },
		{  8, 14, "U[X[c", "U[X[cɒւ܂B" },
		{  5, 11, "C", "Cɒւ܂B" },
		{  0,  0, "", "" },
		{ 11, 16, "EFfBOhX", "EFfBOhXɒւ܂" },
		{  6, 12, "sǂ̕", "sǂ̕ɒւ܂B" },
		{  6, 12, "pW}", "pW}ɒւ܂B" },
		{  8, 14, "X̃[u", "X̃[uɒւ܂B" },
		{  8, 14, "P̃hX", "P̃hXɒւ܂B" },
		{  7, 13, "̃hX", "̃hXɒւ܂B" }
	};

static ITEM_INFO
	g_item_info[] =
	{
		{ "",                  0, 0     }, // 00:
		{ "͋[",            0, SP01_SP01_7,    15  }, // 01:͋[
		{ "S̒",          0, SP01_SP01_8,   250  }, // 02:S̒
		{ "~X̌",      0, SP01_SP01_9,  1200  }, // 03:~X̌
		{ "Аn",        0, SP01_SP01_10, 2000  }, // 04:Аn
		{ "K̏",          0, SP01_SP01_11,   15  }, // 05:K̏
		{ "̏",          0, SP01_SP01_12,  500  }, // 06:̏
		{ "~X̏",      0, SP01_SP01_13, 1500  }, // 07:~X̏
		{ "̊Z ",           2, SP01_SP01_14,   98  }, // 08:̊Z 
		{ "S̊Z",            2, SP01_SP01_15,  980  }, // 09:S̊Z
		{ "~X̊Z",      2, SP01_SP01_16, 1980  }, // 10:~X̊Z
		{ "VN̊Z",        2, SP01_SP01_17, 2980  }, // 11:VN̊Z
		{ "R̖@",        2, SP01_SP01_18, 3980  }, // 12:R̖@
		{ "GZbg",        4, SP01_SP01_19,  300  }, // 13:GZbg
		{ "_XV[Y",    4, SP01_SP01_20,  300  }, // 14:_XV[Y
		{ "l`",            4, SP01_SP01_21,  500  }, // 15:l`
		{ "W",              4, SP01_SP01_22,  200  }, // 16:W
		{ "",              4, SP01_SP01_23,  320  }, // 17:
		{ "eB[Jbv",      4, SP01_SP01_24,  400  }, // 18:eB[Jbv
		{ "ϓ",        4, SP01_SP01_25,  200  }, // 19:ϓ
		{ "nCq[",        4, SP01_SP01_26,  200  }, // 20:nCq[
		{ "ٖD",          4, SP01_SP01_27,  200  }, // 21:ٖD
		{ "@",            4, SP01_SP01_28,  200  }, // 22:@
		{ "ꂽ",        4, SP01_SP01_29,  200  }, // 23:ꂽ
		{ "p[Xg",      4, SP01_SP01_30,  200  }, // 24:p[Xg
		{ "nJ`",          4, 0,  15  }, // 25:nJ`
		{ "C",              4, 0,  15  }, // 26:C
		{ "eB[Jbv",      4, 0,  15  }, // 27:eB[Jbv
		{ "NM",            4, 0,  20  }, // 28:NM
		{ "̕",        4, 0,  50  }, // 29:̕
		{ "}g",            4, 0,  60  }, // 30:}g
		{ "Z",              4, 0,  70  }, // 31:Z
		{ "ԑ",              4, SP01_SP01B_32, 400  }, // 32:ԑ
		{ "IS[",        4, SP01_SP01B_33, 600  }, // 33:IS[
		{ "",        4, 0,   0  }, // 34:
		{ "`",        4, 0,   0  }, // 35:`
		{ "X}C",          4, SP01_SP01B_31,   0  }, // 36:X}C
		{ "d̖",          3, SP06_SP06_7,  50  }, // 37:d̖
		{ "mb̎",          3, SP06_SP06_8,  50  }, // 38:mb̎
		{ "h̉ʎ",        3, SP06_SP06_9,  50  }, // 39:h̉ʎ
		{ "̎",          3, SP06_SP06_10,  50  }, // 40:̎
		{ "MȂ",      3, SP06_SP06_11,  50  }, // 41:MȂ
		{ "₳̋ʘI",    3, SP06_SP06_12,  50  }, // 42:₳̋ʘI
		{ "|p̐",        3, SP06_SP06_13,  50  }, // 43:|p̐
		{ "f̍",        3, SP06_SP06_14,  50  }, // 44:f̍
		{ "炩Ȏt",      3, SP06_SP06_15,  50  }, // 45:炩Ȏt
		{ "_̍",          3, SP06_SP06_16,  50  }, // 46:_̍
		{ "V̍",          3, SP06_SP06_17,  50  }, // 47:V̍
		{ "d̂",      3, SP07_SP07_8,1000  }, // 48:d̂
		{ "_",            3, SP07_SP07_9,1000  }, // 49:_
		{ "E̐",        3, SP07_SP07_10, 500  }, // 50:E̐
		{ "֒f̎",          3, SP07_SP07_11,1000  }, // 51:֒f̎
		{ "L̖ڐ",          4, SP07_SP07_12, 600  }, // 52:L̖ڐ
		{ "ÂтF",        4, SP07_SP07_13,1000  }, // 53:ÂтF
		{ "Ȃ钤",        4, SP07_SP07_14,1000  }, // 54:Ȃ钤
		{ "̎w",        4, SP07_SP07_12,1500  }, // 55:̎w
		{ "̎",      4, SP07_SP07_12,2000  }, // 56:̎
		{ "X̃[u",      1, SP07_SP07_15,4000  }, // 57:X̃[u
		{ "i",            1, 0,   0  }, // 58:i
		{ "ĕ",              1, SP02_SP02_10,  70  }, // 59:ĕ
		{ "~",              1, SP02_SP02_11, 120  }, // 60:~
		{ "hX",            1, SP02_SP02_12, 500  }, // 61:hX
		{ "VÑhX",    1, SP02_SP02_13,2000  }, // 62:VÑhX
		{ "؂ȃhX",      1, SP02_SP02_14,3000  }, // 63:؂ȃhX
		{ "p",            1, SP02_SP02_16, 600  }, // 64:p
		{ "pt̐",      1, SP02_SP02_17, 800  }, // 65:pt̐
		{ "Ch",          1, 0,4000  }, // 66:Ch
		{ "U[X[c",      1, SP02_SP02_20,2000  }, // 67:U[X[c
		{ "C",            1, SP02_SP02_21,1000  }, // 68:C
		{ "sǂ̕",          1, 0,   0  }, // 69:sǂ̕
		{ "pW}",          1, 0,   0  }, // 70:pW}
		{ "EFfBOhX",1, 0,   0  }, // 71:EFfBOhX
		{ "m[X[u",      1, 0, 500  }, // 72:m[X[u
		{ "s[X",        1, 0,2500  }, // 73:s[X
		{ "ƒ",            1, 0, 300  }, // 74:ƒ
		{ "@LǍ",0, 0,5000  }, // 75:@LǍ
		{ "_̕",          0, 0,3000  }, // 76:_̕
		{ "`̍H",        4, 0,1500  }, // 77:`̍H
		{ "KX̌C",        4, 0,1500  }, // 78:KX̌C
		{ "̎",      4, 0,3000  }, // 79:̎
		{ "`̃`",        0, 0,2000  }, // 80:`̃`
		{ "d̗",          4, 0,2000  }, // 81:d̗
		{ "̃hX",        1, 0,4000  }, // 82:̃hX
		{ "P̃hX",      1, 0,4000  }, // 83:P̃hX
		{ "",              3, SP05_SP05_3X, 300  }, // 84:
		{ "P[L",            5, SP03_SP03_3, 100  }, // 85:P[L
		{ "َq",            5, SP03_SP03_2,  50  }, // 86:َq
		{ "tR[X",        5, SP03_SP03_4, 300  }, // 87:tR[X
		{ "F",            3, SP05_SP05_2X,   0  }, // 88:F
		{ "t",              3, SP05_SP05_4X, 100  }, // 89:t
	};
static u8
	g_item_sort_tbl[] = 
	{
		84,		//  0:
		37,		//  1:d̖
		38,		//  2:mb̎
		39,		//  3:h̉ʎ
		40,		//  4:̎
		41,		//  5:MȂ
		42,		//  6:₳̋ʘI
		43,		//  7:|p̐
		44,		//  8:f̍
		45,		//  9:炩Ȏt
		46,		// 10:_̍
		47,		// 11:V̍
		48,		// 12:d̂
		49,		// 13:_
		50,		// 14:E̐
		51,		// 15:֒f̎

		58,		// 16:i
		59,		// 17:ĕ
		60,		// 18:~
		61,		// 19:hX
		62,		// 20:VÑhX
		63,		// 21:؂ȃhX
		64,		// 22:p
		65,		// 23:pt̐
		67,		// 24:U[X[c
		68,		// 25:C
		66,		// 26:Ch
		57,		// 27:X̃[u
		69,		// 28:sǂ̕
		70,		// 29:pW}
		71,		// 30:EFfBOhX
		72,		// 31:m[X[u
		73,		// 32:s[X
		74,		// 33:ƒ
		82,		// 34:̃hX
		83,		// 35:P̃hX

		13,		// 36:GZbg
		14,		// 37:_XV[Y
		15,		// 38:l`
		16,		// 39:W
		17,		// 40:
		18,		// 41:eB[Jbv
		19,		// 42:ϓ
		20,		// 43:nCq[
		21,		// 44:ٖD
		22,		// 45:@
		23,		// 46:ꂽ
		24,		// 47:p[Xg
		25,		// 48:nJ`
		26,		// 49:C
		27,		// 50:eB[Jbv
		28,		// 51:NM
		29,		// 52:̕
		30,		// 53:}g
		31,		// 54:Z
		32,		// 55:ԑ
		33,		// 56:IS[
		34,		// 57:
		35,		// 58:`
		52,		// 59:L̖ڐ
		53,		// 60:ÂтF
		54,		// 61:Ȃ钤
		55,		// 62:̎w
		56,		// 63:̎
		77,		// 64:`̍H
		78,		// 65:KX̌C
		79,		// 66:̎
		81,		// 67:d̗

		1,		// 68:͋[
		2,		// 69:S̒
		3,		// 70:~X̌
		4,		// 71:Аn
		5,		// 72:K̏
		6,		// 73:̏
		7,		// 74:~X̏
		80,		// 75:`̃`
		76,		// 76:_̕
		75,		// 77:@LǍ
		8,		// 78:̊Z 
		9,		// 79:S̊Z
		10,		// 80:~X̊Z
		11,		// 81:VN̊Z
		12		// 82:R̖@
	},
	g_church_tbl[] = { 88, 89, 84 },
	g_dress_tbl[] = { 59, 60, 61, 62, 64, 68, 63, 65, 67 },
	g_tool_tbl[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24 },
	g_atool_tbl[] = { 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47 },
	g_orc_tbl[] = { 48, 49, 50, 51, 53, 54, 55, 56, 57, 52 },
	g_thief_tbl[] = { 48, 49, 50, 51 },
	g_poor_tbl[] = { 1, 5, 8, 13, 14 },
	g_birth_tbl[] = { 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 32, 33 },
	g_restaurant_tbl[] = { 85, 86, 87 },
	g_poor_label[] = 
	{
		SP07P_SP07P_9,		// ͋[
		SP07P_SP07P_10,		// K̏
		SP07P_SP07P_11,		// ̊Z 
		SP07P_SP07P_12,		// GZbg
		SP07P_SP07P_13,		// _XV[Y
	};
static u16
	g_dress_sample_c[] = 
	{
		_DR_C02_CGBA,
		_DR_C03_CGBA,
		_DR_C04_CGBA,
		_DR_C05_CGBA,
		_DR_C07_CGBA,
		_DR_C12_CGBA,
	},
	g_dress_sample_l[] = 
	{
		_DR_L02_CGBA,
		_DR_L03_CGBA,
		_DR_L04_CGBA,
		_DR_L05_CGBA,
		_DR_L07_CGBA,
		_DR_L12_CGBA,
		_DR_L06_CGBA,
		_DR_L08_CGBA,
		_DR_L11_CGBA,
	},
	g_dress_sample_h[] = 
	{
		_DR_H02_CGBA,
		_DR_H03_CGBA,
		_DR_H04_CGBA,
		_DR_H05_CGBA,
		_DR_H07_CGBA,
		_DR_H12_CGBA,
		_DR_H06_CGBA,
		_DR_H08_CGBA,
		_DR_H11_CGBA,
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void Discount(void);
static void setItemInformation(void);
static BOOL selectItem(void);
static BOOL selectDecide(void);
static void selectItems(int, BOOL, BOOL);
static BOOL decideItem(void);
static void waitEatItem(void);
static void mainEatItem(void);
static void endEatItem(void);
static void dressCheck(int, int);
static void listupItem(void);
static void DressConY(void);
static void DressConS(void);
static void checkDressA(void);
static void checkDressB(void);
static void checkDressC(void);
static void item_once(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
//---------------------------------------------------------
// 
//---------------------------------------------------------
void initFirstItem(void)
{
	OS_InitMutex(&g_mutex);
	g_step = ITEM_MODE_NONE;
	g_script_label = -1;
	g_last_label = -1;
	g_dress_num = -1;
}

//---------------------------------------------------------
// ւ
//---------------------------------------------------------
void item_dress(int in_item, BOOL in_flag)
{
	///#cmd{ cmdItemDelete }
	///#m_char{ cDA, 0, efAlpha02s }
	item_dress2(in_item, in_flag);
}

void item_dress2(int in_item, BOOL in_flag)
{
	u8 old_dress;

	old_dress = getDress();
	switch (in_item)
	{
		case 58:
			setDress(1);	//i
			break;
		case 59:
			setDress(2);	//ĕ
			break;
		case 60:
			setDress(3);	//~
			break;
		case 61:
			setDress(4);	//hX
			break;
		case 62:
			setDress(5);	//VÑhX
			break;
		case 63:
			setDress(6);	//؂ȃhX
			break;
		case 64:
			setDress(7);	//p
			break;
		case 65:
			setDress(8);	//pt̐
			break;
		case 67:
			setDress(11);	//U[X[c
			break;
		case 68:
			setDress(12);	//C
			break;
		case 69:
			setDress(15);	//sǕ
			break;
		case 70:
			setDress(16);	//pW}
			break;
		case 57:
			setDress(17);	//X̃[u
			break;
		case 83:
			setDress(18);	//P̃hX
			break;
		case 82:
			setDress(19);	//̃hX
			break;
	}
	updateItem();
	setParamObj();
	if (!in_flag)
	{
		setChaNum(0, cDA0);
		setMessage(0, g_dress_mes[old_dress-1].m_from_len*2, g_dress_mes[old_dress-1].m_from_mes);
		setMessage(1, g_dress_mes[getDress()-1].m_to_len*2, g_dress_mes[getDress()-1].m_to_mes);
		putStartMessage();
		waitScriptMessage();
	}
}
//----------------------------------
// ACeĂ邩`FbN
//----------------------------------
s8 isItem(u8 in_item)
{
	u8 i;

	for (i=0; i<getItemCount(); i++)
	{
		if (getItem(i) == in_item)
			return (s8)i;
	}
	return -1;
}
//----------------------------------
// ACeĂ邩`FbN
//----------------------------------
u8 numItem(u8 in_item)
{
	u8 i, n;

	n = 0;
	for (i=0; i<getItemCount(); i++)
	{
		if (getItem(i) == in_item)
			n++;
	}
	return n;
}
//----------------------------------
// ̎pݒ
//----------------------------------
void funcSetMyDress(void)
{
	int i, p;

	g_sort_count = 0;
	for (i=0; i<83; i++)
	{
		if (g_item_sort_tbl[i] == 57 || g_item_sort_tbl[i] == 61 || g_item_sort_tbl[i] == 62 || g_item_sort_tbl[i] == 63 || g_item_sort_tbl[i] == 82 || g_item_sort_tbl[i] == 83)
		{
			for (p=0; p<getItemCount(); p++)
			{
				if (getItem(p) == g_item_sort_tbl[i])
				{
					g_sort_item[g_sort_count] = g_item_sort_tbl[i];
					g_sort_count++;
				}
			}
		}
	}
	g_price_rate = 100;
	g_script_id = 0;
	g_script_label = -1;
	g_last_label = -1;
	g_select_mode = ITEM_SELECT_DRESS2;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setItemGraph();
	setRoomItem();
}

//----------------------------------
// ̎
//----------------------------------
static void listupItem(void)
{
	int i, p;

	g_sort_count = 0;
	for (i=0; i<83; i++)
	{
		for (p=0; p<getItemCount(); p++)
		{
			if (getItem(p) == g_item_sort_tbl[i])
			{
				g_sort_item[g_sort_count] = g_item_sort_tbl[i];
				g_sort_count++;
			}
		}
	}
}
//----------------------------------
// ̎pݒ
//----------------------------------
void funcSetMyItem(void)
{
	listupItem();
	g_price_rate = 100;
	g_script_id = 0;
	g_script_label = -1;
	g_last_label = -1;
	g_select_mode = ITEM_SELECT_LOOK;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setItemGraph();
	setRoomItem();
}

//----------------------------------
// ACep̐ݒ
//ifuncSetMyItemƂ̈Ⴂ́AzȂj
//----------------------------------
void funcSetSellItem(void)
{
	listupItem();
	g_price_rate = 50;
	g_script_id = _SP01_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_select_mode = ITEM_SELECT_SELL;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopSellGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}


//----------------------------------
// ̐ݒ
//----------------------------------
void funcSetChurchShop(void)
{
	int i;

	for (i=0; i<3; i++)
		g_sort_item[i] = g_church_tbl[i];
	g_sort_count = 3;
	g_price_rate = 100;
	g_script_id = _SP05_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP05_SP05_6;
	g_buy_label = -1;
	g_already_label = -1;
	g_select_mode = ITEM_SELECT_CHURCH;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// miX̐ݒ
//----------------------------------
void funcSetDressShop(void)
{
	int i;

	if (getageWidth() >= ageL)
		g_sort_count = 9;
	else
		g_sort_count = 6;
	for (i=0; i<g_sort_count; i++)
		g_sort_item[i] = g_dress_tbl[i];
	Discount();
	g_script_id = _SP02_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP02_SP02_4;
	if (g_price_rate != 100)
		g_buy_label = SP02_SP02_5;	// w̑䎌ȉꍇj
	else
		g_buy_label = SP02_SP02_2;	// w̑䎌
	g_already_label = SP02_SP02_ITEM_ALREADY;	// PĂȂACẽ`FbN
	g_select_mode = ITEM_SELECT_DRESS;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// ̐ݒ
//----------------------------------
void funcSetToolShop(void)
{
	int i;

	for (i=0; i<24; i++)
		g_sort_item[i] = g_tool_tbl[i];
	g_sort_count = 24;
	Discount();
	g_script_id = _SP01_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP01_SP01_4;
	if (g_price_rate != 100)
		g_buy_label = SP01_SP01_5;	// w̑䎌ȉꍇj
	else
		g_buy_label = SP01_SP01_2;	// w̑䎌
	g_already_label = SP01_SP01_ITEM_ALREADY;	// PĂȂACẽ`FbN
	g_select_mode = ITEM_SELECT_BUY;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// E̓̐ݒ
//----------------------------------
void funcSetAToolShop(void)
{
	int i;

	for (i=0; i<11; i++)
		g_sort_item[i] = g_atool_tbl[i];
	g_sort_count = 11;
	g_price_rate = 100;
	g_script_id = _SP06_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP06_SP06_4;
	g_buy_label = SP06_SP06_2;
	g_already_label = -1;
	g_select_mode = ITEM_SELECT_BUY;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// `Cj[YI[N
//----------------------------------
void funcSetOrcShop(void)
{
	int i;

	if (isItem(52) == -1 && getLabel(LF_ev030_52) == OFF && getLabel(LF_at03_4) == OFF)
		g_sort_count = 10;
	else
		g_sort_count = 9;
	for (i=0; i<g_sort_count; i++)
		g_sort_item[i] = g_orc_tbl[i];
	g_price_rate = 100;
	g_script_id = _SP07_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP07_SP07_7;
	g_buy_label = SP07_SP07_4;
	g_already_label = SP07_SP07_ALREADY;
	g_select_mode = ITEM_SELECT_BUY;
	g_step = ITEM_MODE_WAIT;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}
//----------------------------------
void funcSetOrcThief(void)
{
	int i;

	g_price_rate = 0;
	for (i=0; i<4; i++)
		g_sort_item[i] = g_thief_tbl[i];
	g_sort_count = 4;
	if (isItem(53) == -1 && getLabel(LF_ev030_53) == OFF)
	{
		g_sort_item[g_sort_count] = 53;
		g_sort_count++;
	}
	if (isItem(54) == -1 && getLabel(LF_ev030_54) == OFF)
	{
		g_sort_item[g_sort_count] = 54;
		g_sort_count++;
	}
	if (isItem(55) == -1 && getLabel(LF_ev030_55) == OFF)
	{
		g_sort_item[g_sort_count] = 55;
		g_sort_count++;
	}
	if (isItem(56) == -1 && getLabel(LF_ev030_56) == OFF)
	{
		g_sort_item[g_sort_count] = 56;
		g_sort_count++;
	}
	if (isItem(57) == -1 && getLabel(LF_ev030_57) == OFF)
	{
		g_sort_item[g_sort_count] = 57;
		g_sort_count++;
	}
	if (isItem(52) == -1 && getLabel(LF_ev030_52) == OFF && getLabel(LF_at03_4) == OFF)
	{
		g_sort_item[g_sort_count] = 52;
		g_sort_count++;
	}
	g_select_mode = ITEM_SELECT_THIEF;
	g_step = ITEM_MODE_WAIT;
	g_script_id = 0;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = -1;
	g_buy_label = -1;
	g_already_label = -1;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	//putMoneyWindow(TRUE);
}
//----------------------------------
void funcSetOrcPoor(void)
{
	int i;

	for (i=0; i<5; i++)
		g_sort_item[i] = g_poor_tbl[i];
	g_sort_count = 5;
	g_price_rate = 100;
	g_select_mode = ITEM_SELECT_BUY;
	g_step = ITEM_MODE_WAIT;
	g_script_id = _SP07P_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP07P_SP07P_6;
	g_buy_label = SP07P_SP07P_4;
	g_already_label = SP07P_SP07P_ITEM_ALREADY;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// i̒aj
//----------------------------------
void funcSetBirthdayShop(void)
{
	int i;

	for (i=0; i<12; i++)
		g_sort_item[i] = g_birth_tbl[i];
	g_sort_count = 12;
	Discount();
	g_select_mode = ITEM_SELECT_PRESENT;
	g_step = ITEM_MODE_WAIT;
	g_script_id = _SP01_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP01_SP01B_4;
	if (g_price_rate != 100)
		g_buy_label = SP01_SP01B_5;	// w̑䎌ȉꍇj
	else
		g_buy_label = SP01_SP01B_2;	// w̑䎌
	g_already_label = -1;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// Xg
//----------------------------------
void funcSetRestaurant(void)
{
	int i;

	for (i=0; i<3; i++)
		g_sort_item[i] = g_restaurant_tbl[i];
	g_sort_count = 3;
	Discount();
	g_select_mode = ITEM_SELECT_BUY;
	g_step = ITEM_MODE_WAIT;
	g_script_id = _SP03_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = SP03_SP03_7;
	if (g_price_rate != 100)
		g_buy_label = SP03_SP03_8;	// w̑䎌ȉꍇj
	else
		g_buy_label = SP03_SP03_5;	// w̑䎌
	g_already_label = -1;
	g_select_top = 0;
	setItemInformation();
	setShopBuyGraph();
	setRoomItem();
	putMoneyWindow(TRUE);
}

//----------------------------------
// 
//----------------------------------
void funcSetWeapon(void)
{
	g_sort_count = 0;
	// ͋[
	if (isItem(1) != -1)
	{
		g_sort_item[g_sort_count] = 1;
		g_sort_count++;
	}
	// S̒
	if (isItem(2) != -1)
	{
		g_sort_item[g_sort_count] = 2;
		g_sort_count++;
	}
	// ~X̌
	if (isItem(3) != -1)
	{
		g_sort_item[g_sort_count] = 3;
		g_sort_count++;
	}
	// Аn
	if (isItem(4) != -1)
	{
		g_sort_item[g_sort_count] = 4;
		g_sort_count++;
	}
	// K̏
	if (isItem(5) != -1)
	{
		g_sort_item[g_sort_count] = 5;
		g_sort_count++;
	}
	// ̏
	if (isItem(6) != -1)
	{
		g_sort_item[g_sort_count] = 6;
		g_sort_count++;
	}
	// ~X̏
	if (isItem(7) != -1)
	{
		g_sort_item[g_sort_count] = 7;
		g_sort_count++;
	}
	// @LǍ
	if (isItem(75) != -1)
	{
		g_sort_item[g_sort_count] = 75;
		g_sort_count++;
	}
	// _̕
	if (isItem(76) != -1)
	{
		g_sort_item[g_sort_count] = 76;
		g_sort_count++;
	}
	// `̃`
	if (isItem(80) != -1)
	{
		g_sort_item[g_sort_count] = 80;
		g_sort_count++;
	}
	g_price_rate = 0;

	g_select_mode = ITEM_SELECT_HAR;
	g_step = ITEM_MODE_WAIT;
	g_script_id = _FE01_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = -1;
	g_buy_label = -1;		// w̑䎌
	g_already_label = -1;
	g_select_top = 0;
	setItemInformation();
	setItemGraph();
	setRoomItem();
}
//----------------------------------
// h
//----------------------------------
void funcSetArmor(void)
{
	g_sort_count = 0;
	// ̊Z 
	if (isItem(8) != -1)
	{
		g_sort_item[g_sort_count] = 8;
		g_sort_count++;
	}
	// S̊Z
	if (isItem(9) != -1)
	{
		g_sort_item[g_sort_count] = 9;
		g_sort_count++;
	}
	// ~X̊Z
	if (isItem(10) != -1)
	{
		g_sort_item[g_sort_count] = 10;
		g_sort_count++;
	}
	// VN̊Z
	if (isItem(11) != -1)
	{
		g_sort_item[g_sort_count] = 11;
		g_sort_count++;
	}
	// R̖@
	if (isItem(12) != -1)
	{
		g_sort_item[g_sort_count] = 12;
		g_sort_count++;
	}
	g_price_rate = 0;

	g_select_mode = ITEM_SELECT_HAR;
	g_step = ITEM_MODE_WAIT;
	g_script_id = _FE01_PSC;
	g_script_label = -1;
	g_last_label = -1;
	g_nomoney_label = -1;
	g_buy_label = -1;		// w̑䎌
	g_already_label = -1;
	g_select_top = 0;
	setItemInformation();
	setItemGraph();
	setRoomItem();
}


//----------------------------------
// 
//----------------------------------
static void Discount(void)
{
	if (getParam(pCHIMEI) == 999)
		g_price_rate = 50;
	else
	if (getParam(pCHIMEI) > 899)
		g_price_rate = 55;
	else
	if (getParam(pCHIMEI) > 799)
		g_price_rate = 60;
	else
	if (getParam(pCHIMEI) > 699)
		g_price_rate = 65;
	else
	if (getParam(pCHIMEI) > 599)
		g_price_rate = 70;
	else
	if (getParam(pCHIMEI) > 499)
		g_price_rate = 75;
	else
	if (getParam(pCHIMEI) > 399)
		g_price_rate = 80;
	else
	if (getParam(pCHIMEI) > 299)
		g_price_rate = 85;
	else
	if (getParam(pCHIMEI) > 199)
		g_price_rate = 90;
	else
	if (getParam(pCHIMEI) > 99)
		g_price_rate = 95;
	else
		g_price_rate = 100;
}

//----------------------------------
// ACe
//----------------------------------
BOOL isEndItemSelect(void)
{
	BOOL result;

	result = FALSE;
	switch (g_step)
	{
		case ITEM_MODE_WAIT:
			if (!isChangeSubGraph())
			{
				g_select = -1;
				g_item_select = -1;
				g_key_use = FALSE;
				g_key_decide = FALSE;
				g_key_select = 0;
				g_step = ITEM_MODE_MAIN;
			}
			break;

		case ITEM_MODE_MAIN:
			result = selectItem();
			break;

		case ITEM_MODE_DECIDE:
			result = decideItem();
			break;

		case ITEM_MODE_EAT_WAIT:		// XgEp[^\
			waitEatItem();
			break;

		case ITEM_MODE_EAT_MAIN:		// XgEp[^ω
			mainEatItem();
			break;

		case ITEM_MODE_EAT_END:			// Xg
			endEatItem();
			break;

		case ITEM_MODE_SCRIPT_WAIT:		// XNvgX
			if (isEndScriptThread())
				g_step = ITEM_MODE_MAIN;
			break;
	}
	return result;
}

//----------------------------------
// ACe𑗂
//----------------------------------
static void setItemInformation(void)
{
	int i, n;

	for (i=0; i<5; i++)
	{
		if (g_select_top + i < g_sort_count)
		{
			n = g_sort_item[g_select_top + i];
			setItemInfo((u8)i, (u8)g_item_info[n].m_kind, g_item_info[n].m_name, (u16)((g_item_info[n].m_price * g_price_rate) / 100));
		} else
			resetItemInfo((u8)i);
	}
}

//----------------------------------
// ACeIC
//----------------------------------
static BOOL selectItem(void)
{
	u16 m, x, y, pad;

	getTouchPen(&m, &x, &y);
	pad = getPadRep();

	if (m == TOUCH_PEN_UP)
	{
		// 
		if (g_select == -1)
		{
			
			
		} else
		if (g_select == 0)
		{
			// 
			playSE(SE_03);
			g_item_select = -1;
			if (g_select_mode != ITEM_SELECT_HAR)
			{
				g_step = ITEM_MODE_NONE;
				return TRUE;
			}
		} else
		if (g_select == 2)
		{
			// J[\
			playSE(SE_04);
			if (g_select_top >= 5)
				g_select_top -= 5;
			else
				g_select_top = 0;
			setItemInformation();
			if (g_select_top+g_item_select >= g_sort_count)
				g_item_select = -1;
			if (g_select_mode == ITEM_SELECT_BUY || g_select_mode == ITEM_SELECT_DRESS || g_select_mode == ITEM_SELECT_PRESENT || g_select_mode == ITEM_SELECT_CHURCH)
			{
				OS_LockMutex(&g_mutex);
				if (g_script_id == _SP07P_PSC)
					g_script_label = g_poor_label[g_select_top+g_item_select];
				else
				if (g_script_id != 0 && g_item_select != -1)
					g_script_label = g_item_info[g_sort_item[g_select_top+g_item_select]].m_label;
				OS_UnlockMutex(&g_mutex);
			}
			if (g_select_mode == ITEM_SELECT_DRESS)
			{
				if (g_item_select != -1)
				{
					if (getageWidth() == ageC)
						putDressSample(g_dress_sample_c[g_select_top+g_item_select]);
					else
					if (getageWidth() == ageL)
						putDressSample(g_dress_sample_l[g_select_top+g_item_select]);
					else
					if (getageWidth() == ageH)
						putDressSample(g_dress_sample_h[g_select_top+g_item_select]);
				} else {
					clearDressSample();
				}
			}
			setItemObj(-1, g_item_select, FALSE, FALSE);
			g_select = -1;
		} else
		if (g_select == 3)
		{
			// J[\
			playSE(SE_04);
			g_select_top += 5;
			if (g_select_top + 5 > g_sort_count)
			{
				if (g_sort_count - 5 < 0)
					g_select_top = 0;
				else
					g_select_top = (u8)(g_sort_count - 5);
			}
			setItemInformation();
			if (g_select_top+g_item_select >= g_sort_count)
				g_item_select = -1;
			if (g_select_mode == ITEM_SELECT_BUY || g_select_mode == ITEM_SELECT_DRESS || g_select_mode == ITEM_SELECT_PRESENT || g_select_mode == ITEM_SELECT_CHURCH)
			{
				OS_LockMutex(&g_mutex);
				if (g_script_id == _SP07P_PSC)
					g_script_label = g_poor_label[g_select_top+g_item_select];
				else
				if (g_script_id != 0 && g_item_select != -1)
					g_script_label = g_item_info[g_sort_item[g_select_top+g_item_select]].m_label;
				OS_UnlockMutex(&g_mutex);
			}
			if (g_select_mode == ITEM_SELECT_DRESS)
			{
				if (g_item_select != -1)
				{
					if (getageWidth() == ageC)
						putDressSample(g_dress_sample_c[g_select_top+g_item_select]);
					else
					if (getageWidth() == ageL)
						putDressSample(g_dress_sample_l[g_select_top+g_item_select]);
					else
					if (getageWidth() == ageH)
						putDressSample(g_dress_sample_h[g_select_top+g_item_select]);
				} else {
					clearDressSample();
				}
			}
			setItemObj(-1, g_item_select, FALSE, FALSE);
			g_select = -1;
		} else
		if (g_select == 1)
		{
			// wEp
			if (selectDecide())
				return TRUE;
		} else
		if (g_select_mode == ITEM_SELECT_LOOK || g_select_mode == ITEM_SELECT_DRESS2 || g_select_mode == ITEM_SELECT_HAR)
		{
			if (selectDecide())
				return TRUE;
		}
	} else
	if (m == TOUCH_PEN_DOWN || m == TOUCH_PEN_DRAG)
	{
		if (g_key_use)
		{
			// L[쒆ȂNA
			setItemObj(-1, g_item_select, FALSE, FALSE);
			g_key_use = FALSE;
			g_key_decide = FALSE;
		}
		if (x >= 189 && x < 189+51 && y >= 163 && y < 163+20 && g_select_mode != ITEM_SELECT_DRESS2)
		{
			// 
			if (g_select != 0)
			{
				playSE(SE_01);
				//clearMessage();
				setItemObj(0, g_item_select, FALSE, FALSE);
				g_select = 0;
			}
		} else
		if (x >= 16 && x < 16+51 && y >= 163 && y < 163+20 && g_item_select != -1)
		{
			// wEp
			if (g_select != 1)
			{
				playSE(SE_01);
				//clearMessage();
				setItemObj(1, g_item_select, FALSE, FALSE);
				g_select = 1;
			}
		} else
		if (x >= 112 && x < 112+32 && y >= 0 && y < 0+24 && g_select_top > 0)
		{
			// J[\
			if (g_select != 2)
			{
				playSE(SE_01);
				setItemObj(-1, g_item_select, TRUE, FALSE);
				g_select = 2;
			}
		} else
		if (x >= 112 && x < 112+32 && y >= 160 && y < 160+24 && g_select_top + 5 < g_sort_count)
		{
			// J[\
			if (g_select != 3)
			{
				playSE(SE_01);
				setItemObj(-1, g_item_select, FALSE, TRUE);
				g_select = 3;
			}
		} else
		if (x >= 48 && x < 48+184 && y >= 24 && y < 24+24)
		{
			// ڂP
			g_select = 4;
			selectItems(0, FALSE, FALSE);
		} else
		if (x >= 48 && x < 48+184 && y >= 52 && y < 52+24)
		{
			// ڂQ
			g_select = 4;
			selectItems(1, FALSE, FALSE);
		} else
		if (x >= 48 && x < 48+184 && y >= 80 && y < 80+24)
		{
			// ڂR
			g_select = 4;
			selectItems(2, FALSE, FALSE);
		} else
		if (x >= 48 && x < 48+184 && y >= 108 && y < 108+24)
		{
			// ڂS
			g_select = 4;
			selectItems(3, FALSE, FALSE);
		} else
		if (x >= 48 && x < 48+184 && y >= 136 && y < 136+24)
		{
			// ڂT
			g_select = 4;
			selectItems(4, FALSE, FALSE);
		} else
		if (g_select != -1)
		{
			//clearMessage();
			setItemObj(-1, g_item_select, FALSE, FALSE);
			g_select = -1;
		}
	} else
	// ^b`yŐGĂȂAL[̓͂󂯕t
	if (!g_key_use)
	{
		// L[͂܂sĂȂ
		if (pad & PAD_BUTTON_B && g_select_mode != ITEM_SELECT_DRESS2)
		{
			// 
			playSE(SE_03);
			g_step = ITEM_MODE_NONE;
			g_item_select = -1;
			return TRUE;
		} else
		if (g_sort_count > 0 && pad & (PAD_KEY_UP|PAD_KEY_DOWN|PAD_KEY_LEFT|PAD_KEY_RIGHT|PAD_BUTTON_A|PAD_BUTTON_L|PAD_BUTTON_R))
		{
			g_key_use = TRUE;
			if (g_select_top + g_key_select >= g_sort_count)
			{
				g_key_select = (u8)(g_sort_count - g_select_top - 1);
				while (g_key_select >= 5)
				{
					g_key_select -= 5;
					g_select_top -= 5;
				}
			}
			playSE(SE_01);
			selectItems(g_key_select, TRUE, TRUE);
		}
	} else {
		if (pad & PAD_BUTTON_A && g_item_select != -1)
		{
			if (!g_key_decide && g_select_mode != ITEM_SELECT_LOOK && g_select_mode != ITEM_SELECT_DRESS2 && g_select_mode != ITEM_SELECT_HAR)
			{
				playSE(SE_02);
				g_key_decide = TRUE;
				selectItems(g_key_select, TRUE, TRUE);
			} else
			if (selectDecide())
				return TRUE;
		} else
		if (pad & PAD_BUTTON_B && g_select_mode != ITEM_SELECT_DRESS2 && g_select_mode != ITEM_SELECT_HAR)
		{
			// 
			if (!g_key_decide)
			{
				playSE(SE_03);
				g_step = ITEM_MODE_NONE;
				g_item_select = -1;
				return TRUE;
			} else {
				playSE(SE_03);
				g_key_decide = FALSE;
				selectItems(g_key_select, TRUE, TRUE);
			}
		} else
		if (pad & PAD_KEY_UP)
		{
			g_key_decide = FALSE;
			if (g_key_select <= 1 && g_select_top > 0)
			{
				g_select_top--;
				setItemInformation();
				g_item_select = -1;
			} else
			if (g_key_select > 0)
			{
				g_key_select--;
			}
			selectItems(g_key_select, TRUE, TRUE);
		} else
		if (pad & PAD_KEY_DOWN)
		{
			g_key_decide = FALSE;
			if (g_key_select >= 3 && g_select_top + 5 < g_sort_count)
			{
				g_select_top++;
				setItemInformation();
				g_item_select = -1;
			} else
			if (g_key_select < 5)
			{
				if (g_select_top + g_key_select < g_sort_count - 1)
					g_key_select++;
			}
			selectItems(g_key_select, TRUE, TRUE);
		} else
		if (pad & (PAD_KEY_LEFT|PAD_BUTTON_L) && g_select_top > 0)
		{
			g_key_decide = FALSE;
			if (g_select_top < 5)
				g_select_top = 0;
			else
				g_select_top -= 5;
			setItemInformation();
			g_item_select = -1;
			selectItems(g_key_select, TRUE, TRUE);
		} else
		if (pad & (PAD_KEY_RIGHT|PAD_BUTTON_R) && g_select_top + 5 < g_sort_count)
		{
			g_key_decide = FALSE;
			g_select_top += 5;
			if (g_select_top + 5 >= g_sort_count)
				g_select_top = (u8)(g_sort_count - 5);
			setItemInformation();
			g_item_select = -1;
			selectItems(g_key_select, TRUE, TRUE);
		}
		
		
		
		
	}
	return FALSE;
}
//----------------------------------
// ACeICp
//----------------------------------
static BOOL selectDecide(void)
{
	// Z̓_
	if (isChangeGold())
		return FALSE;
	// wEp
	g_no_flag = 0;
	if (g_select_mode == ITEM_SELECT_BUY || g_select_mode == ITEM_SELECT_DRESS || g_select_mode == ITEM_SELECT_PRESENT)
	{
		if (getItemCount() >= 99)
		{
			playSE(SE_02);
			g_step = ITEM_MODE_NONE;
			return TRUE;
		} else
		if (getGold() >= (g_item_info[getSelectItem()].m_price * g_price_rate) / 100)
		{
			if ((getSelectItem() == 52 || getSelectItem() == 53 || getSelectItem() == 54 || getSelectItem() == 57 || getSelectItem() <= 14 || g_select_mode == ITEM_SELECT_DRESS) && isItem((u8)getSelectItem()) != -1)
			{
				playSE(SE_02);
				OS_LockMutex(&g_mutex);
				g_script_label = g_already_label;
				if (getSelectItem() == 52)
					g_script_label = SP07_SP07_16;
				OS_UnlockMutex(&g_mutex);
				g_no_flag = 1;
			} else {
				if (getOptionSFX() != 0)
					playAdxM(_SE56_AHX);
				OS_LockMutex(&g_mutex);
				g_script_label = g_buy_label;
				OS_UnlockMutex(&g_mutex);
				buyItem();
				if (g_select_mode == ITEM_SELECT_PRESENT)
					g_no_flag = 3;
			}
		} else {
			playSE(SE_03);
			OS_LockMutex(&g_mutex);
			g_script_label = g_nomoney_label;
			OS_UnlockMutex(&g_mutex);
			g_no_flag = 1;
		}
	} else
	if (g_select_mode == ITEM_SELECT_SELL)
	{
		switch (getSelectItem())
		{
			case  1:	// ͋[
			case  2:	// S̒
			case  3:	// ~X̌
			case  4:	// Аn
			case  5:	// K̏
			case  6:	// ̏
			case  7:	// ~X̏
			case  8:	// ̊Z 
			case  9:	// S̊Z
			case 10:	// ~X̊Z
			case 11:	// VN̊Z
			case 12:	// R̖@
			case 13:	// GZbg
			case 14:	// _XV[Y
			case 15:	// l`
			case 16:	// W
			case 17:	// 
			case 18:	// eB[Jbv
			case 19:	// ϓ
			case 20:	// nCq[
			case 21:	// ٖD
			case 22:	// @
			case 23:	// ꂽ
			case 24:	// p[Xg
			case 32:	// ԑ
			case 33:	// IS[
			case 37:	// d̖
			case 38:	// mb̎
			case 39:	// h̉ʎ
			case 40:	// ̎
			case 41:	// MȂ
			case 42:	// ₳̋ʘI
			case 43:	// |p̐
			case 44:	// f̍
			case 45:	// 炩Ȏt
			case 46:	// _̍
			case 47:	// V̍
			case 48:	// d̂
			case 49:	// _
			case 50:	// E̐
			case 51:	// ֒f̎
			case 52:	// L̖ڐ
			case 53:	// ÂтF
			case 54:	// Ȃ钤
			case 55:	// ̎w
			case 56:	// ̎
			case 66:	// Ch
			case 73:	// s[X
			case 74:	// ƒ
			case 75:	// @LǍ
			case 76:	// _̕
			case 77:	// `̍H
			case 78:	// KX̌C
			case 79:	// ̎
			case 80:	// `̃`
			case 81:	// d̗
			case 84:	// 
				if (getOptionSFX() != 0)
					playAdxM(_SE56_AHX);
				OS_LockMutex(&g_mutex);
				g_script_label = SP01_SP01S_0;
				OS_UnlockMutex(&g_mutex);
				sellItem();
				break;
			case 25:	// nJ`
			case 26:	// C
			case 27:	// eB[Jbv
			case 28:	// NM
			case 29:	// ̕
			case 30:	// }g
			case 31:	// Z
			case 34:	// 
			case 35:	// `
			case 36:	// X}C
			case 58:	// i
			case 69:	// sǂ̕
			case 70:	// pW}
			case 71:	// EFfBOhX
				playSE(SE_03);
				OS_LockMutex(&g_mutex);
				g_script_label = SP01_SP01S_1;
				OS_UnlockMutex(&g_mutex);
				break;
			case 57:	// X̃[u
				dressCheck(57, 17);
				break;
			case 59:	// ĕ
				dressCheck(59, 2);
				break;
			case 60:	// ~
				dressCheck(60, 3);
				break;
			case 61:	// hX
				dressCheck(61, 4);
				break;
			case 62:	// VÑhX
				dressCheck(62, 5);
				break;
			case 63:	// ؂ȃhX
				dressCheck(63, 6);
				break;
			case 64:	// p
				dressCheck(64, 7);
				break;
			case 65:	// pt̐
				dressCheck(65, 8);
				break;
			case 67:	// U[X[c
				dressCheck(67, 11);
				break;
			case 68:	// C
				dressCheck(68, 12);
				break;
			case 82:	// ̃hX
				dressCheck(68, 19);
				break;
			case 83:	// P̃hX
				dressCheck(68, 18);
				break;
		}
	} else
	if (g_select_mode == ITEM_SELECT_CHURCH)
	{
		if (getSelectItem() == 88 || getGold() >= (g_item_info[getSelectItem()].m_price * g_price_rate) / 100)
		{
			if (getOptionSFX() != 0)
				playAdxM(_SE56_AHX);
			g_no_flag = 3;
		} else {
			playSE(SE_03);
			OS_LockMutex(&g_mutex);
			g_script_label = g_nomoney_label;
			OS_UnlockMutex(&g_mutex);
			g_no_flag = 1;
		}
	} else
	if (g_select_mode == ITEM_SELECT_THIEF)
	{
		if (getOptionSFX() != 0)
			playAdxM(_SE56_AHX);
		g_no_flag = 3;
	} else
	if (g_select_mode == ITEM_SELECT_DRESS2)
	{
		playSE(SE_02);
		g_no_flag = 3;
	} else
	if (g_select_mode == ITEM_SELECT_LOOK)
	{
		if (g_item_info[getSelectItem()].m_kind == 1)
		{
			if (getcon() == conY)
			{
				setScriptThread(DressConY);
				playSE(SE_02);
				g_no_flag = 4;
			} else
			if (getcon() == conS)
			{
				setScriptThread(DressConS);
				playSE(SE_02);
				g_no_flag = 4;
			} else {
				switch (getSelectItem())
				{
					case 58:	//i
						g_dress_num = 1;
						setScriptThread(checkDressA);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 59:	//ĕ
						g_dress_num = 2;
						setScriptThread(checkDressA);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 60:	//~
						g_dress_num = 3;
						setScriptThread(checkDressA);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 61:	//hX
						g_dress_num = 4;
						setScriptThread(checkDressB);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 62:	//VÑhX
						g_dress_num = 5;
						setScriptThread(checkDressB);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 63:	//؂ȃhX
						g_dress_num = 6;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 64:	//p
						g_dress_num = 7;
						setScriptThread(checkDressA);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 65:	//pt̐
						g_dress_num = 8;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 67:	//U[X[c
						g_dress_num = 11;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 68:	//C
						g_dress_num = 12;
						setScriptThread(checkDressA);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 57:	//X̃[u
						g_dress_num = 17;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 83:	//P̃hX
						g_dress_num = 18;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					case 82:	//̃hX
						g_dress_num = 19;
						setScriptThread(checkDressC);
						playSE(SE_02);
						g_no_flag = 4;
						break;
					default:
						playSE(SE_03);
						return FALSE;
				}
			}
		} else
		if (g_item_info[getSelectItem()].m_kind == 3)
		{
			// ACe̎gp
			setScriptThread(item_once);
			playSE(SE_02);
			g_no_flag = 4;
		}
	} else
	if (g_select_mode == ITEM_SELECT_HAR)
	{
		playSE(SE_02);
		g_no_flag = 3;
	}
	g_count = 40;
	g_step = ITEM_MODE_DECIDE;
	return FALSE;
}
//----------------------------------
static void selectItems(int in_num, BOOL in_up, BOOL in_down)
{
	if (g_item_select != in_num && g_select_top+in_num< g_sort_count)
	{
		playSE(SE_01);
		g_item_select = (s8)in_num;
		if (g_select_mode == ITEM_SELECT_BUY || g_select_mode == ITEM_SELECT_DRESS || g_select_mode == ITEM_SELECT_PRESENT || g_select_mode == ITEM_SELECT_CHURCH)
		{
			OS_LockMutex(&g_mutex);
			if (g_script_id == _SP07P_PSC)
				g_script_label = g_poor_label[g_select_top+in_num];
			else
			if (g_script_id != 0 && g_last_label != g_item_info[g_sort_item[g_select_top+in_num]].m_label)
				g_script_label = g_item_info[g_sort_item[g_select_top+in_num]].m_label;
			OS_UnlockMutex(&g_mutex);
		}
		if (g_select_mode == ITEM_SELECT_DRESS)
		{
			if (in_num != -1)
			{
				if (getageWidth() == ageC)
					putDressSample(g_dress_sample_c[g_select_top+in_num]);
				else
				if (getageWidth() == ageL)
					putDressSample(g_dress_sample_l[g_select_top+in_num]);
				else
				if (getageWidth() == ageH)
					putDressSample(g_dress_sample_h[g_select_top+in_num]);
			} else {
				clearDressSample();
			}
		}
	}
	if (in_up)
	{
		if (g_select_top == 0)
			in_up = FALSE;
	}
	if (in_down)
	{
		if (g_select_top + 5 >= g_sort_count)
			in_down = FALSE;
	}
	if (g_key_decide)
		setItemObj(1, g_item_select, in_up, in_down);
	else
		setItemObj(-1, g_item_select, in_up, in_down);
}
//----------------------------------
// `FbN
//----------------------------------
static void dressCheck(int in_num, int in_dress)
{
	if (numItem((u8)in_num) > 1 || getDress() != in_dress)
	{
		if (getOptionSFX() != 0)
			playAdxM(_SE56_AHX);
		OS_LockMutex(&g_mutex);
		g_script_label = SP01_SP01S_0;
		OS_UnlockMutex(&g_mutex);
		sellItem();
	} else {
		playSE(SE_03);
		OS_LockMutex(&g_mutex);
		g_script_label = SP01_SP01S_2;
		OS_UnlockMutex(&g_mutex);
	}
}

//----------------------------------
// ACeI
//----------------------------------
static BOOL decideItem(void)
{
	s16 item;

	g_count--;
	if (g_count % 8 == 0)
	{
		if (g_key_decide)
			setItemObj(1, g_item_select, FALSE, FALSE);
		else
			setItemObj(-1, g_item_select, FALSE, FALSE);
	} else
	if (g_count % 8 == 4)
	{
		if (g_key_decide)
			setItemObj(1, -1, FALSE, FALSE);
		else
			setItemObj(-1, -1, FALSE, FALSE);
	}
	if (g_count == 0)
	{
		item = getSelectItem();
		g_step = ITEM_MODE_MAIN;
		if (item == 85 || item == 86 || item == 87)
		{
			if (g_key_decide)
				setItemObj(1, -1, FALSE, FALSE);
			else
				setItemObj(-1, -1, FALSE, FALSE);
			setParamGraph();
			g_step = ITEM_MODE_EAT_WAIT;
		} else
		if (g_no_flag == 1)
		{
			g_item_select = -1;
			if (g_key_decide)
				setItemObj(1, -1, FALSE, FALSE);
			else
				setItemObj(-1, -1, FALSE, FALSE);
		} else
		if (g_no_flag == 2)
		{
			g_item_select = -1;
			listupItem();
			if (g_sort_count == 0)
			{
				// ĂȂ
				
				
			}
			//if (g_select_top < g_sort_count && g_select_top > 0)
			//	g_select_top -= 5;
			if (g_select_top + 5 > g_sort_count)
			{
				if (g_sort_count - 5 < 0)
					g_select_top = 0;
				else
					g_select_top = (u8)(g_sort_count - 5);
			}
			setItemInformation();
			if (g_key_decide)
				setItemObj(1, -1, FALSE, FALSE);
			else
				setItemObj(-1, -1, FALSE, FALSE);
		} else
		if (g_no_flag == 3)
		{
			if (g_key_decide)
				setItemObj(1, -1, FALSE, FALSE);
			else
				setItemObj(-1, -1, FALSE, FALSE);
			setParamGraph();
			g_step = ITEM_MODE_NONE;
			return TRUE;
		} else
		if (g_no_flag == 4)
		{
			g_step = ITEM_MODE_SCRIPT_WAIT;
		}
	}
	return FALSE;
}

//----------------------------------
// H
//----------------------------------
static void waitEatItem(void)
{
	s16 item;

	if (!isChangeSubGraph())
	{
		item = getSelectItem();
		if (item == 85)
		{
			addParam(pWeight, 75);
			addParam(pBust, 45);
			addParam(pWaist, 40);
			addParam(pHip, 50);
			setParamUp(pHIROU, -5000);
		} else
		if (item == 86)
		{
			addParam(pWeight, 25);
			addParam(pBust, 26);
			addParam(pWaist, 20);
			addParam(pHip, 25);
			setParamUp(pHIROU, -1000);
		} else
		if (item == 87)
		{
			addParam(pWeight, 80);
			addParam(pBust, 60);
			addParam(pWaist, 40);
			addParam(pHip, 50);
			setParamUp(pHIROU, -10000);
		}
		g_count = 240;
		g_step = ITEM_MODE_EAT_MAIN;
	}
}
//----------------------------------
static void mainEatItem(void)
{
	g_count--;
	if (g_count == 0 || getPadRep() & (PAD_BUTTON_A|PAD_BUTTON_B) || getTouchMode() == TOUCH_PEN_UP)
	{
		setScriptGraph();
		g_step = ITEM_MODE_EAT_END;
	}
}
//----------------------------------
static void endEatItem(void)
{
	if (!isChangeSubGraph())
	{
		setItemInformation();
		setShopBuyGraph();
		g_step = ITEM_MODE_WAIT;
	}
}


//----------------------------------
// ACeI
//----------------------------------
s16 getSelectItem(void)
{
	if (g_item_select == -1)
		return -1;
	return g_sort_item[g_select_top + g_item_select];
}

//----------------------------------
// ACeI҂
//----------------------------------
void waitSelectShop(void)
{
	while (g_step != ITEM_MODE_NONE || isChangeSubGraph())
	{
		if (g_script_label != -1)
		{
			g_last_label = g_script_label;
			OS_LockMutex(&g_mutex);
			setScript(g_script_id, g_script_label);
			g_script_label = -1;
			OS_UnlockMutex(&g_mutex);
			waitScript();
			putStartMessage();
			//putAllMessage();
		}
		OS_Sleep(10);
	}
}

//----------------------------------
// 
//----------------------------------
u16 getPriceRate(void)
{
	return g_price_rate;
}

//----------------------------------
// w
//----------------------------------
void buyItem(void)
{
	if (getSelectItem() != 36 && getSelectItem() != 85 && getSelectItem() != 86 && getSelectItem() != 87)
		addItem((u8)getSelectItem());
	setAddGold(-((g_item_info[getSelectItem()].m_price * g_price_rate) / 100));
}

//----------------------------------
// p
//----------------------------------
void sellItem(void)
{
	deleteItem((u8)getSelectItem());
	setAddGold((g_item_info[getSelectItem()].m_price * g_price_rate) / 100);
	g_no_flag = 2;
}

//----------------------------------
// sǉŒւ
//----------------------------------
static void DressConY(void)
{
	if (getageWidth() == ageC)
	{
		setScript(_ITEM_PSC, ITEM_DRESSCONY_C);
		waitScript();
	} else
	if (getageWidth() == ageL)
	{
		setScript(_ITEM_PSC, ITEM_DRESSCONY_L);
		waitScript();
	} else {
		setScript(_ITEM_PSC, ITEM_DRESSCONY_H);
		waitScript();
	}
}

//----------------------------------
// aCԂŒւoȂ
//----------------------------------
static void DressConS(void)
{
	if (getageWidth() == ageC)
	{
		setScript(_ITEM_PSC, ITEM_DRESSCONS_C);
		waitScript();
	} else
	if (getageWidth() == ageL)
	{
		setScript(_ITEM_PSC, ITEM_DRESSCONS_L);
		waitScript();
	} else {
		setScript(_ITEM_PSC, ITEM_DRESSCONS_H);
		waitScript();
	}
}

//----------------------------------
// ւ`FbN
//----------------------------------
static void checkDressA(void)
{
	if (getDress() == g_dress_num)
	{
		setScript(_ITEM_PSC, ITEM_SAMEDRESS);
		waitScript();
	} else {
		item_dress(getSelectItem(), OFF);
		putMessageWindow(FALSE);
		waitChangeGraph();
	}
}
//----------------------------------
static void checkDressB(void)
{
	if (getDress() == g_dress_num)
	{
		setScript(_ITEM_PSC, ITEM_SAMEDRESS);
		waitScript();
	} else
	if (getBMI() > 249)
	{
		if (getageWidth() == ageC)
		{
			setScript(_ITEM_PSC, ITEM_CHECKFAT_C);
			waitScript();
		} else
		if (getageWidth() == ageL)
		{
			setScript(_ITEM_PSC, ITEM_CHECKFAT_L);
			waitScript();
		} else {
			setScript(_ITEM_PSC, ITEM_CHECKFAT_H);
			waitScript();
		}
	} else {
		item_dress(getSelectItem(), OFF);
		putMessageWindow(FALSE);
		waitChangeGraph();
	}
}
//----------------------------------
static void checkDressC(void)
{
	if (getageWidth() == ageC)
	{
		setScript(_ITEM_PSC, ITEM_DRESSAGE);
		waitScript();
	} else
	if (getageWidth() == ageL && g_dress_num == 17)
	{
		// X̃[u͒Ȃ
		setScript(_ITEM_PSC, ITEM_DRESSAGE);
		waitScript();
	} else
	if (getDress() == g_dress_num)
	{
		setScript(_ITEM_PSC, ITEM_SAMEDRESS);
		waitScript();
	} else
	if (getBMI() > 249)
	{
		if (getageWidth() == ageL)
		{
			setScript(_ITEM_PSC, ITEM_CHECKFAT_L);
			waitScript();
		} else{
			setScript(_ITEM_PSC, ITEM_CHECKFAT_H);
			waitScript();
		}
	}  else {
		item_dress(getSelectItem(), OFF);
		putMessageWindow(FALSE);
		waitChangeGraph();
	}
}

//----------------------------------
// ACe̎gp
//----------------------------------
static void item_once(void)
{
	s32 para[28], i;

	while (g_step != ITEM_MODE_SCRIPT_WAIT)
		OS_Sleep(10);
	setParamGraph();
	waitChangeGraph();

	for (i=0; i<28; i++)
		para[i] = 0;

	if (getOptionSFX() != 0)
		playAdxM(_SE56_AHX);
	switch (getSelectItem())
	{
		case 37:	// d̖
			setParamUp2(pTAIRYOKU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_37);
			waitScript();
			break;
		case 38:	// mb̎
			setParamUp2(pCHIRYOKU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_38);
			waitScript();
			break;
		case 39:	// h̉ʎ
			setParamUp2(pPRIDE, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_39);
			waitScript();
			break;
		case 40:	// ̎
			setParamUp2(pMORAL, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_40);
			waitScript();
			break;
		case 41:	// MȂ
			setParamUp2(pKIHINN, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_41);
			waitScript();
			break;
		case 42:	// ₳̋ʘI
			setParamUp2(pKIDATE, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_42);
			waitScript();
			break;
		case 43:	// |p̐
			setParamUp2(pKANNJYU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_43);
			waitScript();
			break;
		case 44:	// f̍
			setParamUp2(pMIRYOKU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_44);
			waitScript();
			break;
		case 45:	// 炩Ȏt
			setParamUp2(pINGOU, -500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_45);
			waitScript();
			break;
		case 46:	// _̍
			setParamUp2(pBUJYUTU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_46);
			waitScript();
			break;
		case 47:	// V̍
			setParamUp2(pMAJYUTU, 500, pMAZOKU, 300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_47);
			waitScript();
			break;
		case 48:	// d̂
			setParamUp2(pHIROU, -2500, pMAZOKU, -300);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_48);
			waitScript();
			break;
		case 49:	// _
			para[pTAIRYOKU]= -500;
			para[pCHIRYOKU]= -500;
			para[pMIRYOKU] = -500;
			para[pPRIDE]   = -500;
			para[pMORAL]   = -500;
			para[pKIHINN]  = -500;
			para[pKANNJYU] = -500;
			para[pKIDATE]  = -500;
			para[pCHIMEI]  = -500;
			para[pBUJYUTU] = -500;
			para[pMAJYUTU] = -500;
			para[pHIROU]   = -500;
			para[pINGOU]   = -500;
			para[pMAZOKU]  =-3000;
			setParamUpAll(para);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_49);
			waitScript();
			break;
		case 50:	// E̐
			setParamUp2(pHIROU, -1500, pMAZOKU, 1000);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_50);
			waitScript();
			break;
		case 51:	// ֒f̎
			para[pTAIRYOKU]= 500;
			para[pCHIRYOKU]= 500;
			para[pMIRYOKU] = 500;
			para[pPRIDE]   = 500;
			para[pMORAL]   = 500;
			para[pKIHINN]  = 500;
			para[pKANNJYU] = 500;
			para[pKIDATE]  = 500;
			para[pCHIMEI]  = 500;
			para[pBUJYUTU] = 500;
			para[pMAJYUTU] = 500;
			para[pHIROU]   = 500;
			para[pINGOU]   = 500;
			para[pMAZOKU]  =1500;
			setParamUpAll(para);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_51);
			waitScript();
			break;
		case 84:	// 
			setParamUp2(pMORAL, 500, pMAZOKU, -500);
			setScript(_ITEM_PSC, ITEM_ITEM_ONCE_84);
			waitScript();
			break;
		default:
			;
	}
	putMessageWindow(FALSE);
	deleteItem((u8)getSelectItem());
	setScriptGraph();
	waitChangeGraph();
	listupItem();
	setItemInformation();
	setItemGraph();
	waitChangeGraph();
	if (g_key_decide)
		setItemObj(1, g_item_select, FALSE, FALSE);
	else
		setItemObj(-1, g_item_select, FALSE, FALSE);
}
