//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "sound_data.h"
#include "game.h"
#include "graph.h"
#include "prime4.h"
#include "room.h"
#include "event_grp.h"
#include "script.h"
#include "m00.h"
#include "schedule.h"
#include "item.h"
#include "sp01.h"
#include "def/room_def.h"
#include "def/tk01_def.h"
#include "def/tk02_def.h"
#include "def/tk04_def.h"
#include "def/tk05_def.h"
#include "def/tk06_def.h"
#include "def/tk07_def.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define ROOM_MODE_INIT						0		// 
#define ROOM_MODE_WAIT						1		// \҂
#define ROOM_MODE_SCRIPT					2		// XNvg҂
#define ROOM_MODE_MENU_WAIT					3		// [j[\҂
#define ROOM_MODE_MENU_MAIN					4		// [j[
#define ROOM_MODE_SCHEDULE_SET_WAIT			5		// XPW[ݒ҂
#define ROOM_MODE_SCHEDULE_WAIT				6		// XPW[s҂
#define ROOM_MODE_STATUS					7		// Xe[^X\
#define ROOM_MODE_SYSTEM_SCRIPT				8		// XNvg҂
#define ROOM_MODE_SYSTEM_MENU_WAIT			9		// Tuj[\҂
#define ROOM_MODE_SYSTEM_MENU_MAIN			10		// Tuj[
#define ROOM_MODE_SYSTEM_MENU_DECIDE		11		// Tuj[
#define ROOM_MODE_SYSTEM_MENU_DIALOG_WAIT	12		// Tuj[_CAO
#define ROOM_MODE_SYSTEM_MENU_DIALOG_MAIN	13		// Tuj[_CAO
#define ROOM_MODE_SYSTEM_MENU_DIALOG_DECIDE	14		// Tuj[_CAO
#define ROOM_MODE_HEALTH_SCRIPT				15		// XNvg҂
#define ROOM_MODE_HEALTH_MENU_WAIT			16		// Tuj[\҂
#define ROOM_MODE_HEALTH_MENU_MAIN			17		// Tuj[
#define ROOM_MODE_HEALTH_MENU_DECIDE		18		// Tuj[
#define ROOM_MODE_TALK_SCRIPT				19		// XNvg҂
#define ROOM_MODE_TALK_MENU_WAIT			20		// Tuj[\҂
#define ROOM_MODE_TALK_MENU_MAIN			21		// Tuj[
#define ROOM_MODE_TALK_MENU_DECIDE			22		// Tuj[
#define ROOM_MODE_SAVELOAD_WAIT				23		// Z[u[h\҂
#define ROOM_MODE_SAVELOAD_MAIN				24		// Z[u[hI
#define ROOM_MODE_SAVE_DIALOG_WAIT			25		// Z[u_CAO
#define ROOM_MODE_SAVE_DIALOG_MAIN			26		// Z[u_CAO
#define ROOM_MODE_SAVE_DIALOG_DECIDE		27		// Z[u_CAO
#define ROOM_MODE_LOAD_DIALOG_WAIT			28		// [h_CAO
#define ROOM_MODE_LOAD_DIALOG_MAIN			29		// [h_CAO
#define ROOM_MODE_LOAD_DIALOG_DECIDE		30		// [h_CAO
#define ROOM_MODE_ITEM_SCRIPT				31		// XNvg҂
#define ROOM_MODE_ITEM_WAIT					32		// ACeʏ҂
#define ROOM_MODE_ITEM_MAIN					33		// ACeI
#define ROOM_MODE_SHOP_SCRIPT				34		// XNvg҂
#define ROOM_MODE_SHOP_MENU_WAIT			35		// Tuj[\҂
#define ROOM_MODE_SHOP_MENU_MAIN			36		// Tuj[
#define ROOM_MODE_SHOP_MENU_DECIDE			37		// Tuj[
#define ROOM_MODE_OPTION_MENU_WAIT			38		// Tuj[\҂
#define ROOM_MODE_OPTION_MENU_MAIN			39		// Tuj[
#define ROOM_MODE_OPTION_MENU_DECIDE		40		// Tuj[
#define ROOM_MODE_TALK_SCRIPT_WAIT			41		// ^b`XNvg҂
#define ROOM_MODE_TOUCH_MAIN				42		// ^b`
#define ROOM_MODE_TOUCH_SCRIPT				43		// ^b`XNvg҂
#define ROOM_MODE_BATTLE_MAIN				44		// ogI
#define ROOM_MODE_BATTLE_DECIDE				45		// ogI

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_load_screen,
	g_option_screen,
	g_touch_help;
static u8
	g_step,
	g_step_backup,
	g_count,
	g_decide,
	g_page,
	g_page_max,
	g_saveload_max,
	g_saveload,
	g_save_num;
static s16
	g_wait;
static SAVE_INFO
	*g_save_info;


static u16
	g_touch_table[3][3][5] = 
	{
		{
			{ ROOM_TOUCH_HEAD_NC, ROOM_TOUCH_FACE_NC, ROOM_TOUCH_BUST_NC, ROOM_TOUCH_WAIST_NC, ROOM_TOUCH_FOOT_NC },
			{ ROOM_TOUCH_HEAD_YC, ROOM_TOUCH_FACE_YC, ROOM_TOUCH_BUST_YC, ROOM_TOUCH_WAIST_YC, ROOM_TOUCH_FOOT_YC },
			{ ROOM_TOUCH_HEAD_SC, ROOM_TOUCH_FACE_SC, ROOM_TOUCH_BUST_SC, ROOM_TOUCH_WAIST_SC, ROOM_TOUCH_FOOT_SC }
		}, {
			{ ROOM_TOUCH_HEAD_NL, ROOM_TOUCH_FACE_NL, ROOM_TOUCH_BUST_NL, ROOM_TOUCH_WAIST_NL, ROOM_TOUCH_FOOT_NL },
			{ ROOM_TOUCH_HEAD_YL, ROOM_TOUCH_FACE_YL, ROOM_TOUCH_BUST_YL, ROOM_TOUCH_WAIST_YL, ROOM_TOUCH_FOOT_YL },
			{ ROOM_TOUCH_HEAD_SL, ROOM_TOUCH_FACE_SL, ROOM_TOUCH_BUST_SL, ROOM_TOUCH_WAIST_SL, ROOM_TOUCH_FOOT_SL }
		}, {
			{ ROOM_TOUCH_HEAD_NH, ROOM_TOUCH_FACE_NH, ROOM_TOUCH_BUST_NH, ROOM_TOUCH_WAIST_NH, ROOM_TOUCH_FOOT_NH },
			{ ROOM_TOUCH_HEAD_YH, ROOM_TOUCH_FACE_YH, ROOM_TOUCH_BUST_YH, ROOM_TOUCH_WAIST_YH, ROOM_TOUCH_FOOT_YH },
			{ ROOM_TOUCH_HEAD_SH, ROOM_TOUCH_FACE_SH, ROOM_TOUCH_BUST_SH, ROOM_TOUCH_WAIST_SH, ROOM_TOUCH_FOOT_SH }
		}
	};




// -------------------------------------
// [J֐`
// -------------------------------------
static void initRoomScreen(void);
static void waitRoom(void);
static void scriptRoom(void);
static void waitRoomMenu(void);
static void mainRoomMenu(void);
static void mainRoomSystemMenu(void);
static void decideRoomSystemMenu(void);
static void dialogRoomSystemMenuWait(void);
static void dialogRoomSystemMenu(void);
static void dialogRoomSystemMenuDecide(void);
static void mainRoomHealthMenu(void);
static void decideRoomHealthMenu(void);
static void mainRoomTalkMenu(void);
static void decideRoomTalkMenu(void);
static void mainRoomTouch(void);
static void mainRoomStatus(void);
static void waitSaveLoad(void);
static void mainSaveLoad(void);
static void dialogRoomSaveLoadWait(void);
static void dialogRoomSaveLoad(void);
static void dialogRoomSaveLoadDecide(void);
static void mainRoomShopMenu(void);
static void decideRoomShopMenu(void);
static void selectItem(void);
static void selectBattle(void);
static void decideBattle(void);
static void mainRoomOptionMenu(void);
static void decideRoomOptionMenu(void);
static void room_loop(void);
static void room_system(void);
static void room_health(void);
static void room_health_end(void);
static void room_shop(void);
static void room_talk(void);
static void room_item(void);
static void tk01(void);
static void tk04(void);
static void tk05(void);
static void tk06(void);
static void tk07(void);
static void AisatuParamChange(void);
static void YasasikuParamChange(void);
static void KibishikuParamChange(void);
static void oKodukaiParamChange(void);
static void touchGuide(void);
static void touchMessage(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initRoom(void)
{
	g_step = ROOM_MODE_INIT;
	g_touch_help = TRUE;
	g_save_info = NULL;
}

// -------------------------------------
//  C
// -------------------------------------
void execRoom(void)
{
	u8 result;

	switch (g_step)
	{
		case ROOM_MODE_INIT:
			initRoomScreen();
			break;
		case ROOM_MODE_WAIT:
			waitRoom();
			break;
		case ROOM_MODE_SCRIPT:
		case ROOM_MODE_SYSTEM_SCRIPT:
		case ROOM_MODE_HEALTH_SCRIPT:
		case ROOM_MODE_TALK_SCRIPT:
		case ROOM_MODE_ITEM_SCRIPT:
		case ROOM_MODE_SHOP_SCRIPT:
		case ROOM_MODE_TALK_SCRIPT_WAIT:
		case ROOM_MODE_TOUCH_SCRIPT:
			scriptRoom();
			break;
		case ROOM_MODE_MENU_WAIT:
		case ROOM_MODE_SYSTEM_MENU_WAIT:
		case ROOM_MODE_HEALTH_MENU_WAIT:
		case ROOM_MODE_TALK_MENU_WAIT:
		case ROOM_MODE_SHOP_MENU_WAIT:
		case ROOM_MODE_OPTION_MENU_WAIT:
			waitRoomMenu();
			break;
		case ROOM_MODE_MENU_MAIN:
			mainRoomMenu();
			break;
		case ROOM_MODE_SYSTEM_MENU_MAIN:
			mainRoomSystemMenu();
			break;
		case ROOM_MODE_SYSTEM_MENU_DECIDE:
			decideRoomSystemMenu();
			break;
		case ROOM_MODE_SYSTEM_MENU_DIALOG_WAIT:
			dialogRoomSystemMenuWait();
			break;
		case ROOM_MODE_SYSTEM_MENU_DIALOG_MAIN:
			dialogRoomSystemMenu();
			break;
		case ROOM_MODE_SYSTEM_MENU_DIALOG_DECIDE:
			dialogRoomSystemMenuDecide();
			break;
		case ROOM_MODE_HEALTH_MENU_MAIN:
			mainRoomHealthMenu();
			break;
		case ROOM_MODE_HEALTH_MENU_DECIDE:
			decideRoomHealthMenu();
			break;
		case ROOM_MODE_TALK_MENU_MAIN:
			mainRoomTalkMenu();
			break;
		case ROOM_MODE_TALK_MENU_DECIDE:
			decideRoomTalkMenu();
			break;
		case ROOM_MODE_TOUCH_MAIN:
			mainRoomTouch();
			break;
		case ROOM_MODE_SHOP_MENU_MAIN:
			mainRoomShopMenu();
			break;
		case ROOM_MODE_SHOP_MENU_DECIDE:
			decideRoomShopMenu();
			break;
		case ROOM_MODE_SCHEDULE_SET_WAIT:
			result = mainScheduleSet();
			if (result == 1)
			{
				// Zbgs
				initSchedule();
				g_step = ROOM_MODE_SCHEDULE_WAIT;
			} else
			if (result == 2 || result == 4)
			{
				// Zbg̃LZ
				putDateWindow(TRUE);
				setMenuGraph();
				g_step = ROOM_MODE_MENU_WAIT;
			} else
			if (result == 3)
			{
				// ΂ꂽ
				setScriptThread(room_loop);
				g_step = ROOM_MODE_SCRIPT;
			}
			break;
		case ROOM_MODE_SCHEDULE_WAIT:
			if (!mainSchedule())
			{
				setScriptThread(room_loop);
				g_step = ROOM_MODE_SCRIPT;
			}
			break;
		case ROOM_MODE_STATUS:
			mainRoomStatus();
			break;
		case ROOM_MODE_SAVELOAD_WAIT:
			waitSaveLoad();
			break;
		case ROOM_MODE_SAVELOAD_MAIN:
			mainSaveLoad();
			break;
		case ROOM_MODE_SAVE_DIALOG_WAIT:
		case ROOM_MODE_LOAD_DIALOG_WAIT:
			dialogRoomSaveLoadWait();
			break;
		case ROOM_MODE_SAVE_DIALOG_MAIN:
		case ROOM_MODE_LOAD_DIALOG_MAIN:
			dialogRoomSaveLoad();
			break;
		case ROOM_MODE_SAVE_DIALOG_DECIDE:
		case ROOM_MODE_LOAD_DIALOG_DECIDE:
			dialogRoomSaveLoadDecide();
			break;
		case ROOM_MODE_OPTION_MENU_MAIN:
			mainRoomOptionMenu();
			break;
		case ROOM_MODE_OPTION_MENU_DECIDE:
			decideRoomOptionMenu();
			break;
		case ROOM_MODE_ITEM_WAIT:
			if (isEndItemSelect())
			{
				g_step = g_step_backup;
				setScriptGraph();
			}
			break;
		case ROOM_MODE_ITEM_MAIN:
			selectItem();
			break;
		case ROOM_MODE_BATTLE_MAIN:
			selectBattle();
			break;
		case ROOM_MODE_BATTLE_DECIDE:
			decideBattle();
			break;
		default:
			;
	}
	execScript();
	execEventGraph();
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initRoomScreen(void)
{
	if (g_load_screen)
	{
		// [h
		u8 i;

		initEventGraph(0);
		getSaveInfo((void **)&g_save_info);
		g_saveload_max = getSaveCount();
		g_page = (u8)((getLastSaved() / 4) + 1);
		g_page_max = (u8)((g_saveload_max + 3) / 4);
		setSaveLoadPage(g_page, g_page_max);
		for (i=0; i<4; i++)
		{
			u8 n;
			n = (u8)((g_page - 1) * 4 + i);
			if (n < g_saveload_max)
				setSaveLoadInfo(i, (void *)&g_save_info[n]);
			else
				setSaveLoadInfo(i, NULL);
		}
		if (g_page == g_page_max && g_saveload_max != g_page_max * 4)
			setSaveLoadPanel(g_page_max * 4 - g_saveload_max);
		else
			setSaveLoadPanel(4);
		g_saveload = 1;
		setLoadGraph();
		setBGM(SEQ_PRM4_19);
		playBGM();
		g_step = ROOM_MODE_SAVELOAD_WAIT;
	} else
	if (g_option_screen)
	{
		// IvV
		initEventGraph(1);
		setOptionGraph();
		setBGM(SEQ_PRM4_19);
		playBGM();
		g_step = ROOM_MODE_OPTION_MENU_WAIT;
	} else {
		initEventGraph(-1);
		setParamGraph();
		g_step = ROOM_MODE_WAIT;
	}
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitRoom(void)
{
	if (!isFlipBmpBuf())
	{
		setScriptThread(room_loop);
		g_step = ROOM_MODE_SCRIPT;
	}
	//execEventGraph();
}

// -------------------------------------
//  XNvgI҂
// -------------------------------------
static void scriptRoom(void)
{
	if (isEndScriptThread())
	{
		if (g_step == ROOM_MODE_SCRIPT)
		{
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		} else
		if (g_step == ROOM_MODE_SYSTEM_SCRIPT)
		{
			setSystemGraph();
			g_step = ROOM_MODE_SYSTEM_MENU_WAIT;
		} else
		if (g_step == ROOM_MODE_HEALTH_SCRIPT)
		{
			setHealthGraph();
			g_step = ROOM_MODE_HEALTH_MENU_WAIT;
		} else
		if (g_step == ROOM_MODE_TALK_SCRIPT)
		{
			setTalkGraph();
			g_step = ROOM_MODE_TALK_MENU_WAIT;
		} else
		if (g_step == ROOM_MODE_ITEM_SCRIPT)
		{
			g_step = ROOM_MODE_ITEM_MAIN;
			funcSetMyItem();
		} else
		if (g_step == ROOM_MODE_SHOP_SCRIPT)
		{
			if (getLabel(LF_openAkumaShop) == ON)
				setShopGraph(TRUE);
			else
				setShopGraph(FALSE);
			g_step = ROOM_MODE_SHOP_MENU_WAIT;
		} else
		if (g_step == ROOM_MODE_TALK_SCRIPT_WAIT)
		{
			initTouchPenData();
			if (getageWidth() == ageC)
				setTouchPenData(_MUSUME_TOUCH_C_TPD);
			else
			if (getageWidth() == ageL)
				setTouchPenData(_MUSUME_TOUCH_L_TPD);
			else
				setTouchPenData(_MUSUME_TOUCH_H_TPD);
			g_step = ROOM_MODE_TOUCH_MAIN;
		} else
		if (g_step == ROOM_MODE_TOUCH_SCRIPT)
		{
			changeLCDC(TRUE);
			setTalkGraph();
			g_step = ROOM_MODE_TALK_MENU_WAIT;
		}
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void waitRoomMenu(void)
{
	if (!isChangeSubGraph())
	{
		if (g_step == ROOM_MODE_MENU_WAIT)
		{
			initTouchPenData();
			setTouchPenData(_MAIN_MENU_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_START, 0);
			g_step = ROOM_MODE_MENU_MAIN;
		} else
		if (g_step == ROOM_MODE_SYSTEM_MENU_WAIT)
		{
			initTouchPenData();
			setTouchPenData(_SELECT_MENU_1_TPD);
			setTouchPenKeySelectPos(1);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = ROOM_MODE_SYSTEM_MENU_MAIN;
		} else
		if (g_step == ROOM_MODE_HEALTH_MENU_WAIT)
		{
			initTouchPenData();
			setTouchPenData(_SELECT_MENU_1_TPD);
			setTouchPenKeySelectPos(1);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = ROOM_MODE_HEALTH_MENU_MAIN;
		} else
		if (g_step == ROOM_MODE_TALK_MENU_WAIT)
		{
			initTouchPenData();
			setTouchPenData(_SELECT_MENU_2_TPD);
			setTouchPenKeySelectPos(1);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = ROOM_MODE_TALK_MENU_MAIN;
		} else
		if (g_step == ROOM_MODE_SHOP_MENU_WAIT)
		{
			initTouchPenData();
			if (getLabel(LF_openAkumaShop) == ON)
				setTouchPenData(_SELECT_MENU_4_TPD);
			else
				setTouchPenData(_SELECT_MENU_3_TPD);
			setTouchPenKeySelectPos(1);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = ROOM_MODE_SHOP_MENU_MAIN;
		} else
		if (g_step == ROOM_MODE_OPTION_MENU_WAIT)
		{
			initTouchPenData();
			setTouchPenData(_OPTION_1_TPD);
			setTouchPenKeySelectPos(0);
			setTouchPenKeyDecide(PAD_BUTTON_B, 9);
			g_step = ROOM_MODE_OPTION_MENU_MAIN;
		}
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainRoomMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		playSE(SE_02);
		switch (decide)
		{
			case 0:		// Schedule
				initScheduleSet();
				g_step = ROOM_MODE_SCHEDULE_SET_WAIT;
				break;
			case 1:		// Status
				setParamGraph();
				g_step = ROOM_MODE_STATUS;
				break;
			case 2:		// Health
				setScriptGraph();
				setScriptThread(room_health);
				g_step = ROOM_MODE_HEALTH_SCRIPT;
				break;
			case 3:		// Shop
				putDateWindow(FALSE);
				setScriptGraph();
				setScriptThread(room_shop);
				g_step = ROOM_MODE_SHOP_SCRIPT;
				break;
			case 4:		// Talk
				setScriptGraph();
				setScriptThread(room_talk);
				g_step = ROOM_MODE_TALK_SCRIPT;
				break;
			case 5:		// Item
				setScriptGraph();
				setScriptThread(room_item);
				g_step = ROOM_MODE_ITEM_SCRIPT;
				break;
			case 6:		// System
				setScriptGraph();
				setScriptThread(room_system);
				g_step = ROOM_MODE_SYSTEM_SCRIPT;
				break;
		}
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		setMenuObj(select);
	}
	//execEventGraph();
}

// -------------------------------------
//  VXeݒ
// -------------------------------------
static void mainRoomSystemMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
		{
			playSE(SE_03);
			g_count = 10;
		} else {
			playSE(SE_02);
			g_count = 45;
		}
		g_decide = (u8)decide;
		g_step = ROOM_MODE_SYSTEM_MENU_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		setSystemObj(select);
	}
	//execEventGraph();
}

// -------------------------------------
//  VXe
// -------------------------------------
static void decideRoomSystemMenu(void)
{
	g_count--;
	if (g_count % 8 == 0)
		setSystemObj(g_decide);
	else
	if (g_count % 8 == 4)
		setSystemObj(-1);
	if (g_count == 0)
	{
		if (g_decide == 1 || g_decide == 2)
		{
			// Z[u[h
			u8 i;
			setChaAnim(FALSE);
			getSaveInfo((void **)&g_save_info);
			g_saveload_max = getSaveCount();
			g_page = (u8)((getLastSaved() / 4) + 1);
			g_page_max = (u8)((g_saveload_max + 3) / 4);
			setSaveLoadPage(g_page, g_page_max);
			for (i=0; i<4; i++)
			{
				u8 n;
				n = (u8)((g_page - 1) * 4 + i);
				if (n < g_saveload_max)
					setSaveLoadInfo(i, (void *)&g_save_info[n]);
				else
					setSaveLoadInfo(i, NULL);
			}
			if (g_page == g_page_max && g_saveload_max != g_page_max * 4)
				setSaveLoadPanel(g_page_max * 4 - g_saveload_max);
			else
				setSaveLoadPanel(4);
			if (g_decide == 1)
			{
				g_saveload = 0;
				setSaveGraph();
			} else {
				g_saveload = 1;
				setLoadGraph();
				clearCha(3);
				putDateWindow(FALSE);
				setBgNum(BG_bgrs);
			}
			putMessageWindow(TRUE);
			g_step = ROOM_MODE_SAVELOAD_WAIT;
		} else
		if (g_decide == 3)
		{
			// IvV
			setOptionGraph();
			g_step = ROOM_MODE_OPTION_MENU_WAIT;
		} else
		if (g_decide == 4)
		{
			// ^Cgɖ߂
			setSubDialog();
			g_step = ROOM_MODE_SYSTEM_MENU_DIALOG_WAIT;
		} else {
			// ߂
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  VXe_CAO
// -------------------------------------
static void dialogRoomSystemMenuWait(void)
{
	if (isPutSubDialog())
	{
		initTouchPenData();
		setTouchPenData(_ENTRY_DIALOG_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_B, 1);
		setTouchPenKeyDecide(PAD_BUTTON_START, 0);
		setTouchPenKeySelectPos(1);

		g_step = ROOM_MODE_SYSTEM_MENU_DIALOG_MAIN;
	}
	//execEventGraph();
}
// -------------------------------------
static void dialogRoomSystemMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide == 0)
	{
		playSE(SE_02);
		g_decide = 0;
		decideSubDialog(0);
		g_step = ROOM_MODE_SYSTEM_MENU_DIALOG_DECIDE;
	} else
	if (decide == 1)
	{
		playSE(SE_03);
		g_decide = 1;
		decideSubDialog(1);
		g_step = ROOM_MODE_SYSTEM_MENU_DIALOG_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		selectSubDialog(select);
	}
	//execEventGraph();
}
// -------------------------------------
static void dialogRoomSystemMenuDecide(void)
{
	if (isDeleteSubDialog())
	{
		if (g_decide == 0)
		{
			// ͂(^Cgɖ߂)
			//OS_ResetSystem(1);
			stopBGM();
			exitEventGraph();
			changeGameMode(GAME_MODE_TITLE);
		} else {
			// 
			setSystemObj(-1);
			initTouchPenData();
			setTouchPenData(_SELECT_MENU_1_TPD);
			setTouchPenKeySelectPos(1);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			g_step = ROOM_MODE_SYSTEM_MENU_MAIN;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  ̒Ǘݒ
// -------------------------------------
static void mainRoomHealthMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
		{
			playSE(SE_03);
			g_count = 10;
		} else {
			playSE(SE_02);
			g_count = 45;
		}
		g_decide = (u8)decide;
		if (g_decide == 1)
			setPolicy(polNor);
		else
		if (g_decide == 2)
			setPolicy(polAct);
		else
		if (g_decide == 3)
			setPolicy(polMod);
		else
		if (g_decide == 4)
			setPolicy(polDie);
		g_step = ROOM_MODE_HEALTH_MENU_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		setHealthObj(select);
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  ̒Ǘ
// -------------------------------------
static void decideRoomHealthMenu(void)
{
	g_count--;
	if (g_count % 8 == 0)
		setHealthObj(g_decide);
	else
	if (g_count % 8 == 4)
		setHealthObj(-1);
	if (g_count == 0)
	{
		if (g_decide == 0)
		{
			clearFaceName();
			putFaceWindow(FALSE);
			clearMessage();
			putMessageWindow(FALSE);
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		} else {
			setScriptGraph();
			setScriptThread(room_health_end);
			g_step = ROOM_MODE_SCRIPT;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  Ƙbݒ
// -------------------------------------
static void mainRoomTalkMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
		{
			playSE(SE_03);
			g_count = 10;
		} else {
			playSE(SE_02);
			g_count = 45;
		}
		g_decide = (u8)decide;
		g_step = ROOM_MODE_TALK_MENU_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		setTalkObj(select);
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  Ƙb
// -------------------------------------
static void decideRoomTalkMenu(void)
{
	g_count--;
	if (g_count % 8 == 0)
		setTalkObj(g_decide);
	else
	if (g_count % 8 == 4)
		setTalkObj(-1);
	if (g_count == 0)
	{
		if (g_decide == 0)
		{
			// ߂
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		} else
		if (g_decide == 5)
		{
			// G
			if (g_touch_help)
			{
				g_touch_help = FALSE;
				setTalkObj(5);
				setScriptThread(touchGuide);
				changeLCDC(FALSE);
				g_step = ROOM_MODE_TALK_SCRIPT_WAIT;
			} else {
				changeLCDC(FALSE);
				initTouchPenData();
				if (getageWidth() == ageC)
					setTouchPenData(_MUSUME_TOUCH_C_TPD);
				else
				if (getageWidth() == ageL)
					setTouchPenData(_MUSUME_TOUCH_L_TPD);
				else
					setTouchPenData(_MUSUME_TOUCH_H_TPD);
				g_step = ROOM_MODE_TOUCH_MAIN;
			}
///			putDateWindow(TRUE);
///			setMenuGraph();
///			g_step = ROOM_MODE_MENU_WAIT;
		} else {
			setParamGraph();
			setScriptThread(tk01);
			g_step = ROOM_MODE_SCRIPT;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  ^b`
// -------------------------------------
static void mainRoomTouch(void)
{
	s16 decide;

	decide = getTouchPenDecide();
	if (decide != -1)
	{
		g_decide = (u8)decide;
		setScriptThread(touchMessage);

		g_step = ROOM_MODE_TOUCH_SCRIPT;
	}
#ifdef _CERO_DEBUG
	if (getPadRep() & PAD_BUTTON_L)
	{
		if (getageWidth() == ageC)
			setageWidth(ageL);
		else
		if (getageWidth() == ageL)
			setageWidth(ageH);
		else
			setageWidth(ageC);
		setChaNum(0, cDA0);
	} else
	if (getPadRep() & PAD_BUTTON_R)
	{
		if (getcon() == conN)
		{
			setcon(conY);
			setDress(15);	//sǕ
		} else
		if (getcon() == conY)
		{
			setcon(conS);
			setDress(16);	//pW}
		} else {
			setcon(conN);
			setDress(1);	//i
		}
		setChaNum(0, cDA0);
	}
#endif
}

// -------------------------------------
//  Z[u[h
// -------------------------------------
static void waitSaveLoad(void)
{
	if (!isChangeSubGraph())
	{
		initTouchPenData();
		if (g_page == g_page_max)
		{
			u8 n;
			n = (u8)(g_page_max * 4 - g_saveload_max);
			if (n == 1)
				setTouchPenData(_SAVELOAD_1_TPD);
			else
			if (n == 2)
				setTouchPenData(_SAVELOAD_2_TPD);
			else
			if (n == 3)
				setTouchPenData(_SAVELOAD_3_TPD);
			else
				setTouchPenData(_SAVELOAD_4_TPD);
		} else
			setTouchPenData(_SAVELOAD_4_TPD);
		setTouchPenKeySelectPos(4);
		setTouchPenKeyDecide(PAD_BUTTON_B, 0);
		g_step = ROOM_MODE_SAVELOAD_MAIN;
	}
	//execScript();
	//execEventGraph();
}
// -------------------------------------
static void mainSaveLoad(void)
{
	s16 select, selold, decide;
	u8 i;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (getPadRep() & PAD_KEY_LEFT)
		decide = 1;
	else
	if (getPadRep() & PAD_KEY_RIGHT)
		decide = 2;
	if (decide != -1)
	{
		BOOL result;
		result = FALSE;
		if (decide == 0)
		{
			// ߂
			if (g_load_screen)
			{
				//OS_ResetSystem(1);
				stopBGM();
				exitEventGraph();
				changeGameMode(GAME_MODE_TITLE);
				return;
			}
			setSaveLoadObj(-1);
			if (g_saveload == 1)
			{
				setChaNum(0, cDA0);
				putDateWindow(TRUE);
				setBgNum(BG_bgr000);
			}
			putMessageWindow(FALSE);
			playSE(SE_03);
			setChaAnim(TRUE);
			putDateWindow(TRUE);
			setMenuGraph();
			if (g_save_info)
			{
				freeBDS(g_save_info);
				g_save_info = NULL;
			}
			g_step = ROOM_MODE_MENU_WAIT;
		} else
		if (decide == 1)
		{
			// ̃y[W
			if (g_page > 1)
				g_page--;
			result = TRUE;
			playSE(SE_01);
		} else
		if (decide == 2 || decide == 3)
		{
			if (g_page < g_page_max)
				g_page++;
			else
			if (decide == 3)
				g_page = 1;
			result = TRUE;
			playSE(SE_01);
		} else {
			// Z[uor[h
			s32 num;

			num = ((g_page - 1) * 4) + (decide - 4);
			if (g_saveload == 0)
			{
				// Z[u
				if (g_save_info[num].m_nodata == 0)
				{
					if (saveUserData(num))
					{
						setLastSaved((u8)num);
						freeBDS(g_save_info);
						getSaveInfo((void **)&g_save_info);
						result = TRUE;
						playSE(SE_02);
					}
				} else {
					// ㏑Ȃ̂ŊmFĂ
					g_save_num = (u8)num;
					setSubDialog();
					g_step = ROOM_MODE_SAVE_DIALOG_WAIT;
				}
			} else {
				// [h
				if (g_save_info[num].m_nodata == 1)
				{
					// [h\Ȃ̂ŊmF
					g_save_num = (u8)num;
					setSubDialog();
					g_step = ROOM_MODE_LOAD_DIALOG_WAIT;
				} else {
					// [hs\
					playSE(SE_03);
				}
			}
		}
		if (result)
		{
			setSaveLoadPage(g_page, g_page_max);
			for (i=0; i<4; i++)
			{
				u8 n;
				n = (u8)((g_page - 1) * 4 + i);
				if (n < g_saveload_max)
					setSaveLoadInfo(i, (void *)&g_save_info[n]);
				else
					setSaveLoadInfo(i, NULL);
			}
			if (g_page == g_page_max && g_saveload_max != g_page_max * 4)
				setSaveLoadPanel(g_page_max * 4 - g_saveload_max);
			else
				setSaveLoadPanel(4);
			//initTouchPenData();
			if (g_page == g_page_max)
			{
				u8 n;
				n = (u8)(g_page_max * 4 - g_saveload_max);
				if (select == 1 || select == 2 || select == 3)
					select = 4;
				if (n == 1)
				{
					if (select > 4)
						select = 4;
					setTouchPenKeySelectPos(select);
					setTouchPenData(_SAVELOAD_1_TPD);
				} else
				if (n == 2)
				{
					if (select > 5)
						select = 5;
					setTouchPenKeySelectPos(select);
					setTouchPenData(_SAVELOAD_2_TPD);
				} else
				if (n == 3)
				{
					if (select > 6)
						select = 6;
					setTouchPenKeySelectPos(select);
					setTouchPenData(_SAVELOAD_3_TPD);
				} else {
					setTouchPenData(_SAVELOAD_4_TPD);
					setTouchPenKeySelectPos(select);
				}
			} else {
				if (select != 4 && select != 5 && select != 6 && select != 7)
					select = 4;
				setTouchPenData(_SAVELOAD_4_TPD);
				setTouchPenKeySelectPos(select);
			}
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			setSaveLoadObj(select);
		}
	} else
	if (select != selold)
	{
		if (select == 1 && g_page == 1)
			setSaveLoadObj(-1);
		else
		if ((select == 2 || select == 3) && g_page == g_page_max)
			setSaveLoadObj(-1);
		else
		{
			setSaveLoadObj(select);
			if (select != -1)
				playSE(SE_01);
		}
	}
	//execScript();
	//execEventGraph();
/*
*/
}
// -------------------------------------
static void dialogRoomSaveLoadWait(void)
{
	if (isPutSubDialog())
	{
		initTouchPenData();
		setTouchPenData(_ENTRY_DIALOG_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_B, 1);
		setTouchPenKeyDecide(PAD_BUTTON_START, 0);
		setTouchPenKeySelectPos(1);

		if (g_step == ROOM_MODE_SAVE_DIALOG_WAIT)
			g_step = ROOM_MODE_SAVE_DIALOG_MAIN;
		else
			g_step = ROOM_MODE_LOAD_DIALOG_MAIN;
	}
}
// -------------------------------------
static void dialogRoomSaveLoad(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide == 0)
	{
		playSE(SE_02);
		g_decide = 0;
		decideSubDialog(0);
		if (g_step == ROOM_MODE_SAVE_DIALOG_MAIN)
			g_step = ROOM_MODE_SAVE_DIALOG_DECIDE;
		else
			g_step = ROOM_MODE_LOAD_DIALOG_DECIDE;
	} else
	if (decide == 1)
	{
		playSE(SE_03);
		g_decide = 1;
		decideSubDialog(1);
		if (g_step == ROOM_MODE_SAVE_DIALOG_MAIN)
			g_step = ROOM_MODE_SAVE_DIALOG_DECIDE;
		else
			g_step = ROOM_MODE_LOAD_DIALOG_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		selectSubDialog(select);
	}
}
// -------------------------------------
static void dialogRoomSaveLoadDecide(void)
{
	u8 i, n;

	if (isDeleteSubDialog())
	{
		if (g_decide == 0)
		{
			// ͂
			if (g_step == ROOM_MODE_SAVE_DIALOG_DECIDE)
			{
				// Z[uႤ
				if (saveUserData(g_save_num))
				{
					setLastSaved((u8)g_save_num);
					if (g_save_info)
					{
						freeBDS(g_save_info);
						g_save_info = NULL;
					}
					getSaveInfo((void **)&g_save_info);
					playSE(SE_02);
				}
				setSaveLoadPage(g_page, g_page_max);
				for (i=0; i<4; i++)
				{
					n = (u8)((g_page - 1) * 4 + i);
					if (n < g_saveload_max)
						setSaveLoadInfo(i, (void *)&g_save_info[n]);
					else
						setSaveLoadInfo(i, NULL);
				}
				if (g_page == g_page_max && g_saveload_max != g_page_max * 4)
					setSaveLoadPanel(g_page_max * 4 - g_saveload_max);
				else
					setSaveLoadPanel(4);
			} else {
				if (loadUserData(g_save_num))
				{
					playSE(SE_02);
					setNameData();
					setSaveLoadObj(-1);
					setChaNum(0, cDA0);
					putDateWindow(TRUE);
					setBgNum(BG_bgr000);
					putMessageWindow(FALSE);
					setChaAnim(TRUE);
					setMenuGraph();
					if (g_save_info)
					{
						freeBDS(g_save_info);
						g_save_info = NULL;
					}
					playRoomBGM();
					g_load_screen = FALSE;
					g_step = ROOM_MODE_MENU_WAIT;
				}
			}
		}
		if (g_step != ROOM_MODE_MENU_WAIT)
		{
			initTouchPenData();
			if (g_page == g_page_max)
			{
				n = (u8)(g_page_max * 4 - g_saveload_max);
				if (n == 1)
					setTouchPenData(_SAVELOAD_1_TPD);
				else
				if (n == 2)
					setTouchPenData(_SAVELOAD_2_TPD);
				else
				if (n == 3)
					setTouchPenData(_SAVELOAD_3_TPD);
				else
					setTouchPenData(_SAVELOAD_4_TPD);
			} else
				setTouchPenData(_SAVELOAD_4_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_B, 0);
			setTouchPenKeySelectPos(4);
			setSaveLoadObj(-1);
			g_step = ROOM_MODE_SAVELOAD_MAIN;
		}
	}
}

// -------------------------------------
//  Vbvݒ
// -------------------------------------
static void mainRoomShopMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 0)
		{
			playSE(SE_03);
			g_count = 10;
		} else {
			playSE(SE_02);
			g_count = 45;
		}
		g_decide = (u8)decide;
		g_step = ROOM_MODE_SHOP_MENU_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		if (getLabel(LF_openAkumaShop) == ON)
			setShopObj2(select);
		else
			setShopObj(select);
	}
	//execScript();
	//execEventGraph();
}

// -------------------------------------
//  Vbv
// -------------------------------------
static void decideRoomShopMenu(void)
{
	g_count--;
	if (g_count % 8 == 0)
	{
		if (getLabel(LF_openAkumaShop) == ON)
			setShopObj2(g_decide);
		else
			setShopObj(g_decide);
	} else
	if (g_count % 8 == 4)
	{
		if (getLabel(LF_openAkumaShop) == ON)
			setShopObj2(-1);
		else
			setShopObj(-1);
	}
	if (g_count == 0)
	{
		if (g_decide == 0)
		{
			// ߂
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		} else
		if (g_decide == 1)
		{
			// 
			setScriptGraph();
			setScriptThread(sp01);
			g_step = ROOM_MODE_SCRIPT;
		} else
		if (g_decide == 2)
		{
			// miX
			setScriptGraph();
			setScriptThread(sp02);
			g_step = ROOM_MODE_SCRIPT;
		} else
		if (g_decide == 3)
		{
			// Xg
			setScriptGraph();
			setScriptThread(sp03);
			g_step = ROOM_MODE_SCRIPT;
		} else
		if (g_decide == 4)
		{
			// 
			setScriptGraph();
			setScriptThread(sp05);
			g_step = ROOM_MODE_SCRIPT;
		} else
		if (g_decide == 5)
		{
			// a@
			setParamGraph();
			setScriptThread(sp04);
			g_step = ROOM_MODE_SCRIPT;
		} else
		if (g_decide == 6)
		{
			// E̓
			setScriptGraph();
			setScriptThread(sp06);
			g_step = ROOM_MODE_SCRIPT;
		}
	}
	//execEventGraph();
}

// -------------------------------------
//  ACemFEI
// -------------------------------------
static void selectItem(void)
{
	s16 item;

	item = getSelectItem();
	if (item == -1)
	{
		putDateWindow(TRUE);
		setMenuGraph();
		g_step = ROOM_MODE_MENU_WAIT;
	}
}

// -------------------------------------
//  ogI
// -------------------------------------
static void selectBattle(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		playSE(SE_02);
		g_decide = (u8)decide;
		g_count = 30;
		g_step = ROOM_MODE_BATTLE_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		putBattleObj((s8)select);
	}
}
// -------------------------------------
static void decideBattle(void)
{
	g_count--;
	if (g_count % 8 == 0)
		putBattleObj((s8)g_decide);
	else
	if (g_count % 8 == 4)
		putBattleObj(-1);
	if (g_count == 0)
	{
		initTouchPenData();
		g_step = g_step_backup;
	}
}


// -------------------------------------
//  IvV
// -------------------------------------
static void mainRoomOptionMenu(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide != -1)
	{
		if (decide == 9)
		{
			// ߂
			if (g_option_screen)
			{
				//OS_ResetSystem(1);
				stopBGM();
				exitEventGraph();
				changeGameMode(GAME_MODE_TITLE);
				return;
			}
			playSE(SE_03);
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		} else {
			pauseTouchPenData();
			g_decide = (u8)decide;
			switch (decide)
			{
				case 0:		// yON
					setOptionBGM(2);
					break;
				case 1:		// yOFF
					setOptionBGM(0);
					break;
				case 2:		// ʉON
					setOptionSFX(2);
					break;
				case 3:		// ʉOFF
					setOptionSFX(0);
					break;
				case 4:		// ON
					setOptionVoice(2);
					break;
				case 5:		// OFF
					setOptionVoice(0);
					break;
				case 6:		// bZ[W
					setOptionMessage(0);
					break;
				case 7:		// bZ[W
					setOptionMessage(1);
					break;
				case 8:		// bZ[Wx
					setOptionMessage(2);
					break;
			}
			playSE(SE_02);
			g_count = 30;
			g_step = ROOM_MODE_OPTION_MENU_DECIDE;
		}
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		setOptionObj(select);
	}
}
// -------------------------------------
static void decideRoomOptionMenu(void)
{
	g_count--;
	if (g_count % 8 == 0)
		setOptionObj(g_decide);
	else
	if (g_count % 8 == 4)
		setOptionObj(-1);
	if (g_count == 0)
	{
		resumeTouchPenData();
		g_step = ROOM_MODE_OPTION_MENU_MAIN;
	}
}

// -------------------------------------
//  ߂̕ϐ
// -------------------------------------
static void room_loop(void)
{
	setBgNum(BG_bgr000);
	waitChangeGraph();

///#{ $ScheduleRun = OFF }
	setLabel(LF_fe_nw00, FALSE);
	setLabel(LF_talkParamChange, FALSE);

	setTalkExec(FALSE);
	//cmdSetDateInfo(cmdIncDayŏς݂Ȃ̂ŕu)

	if (getGameM() > y1446_5)
		setWarFlag(1);

	if (getGameM() != 0)
		playRoomBGM();

	m00();
	playRoomBGM();
}


// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainRoomStatus(void)
{
	u16 m, x, y;

	if (!isChangeSubGraph())
	{
		getTouchPen(&m, &x, &y);
		if (getPadRep() & (PAD_BUTTON_A|PAD_BUTTON_B) || (m == TOUCH_PEN_UP && x >= 0 && x <256 && y >= 56 && y < 192))
		{
			playSE(SE_02);
			putDateWindow(TRUE);
			setMenuGraph();
			g_step = ROOM_MODE_MENU_WAIT;
		}
	}
	//execEventGraph();
}


// -------------------------------------
static void room_system(void)
{
	if (!getLabel(LF_room_system))
	{
		setLabel(LF_room_system, ON);
		setScript(_ROOM_PSC, ROOM_ROOM_SYSTEM);
		waitScript();
	}
}
// -------------------------------------
static void room_health(void)
{
	switch(getPolicy())
	{
		case polNor:
			setScript(_ROOM_PSC, ROOM_HEALTH_00);
			break;
		case polAct:
			setScript(_ROOM_PSC, ROOM_HEALTH_01);
			break;
		case polMod:
			setScript(_ROOM_PSC, ROOM_HEALTH_02);
			break;
		case polDie:
			setScript(_ROOM_PSC, ROOM_HEALTH_03);
			break;
	}
	waitScript();
	putStartMessage();
}
// -------------------------------------
static void room_health_end(void)
{
	switch(getPolicy())
	{
		case polNor:
			setScript(_ROOM_PSC, ROOM_HEALTH_04);
			break;
		case polAct:
			setScript(_ROOM_PSC, ROOM_HEALTH_05);
			break;
		case polMod:
			setScript(_ROOM_PSC, ROOM_HEALTH_06);
			break;
		case polDie:
			setScript(_ROOM_PSC, ROOM_HEALTH_07);
			break;
	}
	waitScript();
}
// -------------------------------------
static void room_shop(void)
{
	if (!getLabel(LF_room_shop))
	{
		setLabel(LF_room_shop, ON);
		setScript(_ROOM_PSC, ROOM_ROOM_SHOP);
		waitScript();
	}
}
// -------------------------------------
static void room_talk(void)
{
	if (!getLabel(LF_room_talk))
	{
		setLabel(LF_room_talk, ON);
		setScript(_ROOM_PSC, ROOM_ROOM_TALK);
		waitScript();
	}
	if (getcon() == conN && getParam(pHIROU) * 10 <= getParam(pTAIRYOKU) * 8)
	{
		if (getGameY() != 0 && getMonth() == 8 && getRandom() % 100 < 50)
			tk07();		// nՁE^bitk07j
		else
		if (getSchLast(0) != 0 && getSchLast(0)== getSchLast(1) && getSchLast(0) == getSchLast(2))
		{
			if (getSchLast(0) <= jButou+1)
				tk05();		// ׋̘b(tk05)
			else
				tk04();		// AoCg̘b(tk04)
		} else
		if (getRandom() % 100 < 50)
			tk06();		// ̘b(tk06)
	}
	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}
// -------------------------------------
static void room_item(void)
{
	if (!getLabel(LF_room_item))
	{
		setLabel(LF_room_item, ON);
		setScript(_ROOM_PSC, ROOM_ROOM_ITEM);
		waitScript();
	}
}

//-------------------------------------
// Ƃ̉bP - {b
//-------------------------------------
static void tk01(void)
{
	waitChangeGraph();
	switch (g_decide)
	{
		case 1:		//A
			switch (getageWidth())
			{
				case ageC:
					if (getcon() == conS)
					{
						//AEaCF`Ch
						setScript(_TK01_PSC, TK01_TK01_13);
					} else
					if (getcon() == conY)
					{
						//AEsǉF`Ch
						setScript(_TK01_PSC, TK01_TK01_10);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//`Ch
						setScript(_TK02_PSC, TK02_TK02_0);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//A`F`Ch
								setScript(_TK01_PSC, TK01_TK01_0);
								break;
							case 1:
								//AaF`Ch
								setScript(_TK01_PSC, TK01_TK01_3);
								break;
							case 2:
								//AbF`Ch
								setScript(_TK01_PSC, TK01_TK01_6);
								break;
						}
					}
					break;

				case ageL:
					if (getcon() == conS)
					{
						//AEaCF[eB[
						setScript(_TK01_PSC, TK01_TK01_14);
					} else
					if (getcon() == conY)
					{
						//AEsǉF[eB[
						setScript(_TK01_PSC, TK01_TK01_11);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//ꃍ[eB[
						setScript(_TK02_PSC, TK02_TK02_1);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//A`F[eB[
								setScript(_TK01_PSC, TK01_TK01_1);
								break;
							case 1:
								//AaF[eB[
								setScript(_TK01_PSC, TK01_TK01_4);
								break;
							case 2:
								//AbF[eB[
								setScript(_TK01_PSC, TK01_TK01_7);
								break;
						}
					}
					break;

				case ageH:
					if (getcon() == conS)
					{
						//AEaCFnCeB[
						setScript(_TK01_PSC, TK01_TK01_15);
					} else
					if (getcon() == conY)
					{
						//AEsǉFnCeB[
						setScript(_TK01_PSC, TK01_TK01_12);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//nCeB[
						setScript(_TK02_PSC, TK02_TK02_2);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//A`FnCeB[
								setScript(_TK01_PSC, TK01_TK01_2);
								break;
							case 1:
								//AaFnCeB[
								setScript(_TK01_PSC, TK01_TK01_5);
								break;
							case 2:
								//AbFnCeB[
								setScript(_TK01_PSC, TK01_TK01_9);
								break;
						}
					}
					break;
			}
			waitScript();
			AisatuParamChange();
			break;

		case 2:		//D
			switch (getageWidth())
			{
				case ageC:
					if (getcon() == conS)
					{
						//₳EaCF`Ch
						setScript(_TK01_PSC, TK01_TK01_28);
					} else
					if (getcon() == conY)
					{
						//₳EsǉF`Ch
						setScript(_TK01_PSC, TK01_TK01_25);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//:`Ch
						setScript(_TK02_PSC, TK02_TK02_21);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//₳`F`Ch
								setScript(_TK01_PSC, TK01_TK01_16);
								break;
							case 1:
								//₳aF`Ch
								setScript(_TK01_PSC, TK01_TK01_19);
								break;
							case 2:
								//₳bF`Ch
								setScript(_TK01_PSC, TK01_TK01_22);
								break;
						}
					}
					break;

				case ageL:
					if (getcon() == conS)
					{
						//₳EaCF[eB[
						setScript(_TK01_PSC, TK01_TK01_29);
					} else
					if (getcon() == conY)
					{
						//₳EsǉF[eB[
						setScript(_TK01_PSC, TK01_TK01_26);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//:[eB[
						setScript(_TK02_PSC, TK02_TK02_22);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//₳`F[eB[
								setScript(_TK01_PSC, TK01_TK01_17);
								break;
							case 1:
								//₳aF[eB[
								setScript(_TK01_PSC, TK01_TK01_20);
								break;
							case 2:
								//₳bF[eB[
								setScript(_TK01_PSC, TK01_TK01_23);
								break;
						}
					}
					break;

				case ageH:
					if (getcon() == conS)
					{
						//₳EaCFnCeB[
						setScript(_TK01_PSC, TK01_TK01_30);
					} else
					if (getcon() == conY)
					{
						//₳EsǉFnCeB[
						setScript(_TK01_PSC, TK01_TK01_27);
					} else
					if (getParam(pHIROU) * 10 > getParam(pTAIRYOKU) * 8)
					{
						//:nCeB[
						setScript(_TK02_PSC, TK02_TK02_23);
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//₳`FnCeB[
								setScript(_TK01_PSC, TK01_TK01_18);
								break;
							case 1:
								//₳aFnCeB[
								setScript(_TK01_PSC, TK01_TK01_21);
								break;
							case 2:
								//₳bFnCeB[
								setScript(_TK01_PSC, TK01_TK01_24);
								break;
						}
					}
					break;
			}
			waitScript();
			YasasikuParamChange();
			break;

		case 3:		//
			switch (getageWidth())
			{
				case ageC:
					if (getcon() == conS)
					{
						//EaCF`Ch
						setScript(_TK01_PSC, TK01_TK01_43);
					} else
					if (getcon() == conY)
					{
						if (getRandom() & 1)
							setScript(_TK01_PSC, TK01_TK01_40A);	//EsǉF`Ch
						else
							setScript(_TK01_PSC, TK01_TK01_40B);	//EsǉF`Ch
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//`F`Ch
								setScript(_TK01_PSC, TK01_TK01_31);
								break;
							case 1:
								//aF`Ch
								setScript(_TK01_PSC, TK01_TK01_34);
								break;
							case 2:
								//bF`Ch
								setScript(_TK01_PSC, TK01_TK01_37);
								break;
						}
					}
					break;

				case ageL:
					if (getcon() == conS)
					{
						//EaCF[eB[
						setScript(_TK01_PSC, TK01_TK01_44);
					} else
					if (getcon() == conY)
					{
						if (getRandom() & 1)
							setScript(_TK01_PSC, TK01_TK01_41A);	//EsǉF[eB[
						else
							setScript(_TK01_PSC, TK01_TK01_41B);	//EsǉF[eB[
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//`F[eB[
								setScript(_TK01_PSC, TK01_TK01_32);
								break;
							case 1:
								//aF[eB[
								setScript(_TK01_PSC, TK01_TK01_35);
								break;
							case 2:
								//bF[eB[
								setScript(_TK01_PSC, TK01_TK01_38);
								break;
						}
					}
					break;

				case ageH:
					if (getcon() == conS)
					{
						//EaCFnCeB[
						setScript(_TK01_PSC, TK01_TK01_45);
					} else
					if (getcon() == conY)
					{
						if (getRandom() & 1)
							setScript(_TK01_PSC, TK01_TK01_42A);	//EsǉFnCeB[
						else
							setScript(_TK01_PSC, TK01_TK01_42B);	//EsǉFnCeB[
					} else {
						switch (getRandom() % 3)
						{
							case 0:
								//`FnCeB[
								setScript(_TK01_PSC, TK01_TK01_33);
								break;
							case 1:
								//aFnCeB[
								setScript(_TK01_PSC, TK01_TK01_36);
								break;
							case 2:
								//bFnCeB[
								setScript(_TK01_PSC, TK01_TK01_39);
								break;
						}
					}
					break;
			}
			waitScript();
			KibishikuParamChange();
			break;

		case 4:		//Â
			if (getGold() < 50)
			{
				setScript(_TK01_PSC, TK01_TK01_NOMONEY);
			} else {
				switch (getageWidth())
				{
					case ageC:
						if (getcon() == conS)
						{
							//ÂEaCF`Ch
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_52);
						} else
						if (getcon() == conY)
						{
							//ÂEsǉF`Ch
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_49);
						} else {
							//ÂF`Ch
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_46);
						}
						break;

					case ageL:
						if (getcon() == conS)
						{
							//ÂEaCF[eB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_53);
						} else
						if (getcon() == conY)
						{
							//ÂEsǉF[eB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_50);
						} else {
							//ÂF[eB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_47);
						}
						break;

					case ageH:
						if (getcon() == conS)
						{
							//ÂEaCFnCeB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_54);
						} else
						if (getcon() == conY)
						{
							//ÂEsǉFnCeB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_51);
						} else {
							//ÂFnCeB[
							oKodukaiParamChange();
							setScript(_TK01_PSC, TK01_TK01_48);
						}
						break;
				}
			}
			waitScript();
			break;
	}
	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}

//-------------------------------------
// AoCg̘b(tk04)
//-------------------------------------
static void tk04(void)
{
	// EǑSēdŖ܂Ă
	// E`ChȂ烉NPA[eB[Ȃ烉NQ
	// @nCeB[̓NRŉb
	if (getSchLast(0) == jKajiTetudai+1)
	{
		if (getLabel(LF_tk04_0) == OFF && getageWidth() == ageC && getSchRank(jKajiTetudai) >= 1)
			setScript(_TK04_PSC, TK04_TK04_0);
		if (getLabel(LF_tk04_1) == OFF && getageWidth() == ageL && getSchRank(jKajiTetudai) >= 2)
			setScript(_TK04_PSC, TK04_TK04_1);
		if (getLabel(LF_tk04_2) == OFF && getageWidth() == ageH && getSchRank(jKajiTetudai) >= 3)
			setScript(_TK04_PSC, TK04_TK04_2);
	} else
	if (getSchLast(0) == jKomori+1)
	{
		if (getLabel(LF_tk04_3) == OFF && getageWidth() == ageC && getSchRank(jKomori) >= 1)
			setScript(_TK04_PSC, TK04_TK04_3);
		if (getLabel(LF_tk04_4) == OFF && getageWidth() == ageL && getSchRank(jKomori) >= 2)
			setScript(_TK04_PSC, TK04_TK04_4);
		if (getLabel(LF_tk04_5) == OFF && getageWidth() == ageH && getSchRank(jKomori) >= 3)
			setScript(_TK04_PSC, TK04_TK04_5);
	} else
	if (getSchLast(0) == jNoujyou+1)
	{
		if (getLabel(LF_tk04_9) == OFF && getageWidth() == ageC && getSchRank(jNoujyou) >= 1)
			setScript(_TK04_PSC, TK04_TK04_9);
		if (getLabel(LF_tk04_10) == OFF && getageWidth() == ageL && getSchRank(jNoujyou) >= 2)
			setScript(_TK04_PSC, TK04_TK04_10);
		if (getLabel(LF_tk04_11) == OFF && getageWidth() == ageH && getSchRank(jNoujyou) >= 3)
			setScript(_TK04_PSC, TK04_TK04_11);
	} else
	if (getSchLast(0) == jKyoukai+1)
	{
		if (getLabel(LF_tk04_12) == OFF && getageWidth() == ageC && getSchRank(jKyoukai) >= 1)
			setScript(_TK04_PSC, TK04_TK04_12);
		if (getLabel(LF_tk04_13) == OFF && getageWidth() == ageL && getSchRank(jKyoukai) >= 2)
			setScript(_TK04_PSC, TK04_TK04_13);
		if (getLabel(LF_tk04_14) == OFF && getageWidth() == ageH && getSchRank(jKyoukai) >= 3)
			setScript(_TK04_PSC, TK04_TK04_14);
	} else
	if (getSchLast(0) == jRyouriya+1)
	{
		if (getLabel(LF_tk04_15) == OFF && getageWidth() == ageC && getSchRank(jRyouriya) >= 1)
			setScript(_TK04_PSC, TK04_TK04_15);
		if (getLabel(LF_tk04_16) == OFF && getageWidth() == ageL && getSchRank(jRyouriya) >= 2)
			setScript(_TK04_PSC, TK04_TK04_16);
		if (getLabel(LF_tk04_17) == OFF && getageWidth() == ageH && getSchRank(jRyouriya) >= 3)
			setScript(_TK04_PSC, TK04_TK04_17);
	} else
	if (getSchLast(0) == jMeido+1)
	{
		if (getLabel(LF_tk04_26) == OFF && getageWidth() == ageC && getSchRank(jMeido) >= 1)
			setScript(_TK04_PSC, TK04_TK04_26);
		if (getLabel(LF_tk04_27) == OFF && getageWidth() == ageL && getSchRank(jMeido) >= 2)
			setScript(_TK04_PSC, TK04_TK04_27);
		if (getLabel(LF_tk04_28) == OFF && getageWidth() == ageH && getSchRank(jMeido) >= 3)
			setScript(_TK04_PSC, TK04_TK04_28);
	} else
	if (getSchLast(0) == jKikori+1)
	{
		if (getLabel(LF_tk04_33) == OFF && getageWidth() == ageC && getSchRank(jKikori) >= 1)
			setScript(_TK04_PSC, TK04_TK04_33);
		if (getLabel(LF_tk04_34) == OFF && getageWidth() == ageL && getSchRank(jKikori) >= 2)
			setScript(_TK04_PSC, TK04_TK04_34);
		if (getLabel(LF_tk04_35) == OFF && getageWidth() == ageH && getSchRank(jKikori) >= 3)
			setScript(_TK04_PSC, TK04_TK04_35);
	} else
	if (getSchLast(0) == jYadoya+1)
	{
		if (getLabel(LF_tk04_6) == OFF && getageWidth() == ageC && getSchRank(jYadoya) == 1)
			setScript(_TK04_PSC, TK04_TK04_6);
		if (getLabel(LF_tk04_7) == OFF && getageWidth() == ageL && getSchRank(jYadoya) >= 2)
			setScript(_TK04_PSC, TK04_TK04_7);
		if (getLabel(LF_tk04_8) == OFF && getageWidth() == ageH && getSchRank(jYadoya) >= 3)
			setScript(_TK04_PSC, TK04_TK04_8);
	} else
	if (getSchLast(0) == jIchiba+1)
	{
		if (getLabel(LF_tk04_31) == OFF && getageWidth() == ageL && getSchRank(jIchiba) >= 2)
			setScript(_TK04_PSC, TK04_TK04_31);
		if (getLabel(LF_tk04_32) == OFF && getageWidth() == ageH && getSchRank(jIchiba) >= 3)
			setScript(_TK04_PSC, TK04_TK04_32);
	} else
	if (getSchLast(0) == jSakaba+1)
	{
		if (getLabel(LF_tk04_20) == OFF && getageWidth() == ageL && getSchRank(jSakaba) >= 2)
			setScript(_TK04_PSC, TK04_TK04_20);
		if (getLabel(LF_tk04_21) == OFF && getageWidth() == ageH && getSchRank(jSakaba) >= 3)
			setScript(_TK04_PSC, TK04_TK04_21);
	} else
	if (getSchLast(0) == jKateiKyousi+1)
	{
		if (getLabel(LF_tk04_18) == OFF && getageWidth() == ageL && getSchRank(jKateiKyousi) >= 2)
			setScript(_TK04_PSC, TK04_TK04_18);
		if (getLabel(LF_tk04_19) == OFF && getageWidth() == ageH && getSchRank(jKateiKyousi) >= 3)
			setScript(_TK04_PSC, TK04_TK04_19);
	} else
	if (getSchLast(0) == jMeidoSakaba+1)
	{
		if (getLabel(LF_tk04_29) == OFF && getageWidth() == ageL && getSchRank(jMeidoSakaba) >= 2)
			setScript(_TK04_PSC, TK04_TK04_29);
		if (getLabel(LF_tk04_30) == OFF && getageWidth() == ageH && getSchRank(jKateiKyousi) >= 3)
			setScript(_TK04_PSC, TK04_TK04_30);
	} else
	if (getSchLast(0) == jAyasiiSakaba+1)
	{
		if (getLabel(LF_tk04_22) == OFF && getageWidth() == ageL && getSchRank(jAyasiiSakaba) >= 2)
			setScript(_TK04_PSC, TK04_TK04_22);
		if (getLabel(LF_tk04_23) == OFF && getageWidth() == ageH && getSchRank(jAyasiiSakaba) >= 3)
			setScript(_TK04_PSC, TK04_TK04_23);
	} else
	if (getSchLast(0) == jKajino+1)
	{
		if (getLabel(LF_tk04_24) == OFF && getageWidth() == ageL && getSchRank(jKajino) >= 2)
			setScript(_TK04_PSC, TK04_TK04_24);
		if (getLabel(LF_tk04_25) == OFF && getageWidth() == ageH && getSchRank(jKajino) >= 3)
			setScript(_TK04_PSC, TK04_TK04_25);
	}
	waitScript();
}
//-------------------------------------
// ׋̘b(tk05)
//-------------------------------------
static void tk05(void)
{
	if (getSchLast(0) == jBujyutu+1)
	{
		if (getLabel(LF_tk05_0) == OFF && getageWidth() == ageC && getSchRank(jBujyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_0);
		else
		if (getLabel(LF_tk05_1) == OFF && getageWidth() == ageL && getSchRank(jBujyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_1);
		else
		if (getLabel(LF_tk05_2) == OFF && getageWidth() == ageH && getSchRank(jBujyutu) == 2)
			setScript(_TK05_PSC, TK05_TK05_2);
		else
		if (getLabel(LF_tk05_54) == OFF && getageWidth() == ageH && getSchRank(jBujyutu) == 3)
			setScript(_TK05_PSC, TK05_TK05_54);
		else
		if (getSchLastRes(jBujyutu) > 0)
		{
			if (getLabel(LF_tk05_3) == OFF && getageWidth() == ageC && getSchRank(jBujyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_3);
			if (getLabel(LF_tk05_4) == OFF && getageWidth() == ageL && getSchRank(jBujyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_4);
			if (getLabel(LF_tk05_5) == OFF && getageWidth() == ageH && getSchRank(jBujyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_5);
		} else
		if (getSchLastRes(jBujyutu) < 0)
		{
			if (getLabel(LF_tk05_6) == OFF && getageWidth() == ageC && getSchRank(jBujyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_6);
			if (getLabel(LF_tk05_7) == OFF && getageWidth() == ageL && getSchRank(jBujyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_7);
			if (getLabel(LF_tk05_8) == OFF && getageWidth() == ageH && getSchRank(jBujyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_8);
		}
	} else
	if (getSchLast(0) == jMajyutu+1)
	{
		if (getLabel(LF_tk05_9) == OFF && getageWidth() == ageC && getSchRank(jMajyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_9);
		else
		if (getLabel(LF_tk05_10) == OFF && getageWidth() == ageL && getSchRank(jMajyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_10);
		else
		if (getLabel(LF_tk05_11) == OFF && getageWidth() == ageH && getSchRank(jMajyutu) == 2)
			setScript(_TK05_PSC, TK05_TK05_11);
		else
		if (getLabel(LF_tk05_55) == OFF && getageWidth() == ageH && getSchRank(jMajyutu) == 3)
			setScript(_TK05_PSC, TK05_TK05_55);
		else
		if (getSchLastRes(jMajyutu) > 0)
		{
			if (getLabel(LF_tk05_12) == OFF && getageWidth() == ageC && getSchRank(jMajyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_12);
			if (getLabel(LF_tk05_13) == OFF && getageWidth() == ageL && getSchRank(jMajyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_13);
			if (getLabel(LF_tk05_14) == OFF && getageWidth() == ageH && getSchRank(jMajyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_14);
		} else
		if (getSchLastRes(jMajyutu) < 0)
		{
			if (getLabel(LF_tk05_15) == OFF && getageWidth() == ageC && getSchRank(jMajyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_15);
			if (getLabel(LF_tk05_16) == OFF && getageWidth() == ageL && getSchRank(jMajyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_16);
			if (getLabel(LF_tk05_17) == OFF && getageWidth() == ageH && getSchRank(jMajyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_17);
		}
	} else
	if (getSchLast(0) == jZagaku+1)
	{
		if (getLabel(LF_tk05_18) == OFF && getageWidth() == ageC && getSchRank(jZagaku) >= 1)
			setScript(_TK05_PSC, TK05_TK05_18);
		else
		if (getLabel(LF_tk05_19) == OFF && getageWidth() == ageL && getSchRank(jZagaku) >= 1)
			setScript(_TK05_PSC, TK05_TK05_19);
		else
		if (getLabel(LF_tk05_20) == OFF && getageWidth() == ageH && getSchRank(jZagaku) >= 2)
			setScript(_TK05_PSC, TK05_TK05_20);
		else
		if (getSchLastRes(jZagaku) > 0)
		{
			if (getLabel(LF_tk05_21) == OFF && getageWidth() == ageC && getSchRank(jZagaku) == 0)
				setScript(_TK05_PSC, TK05_TK05_21);
			if (getLabel(LF_tk05_22) == OFF && getageWidth() == ageL && getSchRank(jZagaku) == 1)
				setScript(_TK05_PSC, TK05_TK05_22);
			if (getLabel(LF_tk05_23) == OFF && getageWidth() == ageH && getSchRank(jZagaku) == 2)
				setScript(_TK05_PSC, TK05_TK05_23);
		} else
		if (getSchLastRes(jZagaku) < 0)
		{
			if (getLabel(LF_tk05_24) == OFF && getageWidth() == ageC && getSchRank(jZagaku) == 0)
				setScript(_TK05_PSC, TK05_TK05_24);
			if (getLabel(LF_tk05_25) == OFF && getageWidth() == ageL && getSchRank(jZagaku) == 1)
				setScript(_TK05_PSC, TK05_TK05_25);
			if (getLabel(LF_tk05_26) == OFF && getageWidth() == ageH && getSchRank(jZagaku) == 2)
				setScript(_TK05_PSC, TK05_TK05_26);
		}
	} else
	if (getSchLast(0) == jReihou+1)
	{
		if (getLabel(LF_tk05_27) == OFF && getageWidth() == ageC && getSchRank(jReihou) >= 1)
			setScript(_TK05_PSC, TK05_TK05_27);
		else
		if (getLabel(LF_tk05_28) == OFF && getageWidth() == ageL && getSchRank(jReihou) >= 1)
			setScript(_TK05_PSC, TK05_TK05_28);
		else
		if (getLabel(LF_tk05_29) == OFF && getageWidth() == ageH && getSchRank(jReihou) == 2)
			setScript(_TK05_PSC, TK05_TK05_29);
		else
		if (getSchLastRes(jReihou) > 0)
		{
			if (getLabel(LF_tk05_30) == OFF && getageWidth() == ageC && getSchRank(jReihou) == 0)
				setScript(_TK05_PSC, TK05_TK05_30);
			if (getLabel(LF_tk05_31) == OFF && getageWidth() == ageL && getSchRank(jReihou) == 1)
				setScript(_TK05_PSC, TK05_TK05_31);
			if (getLabel(LF_tk05_32) == OFF && getageWidth() == ageH && getSchRank(jReihou) == 2)
				setScript(_TK05_PSC, TK05_TK05_32);
		} else
		if (getSchLastRes(jReihou) < 0)
		{
			if (getLabel(LF_tk05_33) == OFF && getageWidth() == ageC && getSchRank(jReihou) == 0)
				setScript(_TK05_PSC, TK05_TK05_33);
			if (getLabel(LF_tk05_34) == OFF && getageWidth() == ageL && getSchRank(jReihou) == 1)
				setScript(_TK05_PSC, TK05_TK05_34);
			if (getLabel(LF_tk05_35) == OFF && getageWidth() == ageH && getSchRank(jReihou) == 2)
				setScript(_TK05_PSC, TK05_TK05_35);
		}
	} else
	if (getSchLast(0) == jGeijyutu+1)
	{
		if (getLabel(LF_tk05_36) == OFF && getageWidth() == ageC && getSchRank(jGeijyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_36);
		else
		if (getLabel(LF_tk05_37) == OFF && getageWidth() == ageL && getSchRank(jGeijyutu) >= 1)
			setScript(_TK05_PSC, TK05_TK05_37);
		else
		if (getLabel(LF_tk05_38) == OFF && getageWidth() == ageH && getSchRank(jGeijyutu) == 2)
			setScript(_TK05_PSC, TK05_TK05_38);
		else
		if (getSchLastRes(jGeijyutu) > 0)
		{
			if (getLabel(LF_tk05_39) == OFF && getageWidth() == ageC && getSchRank(jGeijyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_39);
			if (getLabel(LF_tk05_40) == OFF && getageWidth() == ageL && getSchRank(jGeijyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_40);
			if (getLabel(LF_tk05_41) == OFF && getageWidth() == ageH && getSchRank(jGeijyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_41);
		} else
		if (getSchLastRes(jGeijyutu) < 0)
		{
			if (getLabel(LF_tk05_42) == OFF && getageWidth() == ageC && getSchRank(jGeijyutu) == 0)
				setScript(_TK05_PSC, TK05_TK05_42);
			if (getLabel(LF_tk05_43) == OFF && getageWidth() == ageL && getSchRank(jGeijyutu) == 1)
				setScript(_TK05_PSC, TK05_TK05_43);
			if (getLabel(LF_tk05_44) == OFF && getageWidth() == ageH && getSchRank(jGeijyutu) == 2)
				setScript(_TK05_PSC, TK05_TK05_44);
		}
	} else
	if (getSchLast(0) == jButou+1)
	{
		if (getLabel(LF_tk05_45) == OFF && getageWidth() == ageC && getSchRank(jButou) >= 1)
			setScript(_TK05_PSC, TK05_TK05_45);
		else
		if (getLabel(LF_tk05_46) == OFF && getageWidth() == ageL && getSchRank(jButou) >= 1)
			setScript(_TK05_PSC, TK05_TK05_46);
		else
		if (getLabel(LF_tk05_47) == OFF && getageWidth() == ageH && getSchRank(jButou) == 2)
			setScript(_TK05_PSC, TK05_TK05_47);
		else
		if (getSchLastRes(jButou) > 0)
		{
			if (getLabel(LF_tk05_48) == OFF && getageWidth() == ageC && getSchRank(jButou) == 0)
				setScript(_TK05_PSC, TK05_TK05_48);
			if (getLabel(LF_tk05_49) == OFF && getageWidth() == ageL && getSchRank(jButou) == 1)
				setScript(_TK05_PSC, TK05_TK05_49);
			if (getLabel(LF_tk05_50) == OFF && getageWidth() == ageH && getSchRank(jButou) == 2)
				setScript(_TK05_PSC, TK05_TK05_50);
		} else
		if (getSchLastRes(jButou) < 0)
		{
			if (getLabel(LF_tk05_51) == OFF && getageWidth() == ageC && getSchRank(jButou) == 0)
				setScript(_TK05_PSC, TK05_TK05_51);
			if (getLabel(LF_tk05_52) == OFF && getageWidth() == ageL && getSchRank(jButou) == 1)
				setScript(_TK05_PSC, TK05_TK05_52);
			if (getLabel(LF_tk05_53) == OFF && getageWidth() == ageH && getSchRank(jButou) == 2)
				setScript(_TK05_PSC, TK05_TK05_53);
		}
	}
	waitScript();
}
//-------------------------------------
// ̘b(tk06)
//-------------------------------------
static void tk06(void)
{
	switch (getDress())
	{
		case 1:		// i
			if (getageWidth() == ageC && getLabel(LF_tk06_0) == OFF)
				setScript(_TK06_PSC, TK06_TK06_0);
			break;
		case 2:		// ĕ
			if (getageWidth() == ageC && getLabel(LF_tk06_1) == OFF && getSeason() == 1)
				setScript(_TK06_PSC, TK06_TK06_1);
			if (getageWidth() == ageL && getLabel(LF_tk06_2) == OFF && getSeason() == 1)
				setScript(_TK06_PSC, TK06_TK06_2);
			if (getageWidth() == ageH && getLabel(LF_tk06_3) == OFF && getSeason() == 1)
				setScript(_TK06_PSC, TK06_TK06_3);
			break;
		case 3:		// ~
			if (getageWidth() == ageC && getLabel(LF_tk06_4) == OFF && getSeason() == 3)
				setScript(_TK06_PSC, TK06_TK06_4);
			if (getageWidth() == ageL && getLabel(LF_tk06_5) == OFF && getSeason() == 3)
				setScript(_TK06_PSC, TK06_TK06_5);
			if (getageWidth() == ageH && getLabel(LF_tk06_6) == OFF && getSeason() == 3)
				setScript(_TK06_PSC, TK06_TK06_6);
			break;
		case 4:		// hX
			if (getageWidth() == ageC && getLabel(LF_tk06_7) == OFF)
				setScript(_TK06_PSC, TK06_TK06_7);
			if (getageWidth() == ageL && getLabel(LF_tk06_8) == OFF)
				setScript(_TK06_PSC, TK06_TK06_8);
			if (getageWidth() == ageH && getLabel(LF_tk06_9) == OFF)
				setScript(_TK06_PSC, TK06_TK06_9);
			break;
		case 5:		// VÑhX
			if (getageWidth() == ageC && getLabel(LF_tk06_10) == OFF)
				setScript(_TK06_PSC, TK06_TK06_10);
			if (getageWidth() == ageL && getLabel(LF_tk06_11) == OFF)
				setScript(_TK06_PSC, TK06_TK06_11);
			if (getageWidth() == ageH && getLabel(LF_tk06_12) == OFF)
				setScript(_TK06_PSC, TK06_TK06_12);
			break;
		case 6:		// ؂ȃhX
			if (getageWidth() == ageC && getLabel(LF_tk06_13) == OFF)
				setScript(_TK06_PSC, TK06_TK06_13);
			if (getageWidth() == ageL && getLabel(LF_tk06_14) == OFF)
				setScript(_TK06_PSC, TK06_TK06_14);
			if (getageWidth() == ageH && getLabel(LF_tk06_15) == OFF)
				setScript(_TK06_PSC, TK06_TK06_15);
			break;
		case 7:		// p
			if (getageWidth() == ageC && getLabel(LF_tk06_19) == OFF)
				setScript(_TK06_PSC, TK06_TK06_19);
			if (getageWidth() == ageL && getLabel(LF_tk06_20) == OFF)
				setScript(_TK06_PSC, TK06_TK06_20);
			if (getageWidth() == ageH && getLabel(LF_tk06_21) == OFF)
				setScript(_TK06_PSC, TK06_TK06_21);
			break;
		case 8:		// pt̐
			if (getageWidth() == ageC && getLabel(LF_tk06_22) == OFF)
				setScript(_TK06_PSC, TK06_TK06_22);
			if (getageWidth() == ageL && getLabel(LF_tk06_23) == OFF)
				setScript(_TK06_PSC, TK06_TK06_23);
			if (getageWidth() == ageH && getLabel(LF_tk06_24) == OFF)
				setScript(_TK06_PSC, TK06_TK06_24);
			break;
		case 11:	// U[X[c
			if (getageWidth() == ageH && getLabel(LF_tk06_31) == OFF)
				setScript(_TK06_PSC, TK06_TK06_31);
			break;
		case 12:	// C
			if (getageWidth() == ageC && getLabel(LF_tk06_32) == OFF)
				setScript(_TK06_PSC, TK06_TK06_32);
			if (getageWidth() == ageL && getLabel(LF_tk06_33) == OFF)
				setScript(_TK06_PSC, TK06_TK06_33);
			if (getageWidth() == ageH && getLabel(LF_tk06_34) == OFF)
				setScript(_TK06_PSC, TK06_TK06_34);
			break;
		case 17:	// X̃[u
			if (getageWidth() == ageH && getLabel(LF_tk06_38) == OFF)
				setScript(_TK06_PSC, TK06_TK06_38);
			break;
		case 18:	// P̃hX
			if (getageWidth() == ageH && getLabel(LF_tk06_40) == OFF)
				setScript(_TK06_PSC, TK06_TK06_40);
			break;
		case 19:	// ̃hX
			if (getageWidth() == ageH && getLabel(LF_tk06_39) == OFF)
				setScript(_TK06_PSC, TK06_TK06_39);
			break;
		default:
			;
	}
	waitScript();
}
//-------------------------------------
// nՁE^bitk07j
//-------------------------------------
static void tk07(void)
{
	if ((getSchCount(jBujyutu) >= getSchCount(jGeijyutu) && getSchCount(jBujyutu) >= getSchCount(jButou)) ||
		(getSchCount(jMajyutu) >= getSchCount(jGeijyutu) && getSchCount(jMajyutu) >= getSchCount(jButou)))
	{
		// n
		if (getageWidth() == ageC)
			setScript(_TK07_PSC, TK07_TK07_0);
		else
		if (getageWidth() == ageL)
			setScript(_TK07_PSC, TK07_TK07_1);
		else
			setScript(_TK07_PSC, TK07_TK07_2);
		waitScript();
	} else
	if (getSchCount(jGeijyutu) >= getSchCount(jBujyutu) && getSchCount(jGeijyutu) >= getSchCount(jMajyutu) && getSchCount(jGeijyutu) >= getSchCount(jButou))
	{
		//|pn
		if (getageWidth() == ageC)
			setScript(_TK07_PSC, TK07_TK07_3);
		else
		if (getageWidth() == ageL)
			setScript(_TK07_PSC, TK07_TK07_4);
		else
			setScript(_TK07_PSC, TK07_TK07_5);
		waitScript();
	} else
	if (getSchCount(jButou) >= getSchCount(jBujyutu) && getSchCount(jButou) >= getSchCount(jMajyutu) && getSchCount(jButou) >= getSchCount(jGeijyutu))
	{
		//_Xn
		if (getageWidth() == ageC)
			setScript(_TK07_PSC, TK07_TK07_6);
		else
		if (getageWidth() == ageL)
			setScript(_TK07_PSC, TK07_TK07_7);
		else
			setScript(_TK07_PSC, TK07_TK07_8);
		waitScript();
	}
}


//-------------------------------------
// A
//-------------------------------------
static void AisatuParamChange(void)
{
	if (getLabel(LF_talkParamChange) == OFF)
	{
		setLabel(LF_talkParamChange, ON);
		setParamUp2(pMORAL, 300, pFA, 100);
	}
	putStartMessage();
	waitScriptMessage();
}

//-------------------------------------
// D
//-------------------------------------
static void YasasikuParamChange(void)
{
	if (getLabel(LF_talkParamChange) == OFF)
	{
		setLabel(LF_talkParamChange, ON);
		setParamUp3(pKANNJYU, 200, pMORAL, -200, pFA, 200);
	}
	putStartMessage();
	waitScriptMessage();
}

//-------------------------------------
// 
//-------------------------------------
static void KibishikuParamChange(void)
{
	if (getLabel(LF_talkParamChange) == OFF)
	{
		setLabel(LF_talkParamChange, ON);
		if (getcon() == conN)
			setParamUp2(pHIROU, 1000, pMORAL, 500);
		else
		if (getcon() == conY)
			setParamUp(pMORAL, 1000);
		else
		if (getcon() == conS)
			setParamUp2(pHIROU, 2000, pFA, -500);
	}
	putStartMessage();
	waitScriptMessage();
}

//-------------------------------------
// ^b`ŏ̃KCh
//-------------------------------------
static void touchGuide(void)
{
	setScript(_ROOM_PSC, ROOM_TOUCHGUIDE);
	waitScript();
	setParamGraph();
}

//-------------------------------------
// ^b`
//-------------------------------------
static void touchMessage(void)
{
	s16 con;

	if (getcon() == conN)
	{
		con = 0;
		if (getLabel(LF_talkParamChange) == OFF)
		{
			setLabel(LF_talkParamChange, ON);
			if (getageWidth() == ageC)
			{
				if (g_decide == 0)
					setParamUp(pKANNJYU, 100);
				else
				if (g_decide == 1)
					setParamUp(pKIDATE, 100);
				else
				if (g_decide == 2)
					setParamUp(pMIRYOKU, 100);
				else
				if (g_decide == 3)
					setParamUp(pPRIDE, 100);
				else
				if (g_decide == 4)
					setParamUp(pKIHINN, 100);
			} else
			if (getageWidth() == ageL)
			{
				if (g_decide == 0)
					setParamUp2(pKANNJYU, 200, pKIHINN, -100);
				else
				if (g_decide == 1)
					setParamUp2(pKIDATE, 200, pKANNJYU, -100);
				else
				if (g_decide == 2)
					setParamUp2(pMIRYOKU, 200, pPRIDE, -100);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 200, pMORAL, -100);
				else
				if (g_decide == 4)
					setParamUp2(pKIHINN, 200, pKIDATE, -100);
			} else {
				if (g_decide == 0)
					setParamUp2(pKANNJYU, 300, pKIHINN, -200);
				else
				if (g_decide == 1)
					setParamUp2(pKIDATE, 300, pKANNJYU, -200);
				else
				if (g_decide == 2)
					setParamUp2(pMIRYOKU, 300, pPRIDE, -200);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 300, pMORAL, -200);
				else
				if (g_decide == 4)
					setParamUp2(pKIHINN, 300, pKIDATE, -200);
			}
		}
	} else
	if (getcon() == conY)
	{
		con = 1;
		if (getLabel(LF_talkParamChange) == OFF)
		{
			setLabel(LF_talkParamChange, ON);
			if (getageWidth() == ageC)
			{
				if (g_decide == 0)
					setParamUp2(pKANNJYU, 100, pMORAL, -100);
				else
				if (g_decide == 1)
					setParamUp2(pKIDATE, 100, pMORAL, -100);
				else
				if (g_decide == 2)
					setParamUp2(pMIRYOKU, 100, pMORAL, -100);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 100, pMORAL, -100);
				else
				if (g_decide == 4)
					setParamUp2(pKIHINN, 100, pMORAL, -100);
			} else
			if (getageWidth() == ageL)
			{
				if (g_decide == 0)
					setParamUp3(pKANNJYU, 200, pKIHINN, -100, pMORAL, -100);
				else
				if (g_decide == 1)
					setParamUp3(pKIDATE, 200, pKANNJYU, -100, pMORAL, -100);
				else
				if (g_decide == 2)
					setParamUp3(pMIRYOKU, 200, pPRIDE, -100, pMORAL, -100);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 200, pMORAL, -200);
				else
				if (g_decide == 4)
					setParamUp3(pKIHINN, 200, pKIDATE, -100, pMORAL, -100);
			} else {
				if (g_decide == 0)
					setParamUp3(pKANNJYU, 300, pKIHINN, -200, pMORAL, -100);
				else
				if (g_decide == 1)
					setParamUp3(pKIDATE, 300, pKANNJYU, -200, pMORAL, -100);
				else
				if (g_decide == 2)
					setParamUp3(pMIRYOKU, 300, pPRIDE, -200, pMORAL, -100);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 300, pMORAL, -300);
				else
				if (g_decide == 4)
					setParamUp3(pKIHINN, 300, pKIDATE, -200, pMORAL, -100);
			}
		}
	} else {
		con = 2;
		if (getLabel(LF_talkParamChange) == OFF)
		{
			setLabel(LF_talkParamChange, ON);
			if (getageWidth() == ageC)
			{
				if (g_decide == 0)
					setParamUp2(pKANNJYU, 100, pHIROU, 100);
				else
				if (g_decide == 1)
					setParamUp2(pKIDATE, 100, pHIROU, 100);
				else
				if (g_decide == 2)
					setParamUp2(pMIRYOKU, 100, pHIROU, 100);
				else
				if (g_decide == 3)
					setParamUp2(pPRIDE, 100, pHIROU, 100);
				else
				if (g_decide == 4)
					setParamUp2(pKIHINN, 100, pHIROU, 100);
			} else
			if (getageWidth() == ageL)
			{
				if (g_decide == 0)
					setParamUp3(pKANNJYU, 200, pKIHINN, -100, pHIROU, 100);
				else
				if (g_decide == 1)
					setParamUp3(pKIDATE, 200, pKANNJYU, -100, pHIROU, 100);
				else
				if (g_decide == 2)
					setParamUp3(pMIRYOKU, 200, pPRIDE, -100, pHIROU, 100);
				else
				if (g_decide == 3)
					setParamUp3(pPRIDE, 200, pMORAL, -200, pHIROU, 100);
				else
				if (g_decide == 4)
					setParamUp3(pKIHINN, 200, pKIDATE, -100, pHIROU, 100);
			} else {
				if (g_decide == 0)
					setParamUp3(pKANNJYU, 300, pKIHINN, -200, pHIROU, 100);
				else
				if (g_decide == 1)
					setParamUp3(pKIDATE, 300, pKANNJYU, -200, pHIROU, 100);
				else
				if (g_decide == 2)
					setParamUp3(pMIRYOKU, 300, pPRIDE, -200, pHIROU, 100);
				else
				if (g_decide == 3)
					setParamUp3(pPRIDE, 300, pMORAL, -200, pHIROU, 1000);
				else
				if (g_decide == 4)
					setParamUp3(pKIHINN, 300, pKIDATE, -200, pHIROU, 100);
			}
		}
	}
	setScript(_ROOM_PSC, g_touch_table[getageWidth()][con][g_decide]);
	waitScript();
}

//-------------------------------------
// ÂQOf
//-------------------------------------
static void oKodukaiParamChange(void)
{
	setAddGold(-50);
	setScript(_TK01_PSC, TK01_TK01_MONEY);
	waitScript();
	if (getcon() == conN)
		setParamUp(pHIROU, -1000);
	else
	if (getcon() == conY)
		setParamUp2(pHIROU, -1000, pMORAL, -500);
	else
	if (getcon() == conS)
		setParamUp(pHIROU, -1000);
	putStartMessage();
	waitScriptMessage();
	waitChangeGold();
}

//-------------------------------------
// Ƃ肠ACeʑ҂NGXg
//-------------------------------------
void setRoomItem(void)
{
	g_step_backup = g_step;
	g_step = ROOM_MODE_ITEM_WAIT;
}

//-------------------------------------
// Ƃ肠ogINGXg
//-------------------------------------
void setRoomBattle(void)
{
	g_step_backup = g_step;
	g_step = ROOM_MODE_BATTLE_MAIN;

	putBattleObj(-1);
	initTouchPenData();
	setTouchPenData(_BATTLE_MENU_TPD);
}

//-------------------------------------
// ROOMɃ[hʂɂ郊NGXg
//-------------------------------------
void setLoadScreen(BOOL in_flag)
{
	g_load_screen = in_flag;
}


//-------------------------------------
// ROOMɃIvVʂɂ郊NGXg
//-------------------------------------
void setOptionScreen(BOOL in_flag)
{
	g_option_screen = in_flag;
}


//-------------------------------------
// ogI҂
//-------------------------------------
s8 waitSelectBattle(void)
{
	while (g_step == ROOM_MODE_BATTLE_MAIN)
		OS_Sleep(10);
	return (s8)g_decide;
}

