//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "graph.h"
#include "prime4.h"
#include "script.h"
#include "event_grp.h"
#include "voice.h"
#include "sound_data.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define SCRIPT_THREAD_STACK_SIZE 2048

#define SCRIPT_TEXT_START_X		8		// eLXg\Jnʒu(20)
#define SCRIPT_TEXT_START_Y		8		// eLXg\Jnʒu

#define SCRIPT_STEP_NONE		0		// ~
#define SCRIPT_STEP_ANALYSIS	1		// 
#define SCRIPT_STEP_MES_WAIT	2		// ͕\҂
#define SCRIPT_STEP_KEY_WAIT	3		// L[EFCg҂
#define SCRIPT_STEP_SEL_WAIT	4		// I҂
#define SCRIPT_STEP_SE_WAIT		5		// SEĐ҂
#define SCRIPT_STEP_BGM_WAIT	6		// BGM~҂
#define SCRIPT_STEP_SPECIAL		7		// ꏈ
#define SCRIPT_STEP_QUAKE_WAIT	8		// ʗh炷
// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_script_start,
	g_script_sync,
	g_script_exec,
	g_voice_play,
	g_window_open,
	g_key_wait_flag;
static u8
	g_step,
	g_message_line,
	g_start_label,
	g_select_label[3],
	*g_script_ptr,
	g_script_end_code,
	g_enemy_name,
	g_enemy_name_buf[32],
	g_text_mode,
	g_special;
static s16
	g_wait,
	g_bgm_req,
	g_text_x,
	g_text_y;
static u16
	g_fade_time;
static u32
	g_script_point;
static u64
	g_scriptThreadStack[SCRIPT_THREAD_STACK_SIZE / sizeof(u64)];
static OSThread
	g_scriptThread;
static void
	*g_script_ptr_base;
static OSMutex
	g_mutex;

static u8
	g_bgm_table[] =
	{
		SEQ_PRM4_00, SEQ_PRM4_01, SEQ_PRM4_02, SEQ_PRM4_03, SEQ_PRM4_04,
		SEQ_PRM4_05, SEQ_PRM4_06, SEQ_PRM4_07, SEQ_PRM4_08, SEQ_PRM4_09,
		SEQ_PRM4_10, SEQ_PRM4_11, SEQ_PRM4_12, SEQ_PRM4_13, SEQ_PRM4_14,
		SEQ_PRM4_15, SEQ_PRM4_16, SEQ_PRM4_17, SEQ_PRM4_18, SEQ_PRM4_19,
		SEQ_PRM4_20, SEQ_PRM4_21, SEQ_PRM4_22, SEQ_PRM4_23, SEQ_PRM4_24,
		SEQ_PRM4_25, SEQ_PRM4_26, SEQ_PRM4_27, SEQ_PRM4_28, SEQ_PRM4_29,
		SEQ_PRM4_30, SEQ_PRM4_31, SEQ_PRM4_32, SEQ_PRM4_33, SEQ_PRM4_34,
		SEQ_PRM4_35, SEQ_PRM4_36, SEQ_PRM4_37, SEQ_PRM4_38,
	},
	g_suuji_table[] = "OPQRSTUVWX";
static u16
	g_se_table[] =
	{
		0,
		_SE01_AHX, _SE02_AHX, _SE03_AHX, _SE04_AHX, _SE05_AHX,
		_SE06_AHX, _SE07_AHX, _SE08_AHX, _SE09_AHX, _SE10_AHX,
		_SE11_AHX, _SE12_AHX, _SE13_AHX, _SE14_AHX, _SE15_AHX,
		_SE16_AHX, _SE17_AHX, _SE18_AHX, _SE19_AHX, _SE20_AHX,
		_SE21_AHX, _SE22_AHX, _SE23_AHX, _SE24_AHX, _SE25_AHX,
		_SE26_AHX, _SE27_AHX, _SE28_AHX, _SE29_AHX, _SE30_AHX,
		_SE31_AHX, _SE32_AHX, _SE33_AHX, _SE34_AHX, _SE35_AHX,
		_SE36_AHX, _SE37_AHX, _SE38_AHX, _SE39_AHX, _SE40_AHX,
		_SE41_AHX, _SE42_AHX, _SE43_AHX, _SE44_AHX, _SE45_AHX,
		_SE46_AHX, _SE47_AHX, _SE48_AHX, _SE49_AHX, _SE50_AHX,
		_SE51_AHX, _SE52_AHX, _SE53_AHX, _SE54_AHX, _SE55_AHX,
		_SE56_AHX, _SE57_AHX, _SE58_AHX, _SE59_AHX, _SE60_AHX,
		_SE61_AHX, _SE62_AHX,
	};

// -------------------------------------
// [J֐`
// -------------------------------------
static void scriptThread(void *);
static void analysisScript(void);
static u8 changeCode(u16 *, int);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  ŏ̏
// -------------------------------------
void initFirstScript(void)
{
	OS_InitMutex(&g_mutex);
	g_script_exec = FALSE;
	g_script_sync = FALSE;
	g_script_ptr_base = NULL;
	g_bgm_req = -1;
	g_window_open = TRUE;
	g_text_mode = 0;
	g_step = SCRIPT_STEP_NONE;
}

// -------------------------------------
//  Xbh
// -------------------------------------
static void scriptThread(void *in_arg)
{
	((void (*)(void))in_arg)();
}

// -------------------------------------
//  XbhŐݒ
// -------------------------------------
void setScriptThread(void (*in_thread)(void))
{
	// Xbh̋N
	if (!OS_IsThreadTerminated(&g_scriptThread))
		OS_KillThread(&g_scriptThread, NULL);
	OS_CreateThread(&g_scriptThread, scriptThread, in_thread, g_scriptThreadStack + SCRIPT_THREAD_STACK_SIZE / sizeof(u64), SCRIPT_THREAD_STACK_SIZE, 18);
	OS_WakeupThreadDirect(&g_scriptThread);
}

// -------------------------------------
//  Xbh쒆H
// -------------------------------------
BOOL isEndScriptThread(void)
{
	return OS_IsThreadTerminated(&g_scriptThread);
}

// -------------------------------------
//  ݒ
// -------------------------------------
void setScript(int in_id, int in_label)
{
	OS_LockMutex(&g_mutex);
	if (g_script_ptr_base)
	{
		freeBDS(g_script_ptr_base);
		g_script_ptr_base = NULL;
	}
	readFile(in_id, &g_script_ptr_base);

	clearMessage();
	g_message_line = 0;
	g_script_ptr = (u8 *)g_script_ptr_base;

	g_voice_play = FALSE;

	g_script_exec = TRUE;
	g_step = SCRIPT_STEP_ANALYSIS;

	g_script_start = TRUE;
	g_start_label = (u8)in_label;
	OS_UnlockMutex(&g_mutex);

	OS_TPrintf("scriptID=%d , labelID=%d\n", in_id, in_label);
}
// -------------------------------------
void setScriptNoInit(int in_id, int in_label)
{
	OS_LockMutex(&g_mutex);
	if (g_script_ptr_base)
	{
		freeBDS(g_script_ptr_base);
		g_script_ptr_base = NULL;
	}
	readFile(in_id, &g_script_ptr_base);

//	clearMessage();
//	g_message_line = 0;
	putStartMessage();
	g_script_ptr = (u8 *)g_script_ptr_base;

	g_voice_play = FALSE;

	g_script_exec = TRUE;
	g_step = SCRIPT_STEP_ANALYSIS;

	g_script_start = TRUE;
	g_start_label = (u8)in_label;
	OS_UnlockMutex(&g_mutex);

	OS_TPrintf("scriptID=%d , labelID=%d\n", in_id, in_label);
}

// -------------------------------------
//  C
// -------------------------------------
void execScript(void)
{
	u16 pad, padr;
	int i;

	pad = getPad();
	padr = getPadRep();
	if (pad & PAD_BUTTON_X)
		setSkipFlag(TRUE);
	else
		setSkipFlag(FALSE);
	if (g_script_exec)
	{
		if (!isFlipBmpBuf())
		{
			switch (g_step)
			{
				case SCRIPT_STEP_ANALYSIS:		// 
					OS_LockMutex(&g_mutex);
					analysisScript();
					OS_UnlockMutex(&g_mutex);
					break;
				case SCRIPT_STEP_MES_WAIT:		// ͕\҂
					if (pad & PAD_BUTTON_X || padr & (PAD_BUTTON_A|PAD_BUTTON_B) || getOnTouchPen())
						putAllMessage();
					if (!isPutMessage())
					{
						if (g_script_ptr_base)
						{
							g_step = SCRIPT_STEP_ANALYSIS;
						} else
						if (g_key_wait_flag)
						{
							putKeyWait();
							g_step = SCRIPT_STEP_KEY_WAIT;
						} else {
							g_script_exec = FALSE;
							g_step = SCRIPT_STEP_NONE;
						}
					}
					break;
				case SCRIPT_STEP_KEY_WAIT:		// L[EFCg҂
					if (g_window_open)
					{
						if (pad & PAD_BUTTON_X || padr & (PAD_BUTTON_A|PAD_BUTTON_B) || getOnTouchPen())
						{
							if (g_voice_play)
							{
								g_voice_play = FALSE;
								if (isPlayAdxM())
									stopAdxM();
							}
							clearKeyWait();
							if (g_text_mode == 0)
							{
								clearMessage();
								g_message_line = 0;
							} else {
								g_text_x = SCRIPT_TEXT_START_X;
								g_text_y += 14;
							}
							if (g_script_ptr_base)
							{
								g_step = SCRIPT_STEP_ANALYSIS;
							} else {
								g_script_exec = FALSE;
								g_step = SCRIPT_STEP_NONE;
							}
						} else
						if (getPadTrg() & PAD_BUTTON_Y && g_text_mode == 0)
						{
							g_window_open = FALSE;
							putAllWindow(FALSE);
						}
					} else {
						if (getPadTrg() & PAD_BUTTON_Y && g_text_mode == 0)
						{
							g_window_open = TRUE;
							putAllWindow(TRUE);
						}
					}
					break;
				case SCRIPT_STEP_SEL_WAIT:		// I҂
					if (g_window_open)
					{
						if (!isSelect())
						{
							clearMessage();
							g_message_line = 0;
							g_script_ptr = (u8 *)g_script_ptr_base;
							g_script_start = TRUE;
							g_start_label = g_select_label[getSelect()];
							g_step = SCRIPT_STEP_ANALYSIS;
						} else
						if (getPadTrg() & PAD_BUTTON_Y)
						{
							g_window_open = FALSE;
							putAllWindow(FALSE);
						}
					} else {
						if (getPadTrg() & PAD_BUTTON_Y)
						{
							g_window_open = TRUE;
							putAllWindow(TRUE);
						}
					}
					break;
				case SCRIPT_STEP_SE_WAIT:		// SEĐ҂
					if (!isPlayAdxM() || pad & PAD_BUTTON_X || padr & (PAD_BUTTON_A|PAD_BUTTON_B) || getOnTouchPen())
						g_step = SCRIPT_STEP_ANALYSIS;
					// XLbvĐ~߂Ȃ火
					//if (!isPlayAdxM() || pad & PAD_BUTTON_X)
					//{
					//	stopAdxM();
					//	g_step = SCRIPT_STEP_ANALYSIS;
					//}
					break;
				case SCRIPT_STEP_BGM_WAIT:		// BGM~҂
					if (g_fade_time == 0 || pad & PAD_BUTTON_X || padr & (PAD_BUTTON_A|PAD_BUTTON_B))
						g_step = SCRIPT_STEP_ANALYSIS;
					else
						g_fade_time--;
					break;
				case SCRIPT_STEP_SPECIAL:		// ꏈ
					if (!isChangeSubGraph())
					{
						g_step = SCRIPT_STEP_ANALYSIS;
						switch (g_special)
						{
							case 0:
								setMenuGraph();
								break;
							case 1:
								setMenuObj(2);
								break;
							case 2:
								setHealthGraph();
								break;
							case 3:
								setHealthObj(2);
								break;
							case 4:
								setHealthObj(4);
								break;
							case 5:
								setHealthObj(3);
								break;
							case 6:
								setMenuObj(0);
								break;
							case 7:
								for (i=0; i<21; i++)
									setScheduleTip(i, getSchSet(i));
								setScheduleTip(22, getSchSet(22));
								setScheduleTip(23, 0);
								setScheduleTip(jBakansu, 1);
								setScheduleGraph(0);
								break;
							case 8:
								putScheduleObj(0, 4);
								putScheduleGold(0, (u8)(getScheduleNum(0)+1));
								break;
							case 9:
								initScheduleObj(2);
								putScheduleObj(2, 4);
								putScheduleGold(0, (u8)(getScheduleNum(0)+1));
								break;
							case 10:
								setParamGraph();
								break;
							case 11:
								setHealthObj(1);
								break;
							case 12:
								initScheduleObj(1);
								putScheduleObj(1, 4);
								putScheduleGold(0, (u8)(getScheduleNum(0)+1));
								break;
							case 13:
								setMenuObj(4);
								break;
							case 14:
								setTalkGraph();
								break;
							case 15:
								setMenuObj(1);
								break;
							case 16:
								setageWidth(ageL);
								break;
							case 17:
								setageWidth(ageH);
								break;
							case 18:
								setDress(9);
								break;
							case 19:
								setDress(1);
								break;
							case 20:
								setQuake();
								g_step = SCRIPT_STEP_QUAKE_WAIT;
								break;
							case 21:
								setDress(10);
								break;
							case 22:
								setDress(16);
								break;
							default:
								;
						}
					}
					break;
				case SCRIPT_STEP_QUAKE_WAIT:		// ʗh҂
					if (pad & PAD_BUTTON_X || padr & (PAD_BUTTON_A|PAD_BUTTON_B) || !isQuake())
					{
						stopQuake();
						g_step = SCRIPT_STEP_ANALYSIS;
					}
					break;
				case SCRIPT_STEP_NONE:			// ~
				default:
					;
			}
		}
	}
	OS_LockMutex(&g_mutex);
	g_script_sync = FALSE;
	OS_UnlockMutex(&g_mutex);
	if (g_bgm_req != -1)
	{
		setBGM(g_bgm_req);
		playBGM();
		g_bgm_req = -1;
	}
}


// -------------------------------------
//  C
// -------------------------------------
static void analysisScript(void)
{
	BOOL result, label_jump;
	u8 label_num, i, n, next_check;

	result = TRUE;
	label_jump = FALSE;
	next_check = 0;
	if (g_script_start)
	{
		label_num = g_start_label;
		label_jump = TRUE;
		g_script_start = FALSE;
	}
	setChangeLock(TRUE);
	while (result)
	{
		switch (*g_script_ptr)
		{
			case SCRIPT_COMMAND_LABEL:			// x([Ĵ) byte:xԍ
				if (label_jump)
				{
					if (*(g_script_ptr+1) == label_num)
						label_jump = FALSE;
				}
				g_script_ptr += 2;		// X[
				break;
			case SCRIPT_COMMAND_GOTO:			// xWv byte:xԍ
				if (!label_jump)
				{
					label_num = *(g_script_ptr+1);
					label_jump = TRUE;
					g_script_ptr = (u8 *)g_script_ptr_base;
				} else
					g_script_ptr += 2;		// X[
				break;
			case SCRIPT_COMMAND_FLAG:			// tOZbg word:tOԍ byte:ON/OFF
				if (!label_jump)
				{
					u16 num;
					BOOL flag;
					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					if (*(g_script_ptr+3) != 0)
						flag = TRUE;
					else
						flag = FALSE;
					setLabel(num, flag);
				}
				g_script_ptr += 4;
				break;
			case SCRIPT_COMMAND_BG:				// BGύX word:BGԍ
				if (!label_jump)
				{
					u16 num;

					if (next_check != 0 && next_check != 4)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					setBgNum(num);
					next_check = 1;
				}
				g_script_ptr += 3;
				break;
			case SCRIPT_COMMAND_BG2:			// BGύX word:BGԍ
				if (!label_jump)
				{
					u16 num;

					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					setBgNum2(num);
					result = FALSE;
				}
				g_script_ptr += 3;
				break;
			case SCRIPT_COMMAND_CHAR:			// CHAύX byte:ʒu word:CHAԍ
				if (!label_jump)
				{
					u16 num;

					if (next_check != 0 && next_check != 1)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+2, 2);
					setChaNum(*(g_script_ptr+1), num);
					next_check = 4;
				}
				g_script_ptr += 4;
				break;
			case SCRIPT_COMMAND_OFF_CHAR:		// CHA
				if (!label_jump)
				{
					if (next_check != 0 && next_check != 2)
					{
						result = FALSE;
						break;
					}
					clearCha(*(g_script_ptr+1));
					next_check = 2;
				}
				g_script_ptr += 2;
				break;
			case SCRIPT_COMMAND_FACE:			// FACEύX word:FACEԍ
				if (!label_jump)
				{
					u8 nc;
					u16 num;

					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					if (num != 0xffff)
						nc = 1;
					else
						nc = 2;
					if (next_check != 0 && next_check != nc && !(nc == 1 && next_check == 4))
					{
						result = FALSE;
						break;
					}
					setFace(num);
					next_check = nc;
				}
				g_script_ptr += 3;
				break;
			case SCRIPT_COMMAND_VOICE:			// {CXĐ dword:{CXԍ
				if (!label_jump)
				{
					u16 num;

					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					playVoice(num);
					g_voice_play = TRUE;
				}
				g_script_ptr += 3;
				break;
			case SCRIPT_COMMAND_TEXT_MODE:		// eLXg̕\XCb` byte:0/EBhE 1/S
				if (!label_jump)
				{
					g_text_mode = *(g_script_ptr+1);
					// eLXg̏ʒu
					g_text_x = SCRIPT_TEXT_START_X;
					g_text_y = SCRIPT_TEXT_START_Y;
				}
				g_script_ptr += 2;
				break;
			case SCRIPT_COMMAND_MESSAGE_NAME:	// FACE̖O̐ݒ byte: str:O
				n = *(g_script_ptr+1);
				if (!label_jump)
				{
					char code[6*2];
					u8 len;

					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)code, (s8 *)(g_script_ptr+2), (u32)(*(g_script_ptr+1)*2));
					len = changeCode((u16 *)code, *(g_script_ptr+1));
					setFaceNameCode(len*2, (char *)code);
					result = FALSE;
				}
				g_script_ptr += (n*2)+2;
				break;
			case SCRIPT_COMMAND_MESSAGE:		// bZ[W\ byte: str:
				if (!label_jump)
				{
					char code[20*2];
					u8 len;

					if (next_check != 0 && next_check != 3)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)code, (s8 *)(g_script_ptr+2), (u32)(*(g_script_ptr+1)*2));
					len = changeCode((u16 *)code, *(g_script_ptr+1));
					if (g_text_mode == 0)
					{
						// EBhE\
						setMessageCode(g_message_line, len*2, (char *)code);
						g_step = SCRIPT_STEP_MES_WAIT;
					} else {
						// Sʕ\
						setCodeToBmpPtrPos(getBmpBuf(), (u8 *)code, len*2, 0, SCRIPT_TEXT_START_X, g_text_y);
						g_text_x = (s16)(SCRIPT_TEXT_START_X + len * 12);
					}
					next_check = 3;
				}
				n = *(g_script_ptr+1);
				g_script_ptr += (n*2) + 2;
				break;
			case SCRIPT_COMMAND_LINE_FEED:		// s
				if (!label_jump)
				{
					if (next_check != 0 && next_check != 3)
					{
						result = FALSE;
						break;
					}
					if (g_text_mode == 0)
					{
						// EBhE\
						g_message_line++;
						if (g_message_line > 2)
							g_message_line = 0;
					} else {
						// Sʕ\
						g_text_x = SCRIPT_TEXT_START_X;
						g_text_y += 14;
					}
					next_check = 3;
				}
				g_script_ptr += 1;
				break;
			case SCRIPT_COMMAND_KEY_WAIT:		// L[EFCg
				if (!label_jump)
				{
					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					if (g_text_mode == 0)
						setKeyWaitPos(-1, -1);
					else
						setKeyWaitPos(g_text_x-4, g_text_y-3);
					//if (!(getPad() & PAD_BUTTON_X))
					//{
						putKeyWait();
						g_step = SCRIPT_STEP_KEY_WAIT;
					//} else {
					//	clearMessage();
					//	g_message_line = 0;
					//}
					result = FALSE;
				}
				g_script_ptr += 1;
				break;
			case SCRIPT_COMMAND_MESSAGE_WINDOW:	// bZ[WEBhEON/OFF byte:ON/OFF
				if (!label_jump)
				{
					u8 nc;
					BOOL put;
					if (*(g_script_ptr+1) == 1)
					{
						nc = 1;
						put = TRUE;
					} else {
						nc = 2;
						put = FALSE;
					}
					if (next_check != 0 && next_check != nc)
					{
						result = FALSE;
						break;
					}
					if (g_text_mode == 0)
						putMessageWindow(put);
					else
					if (!put)
					{
						updateGraph();
						g_text_x = SCRIPT_TEXT_START_X;
						g_text_y = SCRIPT_TEXT_START_Y;
					}
					next_check = nc;
				}
				g_script_ptr += 2;
				break;
			case SCRIPT_COMMAND_DATE_WINDOW:	// tEBhEON/OFF byte:ON/OFF
				if (!label_jump)
				{
				}
				g_script_ptr += 2;
				break;
			case SCRIPT_COMMAND_OFF_FACE_WINDOW:	// FACEEBhEOFF
				if (!label_jump)
				{
					if (next_check != 0 && next_check != 2)
					{
						result = FALSE;
						break;
					}
					clearFaceName();
					putFaceWindow(FALSE);
					next_check = 2;
				}
				g_script_ptr += 1;
				break;
			case SCRIPT_COMMAND_SELECT:			// I̕\
				if (!label_jump)
				{
					char code[12*2];
					u8 len;

					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					initSelect();
					n = 2;
					for (i=0; i<*(g_script_ptr+1); i++)
					{
						g_select_label[i] = *(g_script_ptr+n);
						memcpyBDS((s8 *)code, (s8 *)(g_script_ptr+n+2), (u32)(*(g_script_ptr+n+1)*2));
						len = changeCode((u16 *)code, *(g_script_ptr+n+1));
						setSelectCode(i, len*2, (char *)code);
						n += (u8)((*(g_script_ptr+n+1) * 2) + 2);
					}
					putStartSelect();
					g_step = SCRIPT_STEP_SEL_WAIT;
					result = FALSE;
				}
				n = 2;
				for (i=0; i<*(g_script_ptr+1); i++)
				{
					n++;
					n += (u8)((*(g_script_ptr+n) * 2) + 1);
				}
				g_script_ptr += n;
				break;

			case SCRIPT_COMMAND_SE_PLAY:			// 
				if (!label_jump)
				{
					if (getOptionSFX() != 0)
						playAdxM(g_se_table[*(g_script_ptr+1)]);
				}
				g_script_ptr += 2;
				break;

			case SCRIPT_COMMAND_SE_WAIT:			// 
				if (!label_jump)
				{
					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					g_step = SCRIPT_STEP_SE_WAIT;
					result = FALSE;
				}
				g_script_ptr += 1;
				break;

			case SCRIPT_COMMAND_SE_STOP:			// 
				if (!label_jump)
				{
					stopAdxM();
				}
				g_script_ptr += 1;
				break;

			case SCRIPT_COMMAND_BGM_PLAY:		// 
				if (!label_jump)
				{
					int n;
					n = g_bgm_table[*(g_script_ptr+1)];
					setBGM(n);
					playBGM();
				}
				g_script_ptr += 2;
				break;

			case SCRIPT_COMMAND_ROOM_BGM_PLAY:		// 
				if (!label_jump)
					playRoomBGM();
				g_script_ptr += 1;
				break;

			case SCRIPT_COMMAND_BGM_STOP:		// 
				if (!label_jump)
				{
					u16 num;

					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					memcpyBDS((s8 *)&num, (s8 *)g_script_ptr+1, 2);
					fadeBGM(num);
					if (num > 0)
					{
						g_fade_time = num;
						g_step = SCRIPT_STEP_BGM_WAIT;
						result = FALSE;
					}
				}
				g_script_ptr += 3;
				break;

			case SCRIPT_COMMAND_SPECIAL:		// 
				if (!label_jump)
				{
					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					g_special = *(g_script_ptr+1);
					g_step = SCRIPT_STEP_SPECIAL;
					result = FALSE;
				}
				g_script_ptr += 2;
				break;

			case SCRIPT_COMMAND_QUAKE:			// 
				if (!label_jump)
				{
					if (next_check != 0)
					{
						result = FALSE;
						break;
					}
					setQuake();
					g_step = SCRIPT_STEP_QUAKE_WAIT;
					result = FALSE;
				}
				g_script_ptr += 1;
				break;

			case SCRIPT_COMMAND_GOLD:			// 
				if (!label_jump)
				{
				}
				break;
			case SCRIPT_COMMAND_PARAM:			// 
				if (!label_jump)
				{
				}
				break;

			case SCRIPT_COMMAND_END:
				if (!label_jump)
				{
					//clearMessage();
					g_script_end_code = *(g_script_ptr+1);
					if (g_script_ptr_base)
					{
						freeBDS(g_script_ptr_base);
						g_script_ptr_base = NULL;
					}
					g_script_exec = FALSE;
					g_step = SCRIPT_STEP_NONE;
					result = FALSE;
				} else
					g_script_ptr += 2;
				break;
			default:
				;
		}
	}
	if (next_check == 3)
	{
		if (g_step == SCRIPT_STEP_MES_WAIT)
			putStartMessage();
		if (g_text_mode != 0)
		{
			if (getPad() & PAD_BUTTON_X)
				flipBmpBuf(0);
			else
			if (getOptionMessage() == 0)
				flipBmpBuf(10);
			else
				flipBmpBuf(30);
		}
	}
	setChangeLock(FALSE);
}

// -------------------------------------
//  XNvgI`FbN
// -------------------------------------
BOOL isEndScript(void)
{
	return !g_script_exec;
}
// -------------------------------------
void waitScript(void)
{
	BOOL result;

	OS_LockMutex(&g_mutex);
	result = g_script_exec;
	OS_UnlockMutex(&g_mutex);
	while (result)
	{
		OS_LockMutex(&g_mutex);
		g_script_sync = TRUE;
		OS_UnlockMutex(&g_mutex);
///		OS_WaitVBlankIntr();
		OS_Sleep(10);
		OS_LockMutex(&g_mutex);
		if (!g_script_exec && !g_script_sync && !isFlipBmpBuf())
			result = FALSE;
		OS_UnlockMutex(&g_mutex);
	}
}
// -------------------------------------
void waitScriptMessage(void)
{
	BOOL result;

	OS_LockMutex(&g_mutex);
	g_step = SCRIPT_STEP_MES_WAIT;
	g_key_wait_flag = TRUE;
	g_script_exec = TRUE;
	result = g_script_exec;
	OS_UnlockMutex(&g_mutex);
	while (result)
	{
		OS_LockMutex(&g_mutex);
		g_script_sync = TRUE;
		OS_UnlockMutex(&g_mutex);
///		OS_WaitVBlankIntr();
		OS_Sleep(10);
		OS_LockMutex(&g_mutex);
		if (!g_script_exec && !g_script_sync && !isFlipBmpBuf())
			result = FALSE;
		OS_UnlockMutex(&g_mutex);
	}
}
// -------------------------------------
void waitScriptMessageNoKeyWait(void)
{
	BOOL result;

	OS_LockMutex(&g_mutex);
	g_step = SCRIPT_STEP_MES_WAIT;
	g_key_wait_flag = FALSE;
	g_script_exec = TRUE;
	result = g_script_exec;
	OS_UnlockMutex(&g_mutex);
	while (result)
	{
		OS_LockMutex(&g_mutex);
		g_script_sync = TRUE;
		OS_UnlockMutex(&g_mutex);
///		OS_WaitVBlankIntr();
		OS_Sleep(10);
		OS_LockMutex(&g_mutex);
		if (!g_script_exec && !g_script_sync && !isFlipBmpBuf())
			result = FALSE;
		OS_UnlockMutex(&g_mutex);
	}
}

// -------------------------------------
//  O̕ϊs
// -------------------------------------
static u8 changeCode(u16 *in_code, int in_num)
{
	u32 pt;
	BOOL put;
	int i, len, n, max;
	u16 str[16];
	u8 *ptr;

	len = 0;
	for (i=0; i<in_num; i++)
	{
		if (in_code[i] == 0xffff)
		{
			// ̖O
			ptr = getName(0);
			max = 6;
		} else
		if (in_code[i] == 0xfffe)
		{
			// ̖
			ptr = getName(1);
			max = 6;
		} else
		if (in_code[i] == 0xfffd)
		{
			// ėp
			if (g_enemy_name == 0)
			{
				if (getLabel(LF_ev033) == ON)
				{
					strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"Pl");
					max = 2;
				} else {
					strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)getName(0));
					strcatBDS((s8 *)g_enemy_name_buf, (s8 *)"");
					max = 9;
				}
			} else
			if (g_enemy_name == 1)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)getName(0));
				strcatBDS((s8 *)g_enemy_name_buf, (s8 *)"E");
				strcatBDS((s8 *)g_enemy_name_buf, (s8 *)getName(1));
				max = 13;
			} else
			if (g_enemy_name == 2)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"[[Ego[Y");
				max = 9;
			} else
			if (g_enemy_name == 3)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"NX`[iEInEm[U[");
				max = 16;
			} else
			if (g_enemy_name == 4)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"}[EXg[}");
				max = 10;
			} else
			if (g_enemy_name == 5)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"JE}[W");
				max = 8;
			} else
			if (g_enemy_name == 6)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"NAEnE[");
				max = 8;
			} else
			if (g_enemy_name == 7)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"WFE[}Z");
				max = 10;
			} else
			if (g_enemy_name == 8)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"VFiEXeLAX");
				max = 10;
			} else
			if (g_enemy_name == 9)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"}[KbgE~[iEn~g");
				max = 16;
			} else
			if (g_enemy_name == 12)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"[[");
				max = 3;
			} else
			if (g_enemy_name == 13)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"NX`[i");
				max = 6;
			} else
			if (g_enemy_name == 14)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"}[");
				max = 3;
			} else
			if (g_enemy_name == 15)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"J");
				max = 3;
			} else
			if (g_enemy_name == 16)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"NA");
				max = 3;
			} else
			if (g_enemy_name == 17)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"WF");
				max = 4;
			} else
			if (g_enemy_name == 18)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"VFi");
				max = 4;
			} else
			if (g_enemy_name == 19)
			{
				strcpyBDS((s8 *)g_enemy_name_buf, (s8 *)"}[Kbg");
				max = 6;
			}
			ptr = &g_enemy_name_buf[0];
		} else
		if (in_code[i] == 0xfffc)
		{
			// ėpl
			pt = 100000;
			put = FALSE;
			max = 0;
			while (pt > 0)
			{
				if ((g_script_point / pt) % 10 != 0 || pt == 1)
					put = TRUE;
				if (put)
				{
					memcpyBDS((s8 *)&g_enemy_name_buf[max*2], (s8 *)&g_suuji_table[((g_script_point / pt) % 10) * 2], 2);
					max++;
				}
				pt /= 10;
			}
			ptr = &g_enemy_name_buf[0];
		} else
			ptr = NULL;
		if (ptr)
		{
			n = max;
			while (*ptr != 0 && n > 0)
			{
				str[len] = (u16)getFontCode(&ptr);
				len++;
				n--;
			}
		} else {
			str[len] = in_code[i];
			len++;
		}
	}
	memcpyBDS((s8 *)in_code, (s8 *)&str[0], (u32)(len*2));
	return (u8)len;
}

// -------------------------------------
//	IR[h
// -------------------------------------
u8 getScriptEndCode(void)
{
	return g_script_end_code;
}
// -------------------------------------
//	EnemyNameݒ
// -------------------------------------
void setEnemyName(u8 in_num)
{
	g_enemy_name = in_num;
}
// -------------------------------------
//	lݒ
// -------------------------------------
void setScriptPoint(u32 in_num)
{
	g_script_point = in_num;
}

// -------------------------------------
//	̂afl
// -------------------------------------
void playRoomBGM(void)
{
	if (getGameY() != 7)
	{
		switch (getSeason())
		{
			case 0:
				setBGM(SEQ_PRM4_04);
				break;
			case 1:
				setBGM(SEQ_PRM4_05);
				break;
			case 2:
				setBGM(SEQ_PRM4_06);
				break;
			case 3:
				setBGM(SEQ_PRM4_07);
				break;
		}
	} else {
		switch (getSeason())
		{
			case 0:
				setBGM(SEQ_PRM4_08);
				break;
			case 1:
				setBGM(SEQ_PRM4_09);
				break;
			case 2:
				setBGM(SEQ_PRM4_10);
				break;
			case 3:
				setBGM(SEQ_PRM4_11);
				break;
		}
	}
	playBGM();
}

// -------------------------------------
//	
// -------------------------------------
void setTextMode(u8 in_mode)
{
	g_text_mode = in_mode;
	g_text_x = SCRIPT_TEXT_START_X;
	g_text_y = SCRIPT_TEXT_START_Y;
}
