//---------------------------------------------------------------------------
//
//	eXg[h
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "test.h"
#include "graph.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define TEST_MODE_INIT				0
#define TEST_MODE_WAIT_1			1
#define TEST_MODE_WAIT_2			2
#define TEST_MODE_MAIN				3

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	g_date_put,
	g_char_put;
static u8
	g_step,
	g_count,
	g_ev_count,
	g_key_count,
	g_key_wait;
static s16
	g_wait;
static void
	*g_bg_buf,
	*g_char_buf,
	*g_date_buf,
	*g_year_buf,
	*g_month_buf,
	*g_day_buf,
	*g_week_buf;


static OamData
	g_white_wall_oam[] =
	{
		{    0,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
	},
	g_black_wall_oam[] =
	{
		{    0,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
	},
	g_push_start_oam[] =
	{
		{  128,0,0,0,0,1,  64,0,0,0,3,  64,0, 0,0 },
		{  128,0,0,0,0,1, 128,0,0,0,3,  96,0, 0,0 },
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void initTestScreen(void);
static void waitTestMode1(void);
static void waitTestMode2(void);
static void mainTestMode(void);
static void transDate(void);
static void transChar(void);
static void transEv(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initTest(void)
{
	g_step = TEST_MODE_INIT;
}

// -------------------------------------
//  C
// -------------------------------------
void execTest(void)
{
	switch (g_step)
	{
		case TEST_MODE_INIT:
			initTestScreen();
			break;
		case TEST_MODE_WAIT_1:
			waitTestMode1();
			break;
		case TEST_MODE_WAIT_2:
			waitTestMode2();
			break;
		case TEST_MODE_MAIN:
			mainTestMode();
			break;
		default:
			;
	}
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initTestScreen(void)
{
//	void *ptr;
//	u32 size;

	putLCDC(0, 0);
	setMainLCDC(LCDC_UP);		// Cɂ
	setVRAMBank(VRAM_SIZE_256, VRAM_SIZE_64, VRAM_SIZE_128, VRAM_SIZE_128);
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	// 
	createBmpBuf();		// _uobt@ł

//	memsetBDS(getBmpBuf(), 0xff, BITMAP_SCREEN_SIZE);
	flipBmpBuf(0);
	readFile(_BGR000_CGB, &g_bg_buf);
//	readFile(_CHAR00_CGBA, &g_char_buf);
	readFile(_W_DATE_CGBA, &g_date_buf);
	readFile(_WEEK_PARTS_CGBA, &g_week_buf);
	readFile(_YEAR_PARTS_CGBA, &g_year_buf);
	readFile(_MONTH_PARTS_CGBA, &g_month_buf);
	readFile(_DAY_PARTS_CGBA, &g_day_buf);
//	readBmpPtrToBmpBuf(g_bg_buf, getBmpBuf());
	flipBmpBuf(60);

//	readFileToVRAM(_WHITE_OBJ_CG, VRAM_MAIN_OBJ_CG, 0);
//	setObjData(MAIN_OBJ, (void *)g_white_wall_oam, 12);

	// 
	setFadeFrom(FADE_SUB_BG, FADE_WHITE, FADE_NORMAL, 60);

	setBgMode(PLANE_SUB_BG2, VRAM_BG_CHARBASE_0x0c000, VRAM_BG_SCRBASE_0x0800, BG_SCRSIZE_256x256, COLOR_MODE_16);
	setBgMode(PLANE_SUB_BG3, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);

	readFileToVRAM(_ENTRY1_CG, VRAM_SUB_BG3_CG, 0);
	readFileToVRAM(_ENTRY1_MAP, VRAM_SUB_BG3_SCR, 0);
	readFileToVRAM(_W_CMD_CG, VRAM_SUB_BG2_CG, 0);
	readFileToVRAM(_W_CMD_MAP, VRAM_SUB_BG2_SCR, 0);
	readFileToVRAM(_W_CMD_PAL, VRAM_SUB_BG_PAL, 0);

	setVisible(/*PLANE_SUB_BG2|*/PLANE_SUB_BG3, 1);

	putLCDC(1, 1);

	g_step = TEST_MODE_WAIT_1;

	g_date_put = FALSE;
	g_char_put = TRUE;

	playAdxMstream("rom:/bgm_edm.ahx");
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitTestMode1(void)
{
	if (!isFlipBmpBuf())
	{
//		readAlphaPtrToBmpBuf(g_char_buf, getBmpBuf());
		if (g_date_put)
			transDate();
		flipBmpBuf(60);
		g_step = TEST_MODE_WAIT_2;
	}
	execBmpBuf();
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitTestMode2(void)
{
#if 0
	g_wait--;
	if (g_wait == 0)
	{
		g_wait = 2;
		g_count--;
		setAlpha(PLANE_MAIN_BG2, PLANE_MAIN_BG3, g_count);
//		setAlpha(PLANE_MAIN_OBJ, PLANE_MAIN_BG3, g_count);
//		readBmpPtrToBmpBufFade(g_bmp_ptr, g_bmp_size, g_bmp_buf, g_count);
//		transToVRAM(VRAM_MAIN_BG3_SCR, g_bmp_buf, BITMAP_SCREEN_SIZE, 0);
		if (g_count == 0)
		{
			freeBDS(g_bmp_ptr);
			freeBDS(g_bmp_buf);
			setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
			setVisible(PLANE_MAIN_BG2, 0);
			g_step = TEST_MODE_MAIN;
			g_count = 0;
			g_ev_count = 0;
		}
	}
#endif
	if (!isFlipBmpBuf())
	{
		readAlphaPtrToBmpPtr(g_char_buf, getBmpBuf());
		flipBmpBuf(60);
		freeBDS(g_char_buf);
		g_step = TEST_MODE_MAIN;
	}
	execBmpBuf();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainTestMode(void)
{
	u16 pad;

	if (!isFlipBmpBuf())
	{
		pad = getPad();
		if (pad & PAD_KEY_LEFT)
		{
			if (g_count == 0)
				g_count = 14;
			else
				g_count--;
			transChar();
		} else
		if (pad & PAD_KEY_RIGHT)
		{
			if (g_count == 14)
				g_count = 0;
			else
				g_count++;
			transChar();
		} else
		if (pad & PAD_KEY_UP)
		{
			if (g_ev_count == 0)
				g_ev_count = 56;
			else
				g_ev_count--;
			transEv();
		} else
		if (pad & PAD_KEY_DOWN)
		{
			if (g_ev_count == 56)
				g_ev_count = 0;
			else
				g_ev_count++;
			transEv();
		} else
		if (pad & PAD_BUTTON_R && !g_date_put)
		{
			g_date_put = TRUE;
			transDate();
			flipBmpBuf(10);
		} else
		if (pad & PAD_BUTTON_L && g_date_put)
		{
			g_date_put = FALSE;
			if (g_char_put)
				transChar();
			else
				transEv();
		} else
		if (pad & PAD_BUTTON_A)
		{
			setVisible(PLANE_SUB_BG2, 1);
		} else
		if (pad & PAD_BUTTON_B)
		{
			setVisible(PLANE_SUB_BG2, 0);
		}
	}
	execBmpBuf();
}



// -------------------------------------
//  ʕ\
// -------------------------------------
static void transDate(void)
{
	readAlphaPtrToBmpPtr(g_date_buf, getBmpBuf());
	readAlphaPtrAreaToBmpPtrPos(g_week_buf, 3*24, 0, 24, 16, getBmpBuf(), 13, 17);
	readAlphaPtrAreaToBmpPtrPos(g_month_buf, 11*16, 0, 16, 16, getBmpBuf(), 32, 16);
	readAlphaPtrAreaToBmpPtrPos(g_day_buf, 1*16, 0, 16, 24, getBmpBuf(), 52, 10);
	readAlphaPtrAreaToBmpPtrPos(g_day_buf, 9*16, 0, 16, 24, getBmpBuf(), 64, 10);
	readAlphaPtrAreaToBmpPtrPos(g_year_buf, 1*8, 0, 8, 16, getBmpBuf(), 20, 6);
	readAlphaPtrAreaToBmpPtrPos(g_year_buf, 4*8, 0, 8, 16, getBmpBuf(), 27, 6);
	readAlphaPtrAreaToBmpPtrPos(g_year_buf, 9*8, 0, 8, 16, getBmpBuf(), 34, 6);
	readAlphaPtrAreaToBmpPtrPos(g_year_buf, 2*8, 0, 8, 16, getBmpBuf(), 41, 6);
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void transChar(void)
{
#if 0
	void *ptr;
	int id[15] = 
	{
		_CHAR00_CGBA,
		_CHAR01_CGBA,
		_CHAR02_CGBA,
		_CHAR03_CGBA,
		_CHAR04_CGBA,
		_CHAR05_CGBA,
		_CHAR06_CGBA,
		_CHAR07_CGBA,
		_CHAR08_CGBA,
		_CHAR09_CGBA,
		_CHAR10_CGBA,
		_CHAR11_CGBA,
		_CHAR12_CGBA,
		_CHAR13_CGBA,
		_CHAR14_CGBA,
	};

	readFile(id[g_count], &ptr);
	mergeBmpAlphaPtrToBmpBuf(g_bg_buf, ptr, getBmpBuf());
	if (g_date_put)
		transDate();
	flipBmpBuf(30);
	freeBDS(ptr);
	g_char_put = TRUE;
#endif
}


// -------------------------------------
//  ʕ\
// -------------------------------------
static void transEv(void)
{
#if 0
	int id[57] = 
	{
		_EV01_CGB,
		_EV02_CGB,
		_EV03_CGB,
		_EV04_CGB,
		_EV05_CGB,
		_EV06_CGB,
		_EV07_CGB,
		_EV08_CGB,
		_EV09_CGB,
		_EV10_CGB,
		_EV11_CGB,
		_EV12_CGB,
		_EV13_CGB,
		_EV14_CGB,
		_EV14A_CGB,
		_EV15_CGB,
		_EV16_CGB,
		_EV17_CGB,
		_EV18_CGB,
		_EV19_CGB,
		_EV20_CGB,
		_EV21A_CGB,
		_EV21B_CGB,
		_EV21C_CGB,
		_EV21D_CGB,
		_EV21E_CGB,
		_EV21F_CGB,
		_EV22_CGB,
		_EV23_CGB,
		_EV24_CGB,
		_EV25_CGB,
		_EV26_CGB,
		_EV27_CGB,
		_EV28_CGB,
		_EV29_CGB,
		_EV30_CGB,
		_EV31_CGB,
		_EV32_CGB,
		_EV33_CGB,
		_EV34A_CGB,
		_EV34B_CGB,
		_EV34C_CGB,
		_EV34D_CGB,
		_EV35_CGB,
		_EV36_CGB,
		_EV37_CGB,
		_EV38_CGB,
		_EV39_CGB,
		_EV40_CGB,
		_EV41_CGB,
		_EV42_CGB,
		_EV43_CGB,
		_EV44A_CGB,
		_EV44B_CGB,
		_EV44C_CGB,
		_EV45_CGB,
		_EV46_CGB,
	};

	readBmpFileToBmpBuf(id[g_ev_count], getBmpBuf());
	if (g_date_put)
		transDate();
	flipBmpBuf(60);
	g_char_put = FALSE;
#endif
}
